var pveapi = [
   {
      "children" : [
         {
            "text" : "firewall",
            "leaf" : 0,
            "path" : "/cluster/firewall",
            "info" : {
               "GET" : {
                  "description" : "Directory index.",
                  "method" : "GET",
                  "permissions" : {
                     "user" : "all"
                  },
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "name" : "index",
                  "returns" : {
                     "type" : "array",
                     "items" : {
                        "type" : "object",
                        "properties" : {}
                     },
                     "links" : [
                        {
                           "rel" : "child",
                           "href" : "{name}"
                        }
                     ]
                  }
               }
            },
            "children" : [
               {
                  "text" : "groups",
                  "leaf" : 0,
                  "path" : "/cluster/firewall/groups",
                  "info" : {
                     "GET" : {
                        "description" : "List security groups.",
                        "method" : "GET",
                        "permissions" : {
                           "user" : "all"
                        },
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "name" : "list_security_groups",
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "digest" : {
                                    "type" : "string",
                                    "maxLength" : 40,
                                    "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                    "optional" : 0
                                 },
                                 "group" : {
                                    "type" : "string",
                                    "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                    "maxLength" : 20,
                                    "description" : "Security Group name.",
                                    "minLength" : 2
                                 },
                                 "comment" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "type" : "array",
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{group}"
                              }
                           ]
                        }
                     },
                     "POST" : {
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "name" : "create_security_group",
                        "returns" : {
                           "type" : "null"
                        },
                        "parameters" : {
                           "properties" : {
                              "digest" : {
                                 "type" : "string",
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "optional" : 1
                              },
                              "group" : {
                                 "minLength" : 2,
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "type" : "string",
                                 "description" : "Security Group name.",
                                 "maxLength" : 20
                              },
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "rename" : {
                                 "type" : "string",
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "maxLength" : 20,
                                 "description" : "Rename/update an existing security group. You can set 'rename' to the same value as 'name' to update the 'comment' of an existing group.",
                                 "optional" : 1,
                                 "minLength" : 2
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "method" : "POST",
                        "description" : "Create new security group."
                     }
                  },
                  "children" : [
                     {
                        "text" : "{group}",
                        "leaf" : 0,
                        "path" : "/cluster/firewall/groups/{group}",
                        "info" : {
                           "DELETE" : {
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "group" : {
                                       "description" : "Security Group name.",
                                       "maxLength" : 20,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string",
                                       "minLength" : 2
                                    }
                                 }
                              },
                              "name" : "delete_security_group",
                              "returns" : {
                                 "type" : "null"
                              },
                              "description" : "Delete security group.",
                              "method" : "DELETE"
                           },
                           "POST" : {
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "pos" : {
                                       "optional" : 1,
                                       "minimum" : 0,
                                       "description" : "Update rule at position <pos>.",
                                       "type" : "integer"
                                    },
                                    "type" : {
                                       "type" : "string",
                                       "optional" : 0,
                                       "enum" : [
                                          "in",
                                          "out",
                                          "group"
                                       ]
                                    },
                                    "source" : {
                                       "optional" : 1,
                                       "format" : "pve-fw-addr-spec",
                                       "type" : "string"
                                    },
                                    "dport" : {
                                       "type" : "string",
                                       "format" : "pve-fw-port-spec",
                                       "optional" : 1
                                    },
                                    "action" : {
                                       "maxLength" : 20,
                                       "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                       "type" : "string",
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "minLength" : 2,
                                       "optional" : 0
                                    },
                                    "comment" : {
                                       "type" : "string",
                                       "optional" : 1
                                    },
                                    "sport" : {
                                       "optional" : 1,
                                       "format" : "pve-fw-port-spec",
                                       "type" : "string"
                                    },
                                    "digest" : {
                                       "optional" : 1,
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "type" : "string"
                                    },
                                    "enable" : {
                                       "type" : "integer",
                                       "minimum" : 0,
                                       "optional" : 1
                                    },
                                    "group" : {
                                       "type" : "string",
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "maxLength" : 20,
                                       "description" : "Security Group name.",
                                       "minLength" : 2
                                    },
                                    "iface" : {
                                       "minLength" : 2,
                                       "format" : "pve-iface",
                                       "optional" : 1,
                                       "maxLength" : 20,
                                       "description" : "Network interface name.",
                                       "type" : "string"
                                    },
                                    "macro" : {
                                       "maxLength" : 128,
                                       "type" : "string",
                                       "optional" : 1
                                    },
                                    "proto" : {
                                       "type" : "string",
                                       "optional" : 1,
                                       "format" : "pve-fw-protocol-spec"
                                    },
                                    "dest" : {
                                       "type" : "string",
                                       "format" : "pve-fw-addr-spec",
                                       "optional" : 1
                                    }
                                 }
                              },
                              "description" : "Create new rule.",
                              "method" : "POST",
                              "name" : "create_rule",
                              "proxyto" : null,
                              "returns" : {
                                 "type" : "null"
                              },
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              }
                           },
                           "GET" : {
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "parameters" : {
                                 "properties" : {
                                    "group" : {
                                       "minLength" : 2,
                                       "description" : "Security Group name.",
                                       "maxLength" : 20,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "proxyto" : null,
                              "name" : "get_rules",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "pos" : {
                                          "type" : "integer"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array",
                                 "links" : [
                                    {
                                       "href" : "{pos}",
                                       "rel" : "child"
                                    }
                                 ]
                              },
                              "description" : "List rules.",
                              "method" : "GET"
                           }
                        },
                        "children" : [
                           {
                              "leaf" : 1,
                              "text" : "{pos}",
                              "path" : "/cluster/firewall/groups/{group}/{pos}",
                              "info" : {
                                 "GET" : {
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Audit"
                                          ]
                                       ]
                                    },
                                    "proxyto" : null,
                                    "returns" : {
                                       "type" : "object",
                                       "properties" : {
                                          "pos" : {
                                             "type" : "integer"
                                          }
                                       }
                                    },
                                    "name" : "get_rule",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "group" : {
                                             "description" : "Security Group name.",
                                             "maxLength" : 20,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string",
                                             "minLength" : 2
                                          },
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "type" : "integer",
                                             "optional" : 1,
                                             "minimum" : 0
                                          }
                                       }
                                    },
                                    "method" : "GET",
                                    "description" : "Get single rule data."
                                 },
                                 "PUT" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "iface" : {
                                             "type" : "string",
                                             "maxLength" : 20,
                                             "description" : "Network interface name.",
                                             "minLength" : 2,
                                             "optional" : 1,
                                             "format" : "pve-iface"
                                          },
                                          "dest" : {
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-fw-addr-spec"
                                          },
                                          "proto" : {
                                             "format" : "pve-fw-protocol-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "delete" : {
                                             "type" : "string",
                                             "description" : "A list of settings you want to delete.",
                                             "optional" : 1,
                                             "format" : "pve-configid-list"
                                          },
                                          "enable" : {
                                             "type" : "integer",
                                             "minimum" : 0,
                                             "optional" : 1
                                          },
                                          "comment" : {
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "sport" : {
                                             "optional" : 1,
                                             "format" : "pve-fw-port-spec",
                                             "type" : "string"
                                          },
                                          "source" : {
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-fw-addr-spec"
                                          },
                                          "pos" : {
                                             "type" : "integer",
                                             "description" : "Update rule at position <pos>.",
                                             "minimum" : 0,
                                             "optional" : 1
                                          },
                                          "dport" : {
                                             "type" : "string",
                                             "format" : "pve-fw-port-spec",
                                             "optional" : 1
                                          },
                                          "action" : {
                                             "minLength" : 2,
                                             "optional" : 1,
                                             "maxLength" : 20,
                                             "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                             "type" : "string",
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+"
                                          },
                                          "macro" : {
                                             "optional" : 1,
                                             "type" : "string",
                                             "maxLength" : 128
                                          },
                                          "digest" : {
                                             "type" : "string",
                                             "maxLength" : 40,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "optional" : 1
                                          },
                                          "group" : {
                                             "minLength" : 2,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string",
                                             "description" : "Security Group name.",
                                             "maxLength" : 20
                                          },
                                          "moveto" : {
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "description" : "Move rule to new position <moveto>. Other arguments are ignored."
                                          },
                                          "type" : {
                                             "enum" : [
                                                "in",
                                                "out",
                                                "group"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "proxyto" : null,
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "name" : "update_rule",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "description" : "Modify rule data.",
                                    "method" : "PUT"
                                 },
                                 "DELETE" : {
                                    "name" : "delete_rule",
                                    "proxyto" : null,
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "method" : "DELETE",
                                    "description" : "Delete rule.",
                                    "parameters" : {
                                       "properties" : {
                                          "pos" : {
                                             "optional" : 1,
                                             "minimum" : 0,
                                             "type" : "integer",
                                             "description" : "Update rule at position <pos>."
                                          },
                                          "digest" : {
                                             "optional" : 1,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "type" : "string"
                                          },
                                          "group" : {
                                             "maxLength" : 20,
                                             "description" : "Security Group name.",
                                             "type" : "string",
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "minLength" : 2
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 }
                              }
                           }
                        ]
                     }
                  ]
               },
               {
                  "path" : "/cluster/firewall/rules",
                  "leaf" : 0,
                  "text" : "rules",
                  "info" : {
                     "GET" : {
                        "returns" : {
                           "type" : "array",
                           "items" : {
                              "type" : "object",
                              "properties" : {
                                 "pos" : {
                                    "type" : "integer"
                                 }
                              }
                           },
                           "links" : [
                              {
                                 "href" : "{pos}",
                                 "rel" : "child"
                              }
                           ]
                        },
                        "proxyto" : null,
                        "name" : "get_rules",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "method" : "GET",
                        "description" : "List rules."
                     },
                     "POST" : {
                        "method" : "POST",
                        "description" : "Create new rule.",
                        "name" : "create_rule",
                        "returns" : {
                           "type" : "null"
                        },
                        "proxyto" : null,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "parameters" : {
                           "properties" : {
                              "comment" : {
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "sport" : {
                                 "optional" : 1,
                                 "format" : "pve-fw-port-spec",
                                 "type" : "string"
                              },
                              "type" : {
                                 "enum" : [
                                    "in",
                                    "out",
                                    "group"
                                 ],
                                 "optional" : 0,
                                 "type" : "string"
                              },
                              "source" : {
                                 "optional" : 1,
                                 "format" : "pve-fw-addr-spec",
                                 "type" : "string"
                              },
                              "pos" : {
                                 "description" : "Update rule at position <pos>.",
                                 "type" : "integer",
                                 "minimum" : 0,
                                 "optional" : 1
                              },
                              "dport" : {
                                 "type" : "string",
                                 "format" : "pve-fw-port-spec",
                                 "optional" : 1
                              },
                              "action" : {
                                 "optional" : 0,
                                 "minLength" : 2,
                                 "maxLength" : 20,
                                 "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                 "type" : "string",
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+"
                              },
                              "iface" : {
                                 "minLength" : 2,
                                 "format" : "pve-iface",
                                 "optional" : 1,
                                 "description" : "Network interface name.",
                                 "maxLength" : 20,
                                 "type" : "string"
                              },
                              "macro" : {
                                 "optional" : 1,
                                 "maxLength" : 128,
                                 "type" : "string"
                              },
                              "proto" : {
                                 "type" : "string",
                                 "format" : "pve-fw-protocol-spec",
                                 "optional" : 1
                              },
                              "dest" : {
                                 "type" : "string",
                                 "optional" : 1,
                                 "format" : "pve-fw-addr-spec"
                              },
                              "digest" : {
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "enable" : {
                                 "type" : "integer",
                                 "optional" : 1,
                                 "minimum" : 0
                              }
                           },
                           "additionalProperties" : 0
                        }
                     }
                  },
                  "children" : [
                     {
                        "text" : "{pos}",
                        "leaf" : 1,
                        "path" : "/cluster/firewall/rules/{pos}",
                        "info" : {
                           "PUT" : {
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "sport" : {
                                       "optional" : 1,
                                       "format" : "pve-fw-port-spec",
                                       "type" : "string"
                                    },
                                    "comment" : {
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "moveto" : {
                                       "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                       "type" : "integer",
                                       "minimum" : 0,
                                       "optional" : 1
                                    },
                                    "pos" : {
                                       "optional" : 1,
                                       "minimum" : 0,
                                       "type" : "integer",
                                       "description" : "Update rule at position <pos>."
                                    },
                                    "source" : {
                                       "type" : "string",
                                       "optional" : 1,
                                       "format" : "pve-fw-addr-spec"
                                    },
                                    "type" : {
                                       "type" : "string",
                                       "optional" : 1,
                                       "enum" : [
                                          "in",
                                          "out",
                                          "group"
                                       ]
                                    },
                                    "action" : {
                                       "optional" : 1,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string",
                                       "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                       "maxLength" : 20
                                    },
                                    "dport" : {
                                       "type" : "string",
                                       "format" : "pve-fw-port-spec",
                                       "optional" : 1
                                    },
                                    "iface" : {
                                       "format" : "pve-iface",
                                       "minLength" : 2,
                                       "optional" : 1,
                                       "type" : "string",
                                       "maxLength" : 20,
                                       "description" : "Network interface name."
                                    },
                                    "macro" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "maxLength" : 128
                                    },
                                    "delete" : {
                                       "optional" : 1,
                                       "format" : "pve-configid-list",
                                       "description" : "A list of settings you want to delete.",
                                       "type" : "string"
                                    },
                                    "dest" : {
                                       "type" : "string",
                                       "optional" : 1,
                                       "format" : "pve-fw-addr-spec"
                                    },
                                    "proto" : {
                                       "type" : "string",
                                       "optional" : 1,
                                       "format" : "pve-fw-protocol-spec"
                                    },
                                    "digest" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40
                                    },
                                    "enable" : {
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer"
                                    }
                                 }
                              },
                              "description" : "Modify rule data.",
                              "method" : "PUT",
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : null,
                              "returns" : {
                                 "type" : "null"
                              },
                              "name" : "update_rule"
                           },
                           "GET" : {
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "pos" : {
                                       "optional" : 1,
                                       "minimum" : 0,
                                       "type" : "integer",
                                       "description" : "Update rule at position <pos>."
                                    }
                                 }
                              },
                              "name" : "get_rule",
                              "returns" : {
                                 "properties" : {
                                    "pos" : {
                                       "type" : "integer"
                                    }
                                 },
                                 "type" : "object"
                              },
                              "proxyto" : null,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "description" : "Get single rule data.",
                              "method" : "GET"
                           },
                           "DELETE" : {
                              "parameters" : {
                                 "properties" : {
                                    "digest" : {
                                       "type" : "string",
                                       "maxLength" : 40,
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "optional" : 1
                                    },
                                    "pos" : {
                                       "optional" : 1,
                                       "minimum" : 0,
                                       "description" : "Update rule at position <pos>.",
                                       "type" : "integer"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "description" : "Delete rule.",
                              "method" : "DELETE",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "returns" : {
                                 "type" : "null"
                              },
                              "proxyto" : null,
                              "name" : "delete_rule"
                           }
                        }
                     }
                  ]
               },
               {
                  "text" : "ipset",
                  "leaf" : 0,
                  "path" : "/cluster/firewall/ipset",
                  "info" : {
                     "POST" : {
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "name" : "create_ipset",
                        "returns" : {
                           "type" : "null"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "digest" : {
                                 "optional" : 1,
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "type" : "string"
                              },
                              "name" : {
                                 "minLength" : 2,
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "type" : "string",
                                 "description" : "IP set name.",
                                 "maxLength" : 64
                              },
                              "rename" : {
                                 "maxLength" : 64,
                                 "description" : "Rename an existing IPSet. You can set 'rename' to the same value as 'name' to update the 'comment' of an existing IPSet.",
                                 "type" : "string",
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "minLength" : 2,
                                 "optional" : 1
                              },
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "method" : "POST",
                        "description" : "Create new IPSet"
                     },
                     "GET" : {
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "name" : "ipset_index",
                        "returns" : {
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{name}"
                              }
                           ],
                           "items" : {
                              "type" : "object",
                              "properties" : {
                                 "digest" : {
                                    "optional" : 0,
                                    "type" : "string",
                                    "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                    "maxLength" : 40
                                 },
                                 "comment" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 },
                                 "name" : {
                                    "minLength" : 2,
                                    "type" : "string",
                                    "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                    "maxLength" : 64,
                                    "description" : "IP set name."
                                 }
                              }
                           },
                           "type" : "array"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "description" : "List IPSets",
                        "method" : "GET"
                     }
                  },
                  "children" : [
                     {
                        "info" : {
                           "POST" : {
                              "method" : "POST",
                              "description" : "Add IP or Network to IPSet.",
                              "name" : "create_ip",
                              "returns" : {
                                 "type" : "null"
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "nomatch" : {
                                       "type" : "boolean",
                                       "optional" : 1
                                    },
                                    "cidr" : {
                                       "format" : "IPorCIDRorAlias",
                                       "description" : "Network/IP specification in CIDR format.",
                                       "type" : "string"
                                    },
                                    "name" : {
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string",
                                       "description" : "IP set name.",
                                       "maxLength" : 64
                                    },
                                    "comment" : {
                                       "type" : "string",
                                       "optional" : 1
                                    }
                                 }
                              },
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              }
                           },
                           "DELETE" : {
                              "method" : "DELETE",
                              "description" : "Delete IPSet",
                              "name" : "delete_ipset",
                              "returns" : {
                                 "type" : "null"
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "name" : {
                                       "minLength" : 2,
                                       "description" : "IP set name.",
                                       "maxLength" : 64,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1
                           },
                           "GET" : {
                              "method" : "GET",
                              "description" : "List IPSet content",
                              "name" : "get_ipset",
                              "returns" : {
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "cidr" : {
                                          "type" : "string"
                                       },
                                       "nomatch" : {
                                          "optional" : 1,
                                          "type" : "boolean"
                                       },
                                       "digest" : {
                                          "optional" : 0,
                                          "maxLength" : 40,
                                          "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                          "type" : "string"
                                       },
                                       "comment" : {
                                          "type" : "string",
                                          "optional" : 1
                                       }
                                    }
                                 },
                                 "type" : "array",
                                 "links" : [
                                    {
                                       "rel" : "child",
                                       "href" : "{cidr}"
                                    }
                                 ]
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "name" : {
                                       "minLength" : 2,
                                       "description" : "IP set name.",
                                       "maxLength" : 64,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              }
                           }
                        },
                        "text" : "{name}",
                        "leaf" : 0,
                        "path" : "/cluster/firewall/ipset/{name}",
                        "children" : [
                           {
                              "info" : {
                                 "PUT" : {
                                    "method" : "PUT",
                                    "description" : "Update IP or Network settings",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "name" : "update_ip",
                                    "parameters" : {
                                       "properties" : {
                                          "cidr" : {
                                             "format" : "IPorCIDRorAlias",
                                             "type" : "string",
                                             "description" : "Network/IP specification in CIDR format."
                                          },
                                          "nomatch" : {
                                             "type" : "boolean",
                                             "optional" : 1
                                          },
                                          "digest" : {
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40
                                          },
                                          "comment" : {
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "name" : {
                                             "maxLength" : 64,
                                             "description" : "IP set name.",
                                             "type" : "string",
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "minLength" : 2
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1
                                 },
                                 "GET" : {
                                    "method" : "GET",
                                    "description" : "Read IP or Network settings from IPSet.",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "name" : "read_ip",
                                    "returns" : {
                                       "type" : "object"
                                    },
                                    "parameters" : {
                                       "properties" : {
                                          "cidr" : {
                                             "format" : "IPorCIDRorAlias",
                                             "description" : "Network/IP specification in CIDR format.",
                                             "type" : "string"
                                          },
                                          "name" : {
                                             "minLength" : 2,
                                             "description" : "IP set name.",
                                             "maxLength" : 64,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 },
                                 "DELETE" : {
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "digest" : {
                                             "optional" : 1,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "type" : "string"
                                          },
                                          "cidr" : {
                                             "description" : "Network/IP specification in CIDR format.",
                                             "type" : "string",
                                             "format" : "IPorCIDRorAlias"
                                          },
                                          "name" : {
                                             "type" : "string",
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "maxLength" : 64,
                                             "description" : "IP set name.",
                                             "minLength" : 2
                                          }
                                       }
                                    },
                                    "name" : "remove_ip",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "description" : "Remove IP or Network from IPSet.",
                                    "method" : "DELETE"
                                 }
                              },
                              "text" : "{cidr}",
                              "leaf" : 1,
                              "path" : "/cluster/firewall/ipset/{name}/{cidr}"
                           }
                        ]
                     }
                  ]
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "DELETE" : {
                              "method" : "DELETE",
                              "description" : "Remove IP or Network alias.",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "name" : "remove_alias",
                              "returns" : {
                                 "type" : "null"
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "digest" : {
                                       "optional" : 1,
                                       "maxLength" : 40,
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "type" : "string"
                                    },
                                    "name" : {
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string",
                                       "description" : "Alias name.",
                                       "maxLength" : 64
                                    }
                                 }
                              }
                           },
                           "GET" : {
                              "method" : "GET",
                              "description" : "Read alias.",
                              "returns" : {
                                 "type" : "object"
                              },
                              "name" : "read_alias",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "name" : {
                                       "minLength" : 2,
                                       "description" : "Alias name.",
                                       "maxLength" : 64,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              }
                           },
                           "PUT" : {
                              "method" : "PUT",
                              "description" : "Update IP or Network alias.",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "name" : "update_alias",
                              "returns" : {
                                 "type" : "null"
                              },
                              "parameters" : {
                                 "properties" : {
                                    "comment" : {
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "rename" : {
                                       "optional" : 1,
                                       "minLength" : 2,
                                       "description" : "Rename an existing alias.",
                                       "maxLength" : 64,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    },
                                    "name" : {
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string",
                                       "description" : "Alias name.",
                                       "maxLength" : 64,
                                       "minLength" : 2
                                    },
                                    "cidr" : {
                                       "type" : "string",
                                       "description" : "Network/IP specification in CIDR format.",
                                       "format" : "IPorCIDR"
                                    },
                                    "digest" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "maxLength" : 40,
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications."
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           }
                        },
                        "leaf" : 1,
                        "text" : "{name}",
                        "path" : "/cluster/firewall/aliases/{name}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "method" : "GET",
                        "description" : "List aliases",
                        "name" : "get_aliases",
                        "returns" : {
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{name}"
                              }
                           ],
                           "items" : {
                              "type" : "object",
                              "properties" : {
                                 "comment" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 },
                                 "name" : {
                                    "type" : "string"
                                 },
                                 "digest" : {
                                    "type" : "string",
                                    "maxLength" : 40,
                                    "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                    "optional" : 0
                                 },
                                 "cidr" : {
                                    "type" : "string"
                                 }
                              }
                           },
                           "type" : "array"
                        },
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        }
                     },
                     "POST" : {
                        "description" : "Create IP or Network Alias.",
                        "method" : "POST",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "name" : {
                                 "maxLength" : 64,
                                 "description" : "Alias name.",
                                 "type" : "string",
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "minLength" : 2
                              },
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "cidr" : {
                                 "format" : "IPorCIDR",
                                 "description" : "Network/IP specification in CIDR format.",
                                 "type" : "string"
                              }
                           }
                        },
                        "name" : "create_alias",
                        "returns" : {
                           "type" : "null"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1
                     }
                  },
                  "path" : "/cluster/firewall/aliases",
                  "text" : "aliases",
                  "leaf" : 0
               },
               {
                  "info" : {
                     "GET" : {
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "returns" : {
                           "type" : "object",
                           "properties" : {
                              "policy_out" : {
                                 "type" : "string",
                                 "description" : "Output policy.",
                                 "enum" : [
                                    "ACCEPT",
                                    "REJECT",
                                    "DROP"
                                 ],
                                 "optional" : 1
                              },
                              "policy_in" : {
                                 "type" : "string",
                                 "description" : "Input policy.",
                                 "optional" : 1,
                                 "enum" : [
                                    "ACCEPT",
                                    "REJECT",
                                    "DROP"
                                 ]
                              },
                              "enable" : {
                                 "type" : "integer",
                                 "minimum" : 0,
                                 "optional" : 1
                              }
                           }
                        },
                        "name" : "get_options",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "description" : "Get Firewall options.",
                        "method" : "GET"
                     },
                     "PUT" : {
                        "method" : "PUT",
                        "description" : "Set Firewall options.",
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "name" : "set_options",
                        "returns" : {
                           "type" : "null"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "digest" : {
                                 "optional" : 1,
                                 "maxLength" : 40,
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "type" : "string"
                              },
                              "enable" : {
                                 "optional" : 1,
                                 "minimum" : 0,
                                 "type" : "integer"
                              },
                              "policy_in" : {
                                 "type" : "string",
                                 "description" : "Input policy.",
                                 "enum" : [
                                    "ACCEPT",
                                    "REJECT",
                                    "DROP"
                                 ],
                                 "optional" : 1
                              },
                              "delete" : {
                                 "optional" : 1,
                                 "format" : "pve-configid-list",
                                 "description" : "A list of settings you want to delete.",
                                 "type" : "string"
                              },
                              "policy_out" : {
                                 "type" : "string",
                                 "description" : "Output policy.",
                                 "enum" : [
                                    "ACCEPT",
                                    "REJECT",
                                    "DROP"
                                 ],
                                 "optional" : 1
                              }
                           }
                        }
                     }
                  },
                  "path" : "/cluster/firewall/options",
                  "text" : "options",
                  "leaf" : 1
               },
               {
                  "text" : "macros",
                  "leaf" : 1,
                  "path" : "/cluster/firewall/macros",
                  "info" : {
                     "GET" : {
                        "method" : "GET",
                        "description" : "List available macros",
                        "returns" : {
                           "type" : "array",
                           "items" : {
                              "properties" : {
                                 "descr" : {
                                    "description" : "More verbose description (if available).",
                                    "type" : "string"
                                 },
                                 "macro" : {
                                    "description" : "Macro name.",
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           }
                        },
                        "name" : "get_macros",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "user" : "all"
                        }
                     }
                  }
               },
               {
                  "path" : "/cluster/firewall/refs",
                  "text" : "refs",
                  "leaf" : 1,
                  "info" : {
                     "GET" : {
                        "returns" : {
                           "items" : {
                              "type" : "object",
                              "properties" : {
                                 "type" : {
                                    "enum" : [
                                       "alias",
                                       "ipset"
                                    ],
                                    "type" : "string"
                                 },
                                 "comment" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 },
                                 "name" : {
                                    "type" : "string"
                                 },
                                 "ref" : {
                                    "type" : "string"
                                 }
                              }
                           },
                           "type" : "array"
                        },
                        "name" : "refs",
                        "parameters" : {
                           "properties" : {
                              "type" : {
                                 "enum" : [
                                    "alias",
                                    "ipset"
                                 ],
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Only list references of specified type."
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "method" : "GET",
                        "description" : "Lists possible IPSet/Alias reference which are allowed in source/dest properties."
                     }
                  }
               }
            ]
         },
         {
            "info" : {
               "POST" : {
                  "name" : "create_job",
                  "returns" : {
                     "type" : "null"
                  },
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "starttime" : {
                           "typetext" : "HH:MM",
                           "description" : "Job Start time.",
                           "pattern" : "\\d{1,2}:\\d{1,2}",
                           "type" : "string"
                        },
                        "ionice" : {
                           "maximum" : 8,
                           "optional" : 1,
                           "minimum" : 0,
                           "type" : "integer",
                           "description" : "Set CFQ ionice priority."
                        },
                        "bwlimit" : {
                           "description" : "Limit I/O bandwidth (KBytes per second).",
                           "type" : "integer",
                           "minimum" : 0,
                           "optional" : 1
                        },
                        "mode" : {
                           "description" : "Backup mode.",
                           "type" : "string",
                           "optional" : 1,
                           "default" : "stop",
                           "enum" : [
                              "snapshot",
                              "suspend",
                              "stop"
                           ]
                        },
                        "mailnotification" : {
                           "description" : "Specify when to send an email",
                           "type" : "string",
                           "optional" : 1,
                           "default" : "always",
                           "enum" : [
                              "always",
                              "failure"
                           ]
                        },
                        "dumpdir" : {
                           "optional" : 1,
                           "description" : "Store resulting files to specified directory.",
                           "type" : "string"
                        },
                        "storage" : {
                           "type" : "string",
                           "description" : "Store resulting file to this storage.",
                           "format" : "pve-storage-id",
                           "optional" : 1
                        },
                        "quiet" : {
                           "optional" : 1,
                           "default" : 0,
                           "type" : "boolean",
                           "description" : "Be quiet."
                        },
                        "enabled" : {
                           "type" : "boolean",
                           "description" : "Enable or disable the job.",
                           "default" : "1",
                           "optional" : 1
                        },
                        "maxfiles" : {
                           "optional" : 1,
                           "minimum" : 1,
                           "description" : "Maximal number of backup files per VM.",
                           "type" : "integer"
                        },
                        "size" : {
                           "minimum" : 500,
                           "optional" : 1,
                           "description" : "LVM snapshot size in MB.",
                           "type" : "integer"
                        },
                        "all" : {
                           "description" : "Backup all known VMs on this host.",
                           "type" : "boolean",
                           "optional" : 1,
                           "default" : 0
                        },
                        "pigz" : {
                           "description" : "Uses pigz instead of gzip when N>0. N=1 uses half of cores, N>1 uses N as thread count.",
                           "type" : "integer",
                           "optional" : 1,
                           "default" : 0
                        },
                        "compress" : {
                           "description" : "Compress dump file.",
                           "type" : "string",
                           "enum" : [
                              "0",
                              "1",
                              "gzip",
                              "lzo"
                           ],
                           "default" : "lzo",
                           "optional" : 1
                        },
                        "vmid" : {
                           "description" : "The ID of the VM you want to backup.",
                           "type" : "string",
                           "format" : "pve-vmid-list",
                           "optional" : 1
                        },
                        "remove" : {
                           "description" : "Remove old backup files if there are more than 'maxfiles' backup files.",
                           "type" : "boolean",
                           "default" : 1,
                           "optional" : 1
                        },
                        "tmpdir" : {
                           "optional" : 1,
                           "type" : "string",
                           "description" : "Store temporary files to specified directory."
                        },
                        "stop" : {
                           "default" : 0,
                           "optional" : 1,
                           "type" : "boolean",
                           "description" : "Stop runnig backup jobs on this host."
                        },
                        "stopwait" : {
                           "minimum" : 0,
                           "optional" : 1,
                           "type" : "integer",
                           "description" : "Maximal time to wait until a VM is stopped (minutes)."
                        },
                        "stdexcludes" : {
                           "type" : "boolean",
                           "description" : "Exclude temorary files and logs.",
                           "optional" : 1,
                           "default" : 1
                        },
                        "lockwait" : {
                           "type" : "integer",
                           "description" : "Maximal time to wait for the global lock (minutes).",
                           "minimum" : 0,
                           "optional" : 1
                        },
                        "dow" : {
                           "type" : "string",
                           "description" : "Day of week selection.",
                           "default" : "mon,tue,wed,thu,fri,sat,sun",
                           "format" : "pve-day-of-week-list",
                           "optional" : 1
                        },
                        "exclude" : {
                           "type" : "string",
                           "description" : "exclude specified VMs (assumes --all)",
                           "optional" : 1,
                           "format" : "pve-vmid-list"
                        },
                        "script" : {
                           "type" : "string",
                           "description" : "Use specified hook script.",
                           "optional" : 1
                        },
                        "exclude-path" : {
                           "type" : "string",
                           "description" : "exclude certain files/directories (shell globs).",
                           "optional" : 1,
                           "format" : "string-alist"
                        },
                        "mailto" : {
                           "optional" : 1,
                           "format" : "string-list",
                           "type" : "string",
                           "description" : ""
                        },
                        "node" : {
                           "description" : "Only run if executed on this node.",
                           "type" : "string",
                           "format" : "pve-node",
                           "optional" : 1
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Modify"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "method" : "POST",
                  "description" : "Create new vzdump backup job."
               },
               "GET" : {
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "name" : "index",
                  "returns" : {
                     "links" : [
                        {
                           "href" : "{id}",
                           "rel" : "child"
                        }
                     ],
                     "items" : {
                        "properties" : {
                           "id" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "type" : "array"
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Audit"
                        ]
                     ]
                  },
                  "description" : "List vzdump backup schedule.",
                  "method" : "GET"
               }
            },
            "leaf" : 0,
            "text" : "backup",
            "path" : "/cluster/backup",
            "children" : [
               {
                  "info" : {
                     "PUT" : {
                        "method" : "PUT",
                        "description" : "Update vzdump backup job definition.",
                        "name" : "update_job",
                        "returns" : {
                           "type" : "null"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "stopwait" : {
                                 "type" : "integer",
                                 "description" : "Maximal time to wait until a VM is stopped (minutes).",
                                 "optional" : 1,
                                 "minimum" : 0
                              },
                              "lockwait" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "description" : "Maximal time to wait for the global lock (minutes)."
                              },
                              "stdexcludes" : {
                                 "default" : 1,
                                 "optional" : 1,
                                 "description" : "Exclude temorary files and logs.",
                                 "type" : "boolean"
                              },
                              "dow" : {
                                 "optional" : 1,
                                 "format" : "pve-day-of-week-list",
                                 "description" : "Day of week selection.",
                                 "type" : "string"
                              },
                              "script" : {
                                 "type" : "string",
                                 "description" : "Use specified hook script.",
                                 "optional" : 1
                              },
                              "exclude" : {
                                 "type" : "string",
                                 "description" : "exclude specified VMs (assumes --all)",
                                 "optional" : 1,
                                 "format" : "pve-vmid-list"
                              },
                              "tmpdir" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Store temporary files to specified directory."
                              },
                              "remove" : {
                                 "type" : "boolean",
                                 "description" : "Remove old backup files if there are more than 'maxfiles' backup files.",
                                 "default" : 1,
                                 "optional" : 1
                              },
                              "stop" : {
                                 "type" : "boolean",
                                 "description" : "Stop runnig backup jobs on this host.",
                                 "optional" : 1,
                                 "default" : 0
                              },
                              "mailto" : {
                                 "description" : "",
                                 "type" : "string",
                                 "optional" : 1,
                                 "format" : "string-list"
                              },
                              "node" : {
                                 "format" : "pve-node",
                                 "optional" : 1,
                                 "description" : "Only run if executed on this node.",
                                 "type" : "string"
                              },
                              "exclude-path" : {
                                 "type" : "string",
                                 "description" : "exclude certain files/directories (shell globs).",
                                 "format" : "string-alist",
                                 "optional" : 1
                              },
                              "quiet" : {
                                 "default" : 0,
                                 "optional" : 1,
                                 "description" : "Be quiet.",
                                 "type" : "boolean"
                              },
                              "enabled" : {
                                 "optional" : 1,
                                 "default" : "1",
                                 "type" : "boolean",
                                 "description" : "Enable or disable the job."
                              },
                              "storage" : {
                                 "type" : "string",
                                 "description" : "Store resulting file to this storage.",
                                 "format" : "pve-storage-id",
                                 "optional" : 1
                              },
                              "maxfiles" : {
                                 "optional" : 1,
                                 "minimum" : 1,
                                 "type" : "integer",
                                 "description" : "Maximal number of backup files per VM."
                              },
                              "size" : {
                                 "type" : "integer",
                                 "description" : "LVM snapshot size in MB.",
                                 "minimum" : 500,
                                 "optional" : 1
                              },
                              "mailnotification" : {
                                 "type" : "string",
                                 "description" : "Specify when to send an email",
                                 "enum" : [
                                    "always",
                                    "failure"
                                 ],
                                 "default" : "always",
                                 "optional" : 1
                              },
                              "dumpdir" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Store resulting files to specified directory."
                              },
                              "compress" : {
                                 "type" : "string",
                                 "description" : "Compress dump file.",
                                 "enum" : [
                                    "0",
                                    "1",
                                    "gzip",
                                    "lzo"
                                 ],
                                 "optional" : 1,
                                 "default" : "lzo"
                              },
                              "vmid" : {
                                 "description" : "The ID of the VM you want to backup.",
                                 "type" : "string",
                                 "format" : "pve-vmid-list",
                                 "optional" : 1
                              },
                              "pigz" : {
                                 "default" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "description" : "Uses pigz instead of gzip when N>0. N=1 uses half of cores, N>1 uses N as thread count."
                              },
                              "all" : {
                                 "type" : "boolean",
                                 "description" : "Backup all known VMs on this host.",
                                 "default" : 0,
                                 "optional" : 1
                              },
                              "ionice" : {
                                 "minimum" : 0,
                                 "maximum" : 8,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "description" : "Set CFQ ionice priority."
                              },
                              "starttime" : {
                                 "typetext" : "HH:MM",
                                 "description" : "Job Start time.",
                                 "pattern" : "\\d{1,2}:\\d{1,2}",
                                 "type" : "string"
                              },
                              "mode" : {
                                 "type" : "string",
                                 "description" : "Backup mode.",
                                 "default" : "stop",
                                 "optional" : 1,
                                 "enum" : [
                                    "snapshot",
                                    "suspend",
                                    "stop"
                                 ]
                              },
                              "id" : {
                                 "type" : "string",
                                 "description" : "The job ID.",
                                 "maxLength" : 50
                              },
                              "bwlimit" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "description" : "Limit I/O bandwidth (KBytes per second).",
                                 "type" : "integer"
                              },
                              "delete" : {
                                 "optional" : 1,
                                 "format" : "pve-configid-list",
                                 "description" : "A list of settings you want to delete.",
                                 "type" : "string"
                              }
                           }
                        },
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        }
                     },
                     "GET" : {
                        "description" : "Read vzdump backup job definition.",
                        "method" : "GET",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "id" : {
                                 "type" : "string",
                                 "description" : "The job ID.",
                                 "maxLength" : 50
                              }
                           }
                        },
                        "name" : "read_job",
                        "returns" : {
                           "type" : "object"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        }
                     },
                     "DELETE" : {
                        "description" : "Delete vzdump backup job definition.",
                        "method" : "DELETE",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "id" : {
                                 "description" : "The job ID.",
                                 "maxLength" : 50,
                                 "type" : "string"
                              }
                           }
                        },
                        "name" : "delete_job",
                        "returns" : {
                           "type" : "null"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1
                     }
                  },
                  "path" : "/cluster/backup/{id}",
                  "leaf" : 1,
                  "text" : "{id}"
               }
            ]
         },
         {
            "info" : {
               "GET" : {
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Audit"
                        ]
                     ]
                  },
                  "name" : "index",
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "id" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "type" : "array",
                     "links" : [
                        {
                           "href" : "{id}",
                           "rel" : "child"
                        }
                     ]
                  },
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "method" : "GET",
                  "description" : "Directory index."
               }
            },
            "text" : "ha",
            "leaf" : 0,
            "path" : "/cluster/ha",
            "children" : [
               {
                  "leaf" : 0,
                  "text" : "resources",
                  "path" : "/cluster/ha/resources",
                  "info" : {
                     "GET" : {
                        "method" : "GET",
                        "description" : "List HA resources.",
                        "name" : "index",
                        "returns" : {
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{sid}"
                              }
                           ],
                           "items" : {
                              "type" : "object",
                              "properties" : {
                                 "sid" : {
                                    "type" : "string"
                                 }
                              }
                           },
                           "type" : "array"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "type" : {
                                 "description" : "Only list resources of specific type",
                                 "type" : "string",
                                 "enum" : [
                                    "ct",
                                    "vm"
                                 ],
                                 "optional" : 1
                              }
                           }
                        }
                     },
                     "POST" : {
                        "description" : "Create a new HA resource.",
                        "method" : "POST",
                        "parameters" : {
                           "type" : "object",
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Description.",
                                 "maxLength" : 4096
                              },
                              "group" : {
                                 "format" : "pve-configid",
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "The HA group identifier."
                              },
                              "state" : {
                                 "type" : "string",
                                 "description" : "Resource state.",
                                 "optional" : 1,
                                 "default" : "enabled",
                                 "enum" : [
                                    "enabled",
                                    "disabled"
                                 ]
                              },
                              "type" : {
                                 "description" : "Resource type.",
                                 "type" : "string",
                                 "optional" : 1,
                                 "enum" : [
                                    "ct",
                                    "vm"
                                 ]
                              },
                              "sid" : {
                                 "format" : "pve-ha-resource-or-vm-id",
                                 "typetext" : "<type>:<name>",
                                 "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                 "type" : "string"
                              },
                              "max_relocate" : {
                                 "description" : "Maximal number of service relocate tries when a service failes to start.",
                                 "type" : "integer",
                                 "minimum" : 0,
                                 "default" : 1,
                                 "optional" : 1
                              },
                              "max_restart" : {
                                 "description" : "Maximal number of tries to restart the service on a node after its start failed.",
                                 "type" : "integer",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "default" : 1
                              }
                           }
                        },
                        "name" : "create",
                        "returns" : {
                           "type" : "null"
                        },
                        "protected" : 1
                     }
                  },
                  "children" : [
                     {
                        "children" : [
                           {
                              "path" : "/cluster/ha/resources/{sid}/migrate",
                              "text" : "migrate",
                              "leaf" : 1,
                              "info" : {
                                 "POST" : {
                                    "description" : "Request resource migration (online) to another node.",
                                    "method" : "POST",
                                    "protected" : 1,
                                    "parameters" : {
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "sid" : {
                                             "type" : "string",
                                             "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                             "typetext" : "<type>:<name>",
                                             "format" : "pve-ha-resource-or-vm-id"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "name" : "migrate"
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "sid" : {
                                             "typetext" : "<type>:<name>",
                                             "format" : "pve-ha-resource-or-vm-id",
                                             "type" : "string",
                                             "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100)."
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "name" : "relocate",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "protected" : 1,
                                    "description" : "Request resource relocatzion to another node. This stops the service on the old node, and restarts it on the target node.",
                                    "method" : "POST"
                                 }
                              },
                              "text" : "relocate",
                              "leaf" : 1,
                              "path" : "/cluster/ha/resources/{sid}/relocate"
                           }
                        ],
                        "info" : {
                           "PUT" : {
                              "parameters" : {
                                 "properties" : {
                                    "delete" : {
                                       "optional" : 1,
                                       "format" : "pve-configid-list",
                                       "description" : "A list of settings you want to delete.",
                                       "maxLength" : 4096,
                                       "type" : "string"
                                    },
                                    "group" : {
                                       "description" : "The HA group identifier.",
                                       "type" : "string",
                                       "optional" : 1,
                                       "format" : "pve-configid"
                                    },
                                    "digest" : {
                                       "optional" : 1,
                                       "maxLength" : 40,
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "type" : "string"
                                    },
                                    "sid" : {
                                       "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                       "type" : "string",
                                       "format" : "pve-ha-resource-or-vm-id",
                                       "typetext" : "<type>:<name>"
                                    },
                                    "max_relocate" : {
                                       "type" : "integer",
                                       "description" : "Maximal number of service relocate tries when a service failes to start.",
                                       "optional" : 1,
                                       "default" : 1,
                                       "minimum" : 0
                                    },
                                    "comment" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "description" : "Description.",
                                       "maxLength" : 4096
                                    },
                                    "state" : {
                                       "type" : "string",
                                       "description" : "Resource state.",
                                       "enum" : [
                                          "enabled",
                                          "disabled"
                                       ],
                                       "default" : "enabled",
                                       "optional" : 1
                                    },
                                    "max_restart" : {
                                       "description" : "Maximal number of tries to restart the service on a node after its start failed.",
                                       "type" : "integer",
                                       "optional" : 1,
                                       "default" : 1,
                                       "minimum" : 0
                                    }
                                 },
                                 "additionalProperties" : 0,
                                 "type" : "object"
                              },
                              "returns" : {
                                 "type" : "null"
                              },
                              "name" : "update",
                              "protected" : 1,
                              "description" : "Update resource configuration.",
                              "method" : "PUT"
                           },
                           "GET" : {
                              "returns" : {},
                              "name" : "read",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "sid" : {
                                       "typetext" : "<type>:<name>",
                                       "format" : "pve-ha-resource-or-vm-id",
                                       "type" : "string",
                                       "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100)."
                                    }
                                 }
                              },
                              "method" : "GET",
                              "description" : "Read resource configuration."
                           },
                           "DELETE" : {
                              "method" : "DELETE",
                              "description" : "Delete resource configuration.",
                              "returns" : {
                                 "type" : "null"
                              },
                              "name" : "delete",
                              "parameters" : {
                                 "properties" : {
                                    "sid" : {
                                       "format" : "pve-ha-resource-or-vm-id",
                                       "typetext" : "<type>:<name>",
                                       "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                       "type" : "string"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "protected" : 1
                           }
                        },
                        "leaf" : 0,
                        "text" : "{sid}",
                        "path" : "/cluster/ha/resources/{sid}"
                     }
                  ]
               },
               {
                  "info" : {
                     "POST" : {
                        "description" : "Create a new HA group.",
                        "method" : "POST",
                        "parameters" : {
                           "properties" : {
                              "nofailback" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "description" : "The CRM tries to run services on the node with the highest priority. If a node with higher priority comes online, the CRM migrates the service to that node. Enabling nofailback prevents that behavior.",
                                 "type" : "boolean"
                              },
                              "type" : {
                                 "optional" : 1,
                                 "enum" : [
                                    "group"
                                 ],
                                 "type" : "string",
                                 "description" : "Group type."
                              },
                              "restricted" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "description" : "Services on unrestricted groups may run on any cluster members if all group members are offline. But they will migrate back as soon as a group member comes online. One can implement a 'preferred node' behavior using an unrestricted group with one member.",
                                 "type" : "boolean"
                              },
                              "group" : {
                                 "type" : "string",
                                 "description" : "The HA group identifier.",
                                 "format" : "pve-configid"
                              },
                              "nodes" : {
                                 "description" : "List of cluster node names with optional priority. We use priority '0' as default. The CRM tries to run services on the node with highest priority (also see option 'nofailback').",
                                 "type" : "string",
                                 "optional" : 0,
                                 "format" : "pve-ha-group-node-list",
                                 "typetext" : "<node>[:<pri>]{,<node>[:<pri>]}*"
                              },
                              "comment" : {
                                 "optional" : 1,
                                 "maxLength" : 4096,
                                 "description" : "Description.",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0,
                           "type" : "object"
                        },
                        "name" : "create",
                        "returns" : {
                           "type" : "null"
                        },
                        "protected" : 1
                     },
                     "GET" : {
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "returns" : {
                           "items" : {
                              "type" : "object",
                              "properties" : {
                                 "group" : {
                                    "type" : "string"
                                 }
                              }
                           },
                           "type" : "array",
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{group}"
                              }
                           ]
                        },
                        "name" : "index",
                        "description" : "Get HA groups.",
                        "method" : "GET"
                     }
                  },
                  "path" : "/cluster/ha/groups",
                  "text" : "groups",
                  "leaf" : 0,
                  "children" : [
                     {
                        "path" : "/cluster/ha/groups/{group}",
                        "leaf" : 1,
                        "text" : "{group}",
                        "info" : {
                           "DELETE" : {
                              "method" : "DELETE",
                              "description" : "Delete ha group configuration.",
                              "name" : "delete",
                              "returns" : {
                                 "type" : "null"
                              },
                              "parameters" : {
                                 "properties" : {
                                    "group" : {
                                       "type" : "string",
                                       "description" : "The HA group identifier.",
                                       "format" : "pve-configid"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "protected" : 1
                           },
                           "PUT" : {
                              "protected" : 1,
                              "parameters" : {
                                 "properties" : {
                                    "nodes" : {
                                       "type" : "string",
                                       "description" : "List of cluster node names with optional priority. We use priority '0' as default. The CRM tries to run services on the node with highest priority (also see option 'nofailback').",
                                       "typetext" : "<node>[:<pri>]{,<node>[:<pri>]}*",
                                       "format" : "pve-ha-group-node-list",
                                       "optional" : 1
                                    },
                                    "group" : {
                                       "format" : "pve-configid",
                                       "type" : "string",
                                       "description" : "The HA group identifier."
                                    },
                                    "nofailback" : {
                                       "default" : 0,
                                       "optional" : 1,
                                       "type" : "boolean",
                                       "description" : "The CRM tries to run services on the node with the highest priority. If a node with higher priority comes online, the CRM migrates the service to that node. Enabling nofailback prevents that behavior."
                                    },
                                    "digest" : {
                                       "type" : "string",
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1
                                    },
                                    "restricted" : {
                                       "type" : "boolean",
                                       "description" : "Services on unrestricted groups may run on any cluster members if all group members are offline. But they will migrate back as soon as a group member comes online. One can implement a 'preferred node' behavior using an unrestricted group with one member.",
                                       "optional" : 1,
                                       "default" : 0
                                    },
                                    "delete" : {
                                       "type" : "string",
                                       "description" : "A list of settings you want to delete.",
                                       "maxLength" : 4096,
                                       "optional" : 1,
                                       "format" : "pve-configid-list"
                                    },
                                    "comment" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "description" : "Description.",
                                       "maxLength" : 4096
                                    }
                                 },
                                 "type" : "object",
                                 "additionalProperties" : 0
                              },
                              "returns" : {
                                 "type" : "null"
                              },
                              "name" : "update",
                              "description" : "Update ha group configuration.",
                              "method" : "PUT"
                           },
                           "GET" : {
                              "description" : "Read ha group configuration.",
                              "method" : "GET",
                              "parameters" : {
                                 "properties" : {
                                    "group" : {
                                       "description" : "The HA group identifier.",
                                       "type" : "string",
                                       "format" : "pve-configid"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "name" : "read",
                              "returns" : {}
                           }
                        }
                     }
                  ]
               },
               {
                  "path" : "/cluster/ha/status",
                  "leaf" : 0,
                  "text" : "status",
                  "info" : {
                     "GET" : {
                        "name" : "index",
                        "returns" : {
                           "items" : {
                              "type" : "object",
                              "properties" : {}
                           },
                           "type" : "array",
                           "links" : [
                              {
                                 "href" : "{name}",
                                 "rel" : "child"
                              }
                           ]
                        },
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "method" : "GET",
                        "description" : "Directory index."
                     }
                  },
                  "children" : [
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get HA manger status.",
                              "method" : "GET",
                              "parameters" : {
                                 "additionalProperties" : 0
                              },
                              "returns" : {
                                 "type" : "array"
                              },
                              "name" : "status"
                           }
                        },
                        "leaf" : 1,
                        "text" : "current",
                        "path" : "/cluster/ha/status/current"
                     },
                     {
                        "path" : "/cluster/ha/status/manager_status",
                        "text" : "manager_status",
                        "leaf" : 1,
                        "info" : {
                           "GET" : {
                              "parameters" : {
                                 "additionalProperties" : 0
                              },
                              "returns" : {
                                 "type" : "object"
                              },
                              "name" : "manager_status",
                              "description" : "Get full HA manger status, including LRM status.",
                              "method" : "GET"
                           }
                        }
                     }
                  ]
               }
            ]
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Read cluster log",
                  "method" : "GET",
                  "permissions" : {
                     "user" : "all"
                  },
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "max" : {
                           "optional" : 1,
                           "minimum" : 1,
                           "description" : "Maximum number of entries.",
                           "type" : "integer"
                        }
                     }
                  },
                  "returns" : {
                     "type" : "array",
                     "items" : {
                        "properties" : {},
                        "type" : "object"
                     }
                  },
                  "name" : "log"
               }
            },
            "path" : "/cluster/log",
            "text" : "log",
            "leaf" : 1
         },
         {
            "info" : {
               "GET" : {
                  "permissions" : {
                     "user" : "all"
                  },
                  "parameters" : {
                     "properties" : {
                        "type" : {
                           "optional" : 1,
                           "enum" : [
                              "vm",
                              "storage",
                              "node"
                           ],
                           "type" : "string"
                        }
                     },
                     "additionalProperties" : 0
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {},
                        "type" : "object"
                     },
                     "type" : "array"
                  },
                  "name" : "resources",
                  "description" : "Resources index (cluster wide).",
                  "method" : "GET"
               }
            },
            "path" : "/cluster/resources",
            "text" : "resources",
            "leaf" : 1
         },
         {
            "leaf" : 1,
            "text" : "tasks",
            "path" : "/cluster/tasks",
            "info" : {
               "GET" : {
                  "permissions" : {
                     "user" : "all"
                  },
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "returns" : {
                     "type" : "array",
                     "items" : {
                        "properties" : {
                           "upid" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     }
                  },
                  "name" : "tasks",
                  "description" : "List recent tasks (cluster wide).",
                  "method" : "GET"
               }
            }
         },
         {
            "path" : "/cluster/options",
            "text" : "options",
            "leaf" : 1,
            "info" : {
               "PUT" : {
                  "method" : "PUT",
                  "description" : "Set datacenter options.",
                  "name" : "set_options",
                  "returns" : {
                     "type" : "null"
                  },
                  "parameters" : {
                     "properties" : {
                        "delete" : {
                           "type" : "string",
                           "description" : "A list of settings you want to delete.",
                           "format" : "pve-configid-list",
                           "optional" : 1
                        },
                        "language" : {
                           "type" : "string",
                           "description" : "Default GUI language.",
                           "optional" : 1,
                           "enum" : [
                              "en",
                              "de"
                           ]
                        },
                        "console" : {
                           "description" : "Select the default Console viewer. You can either use the builtin java applet (VNC), an external virt-viewer comtatible application (SPICE), or an HTML5 based viewer (noVNC).",
                           "type" : "string",
                           "optional" : 1,
                           "enum" : [
                              "applet",
                              "vv",
                              "html5"
                           ]
                        },
                        "migration_unsecure" : {
                           "optional" : 1,
                           "type" : "boolean",
                           "description" : "Migration is secure using SSH tunnel by default. For secure private networks you can disable it to speed up migration."
                        },
                        "keyboard" : {
                           "type" : "string",
                           "description" : "Default keybord layout for vnc server.",
                           "enum" : [
                              "sl",
                              "it",
                              "es",
                              "fr",
                              "de-ch",
                              "lt",
                              "no",
                              "fr-ch",
                              "de",
                              "en-us",
                              "pt",
                              "pt-br",
                              "fr-be",
                              "fr-ca",
                              "tr",
                              "da",
                              "pl",
                              "mk",
                              "fi",
                              "en-gb",
                              "nl",
                              "ja",
                              "is",
                              "hu",
                              "sv"
                           ],
                           "optional" : 1
                        },
                        "email_from" : {
                           "description" : "Specify email address to send notification from (default is root@$hostname)",
                           "type" : "string",
                           "optional" : 1,
                           "format" : "email-opt"
                        },
                        "http_proxy" : {
                           "type" : "string",
                           "pattern" : "http://.*",
                           "description" : "Specify external http proxy which is used for downloads (example: 'http://username:password@host:port/')",
                           "optional" : 1
                        }
                     },
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Modify"
                        ]
                     ]
                  },
                  "protected" : 1
               },
               "GET" : {
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Audit"
                        ]
                     ]
                  },
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "name" : "get_options",
                  "returns" : {
                     "type" : "object",
                     "properties" : {}
                  },
                  "description" : "Get datacenter options.",
                  "method" : "GET"
               }
            }
         },
         {
            "text" : "status",
            "leaf" : 1,
            "path" : "/cluster/status",
            "info" : {
               "GET" : {
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Audit"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "name" : "get_status",
                  "returns" : {
                     "type" : "array",
                     "items" : {
                        "type" : "object",
                        "properties" : {
                           "type" : {
                              "type" : "string"
                           }
                        }
                     }
                  },
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "method" : "GET",
                  "description" : "Get cluster status informations."
               }
            }
         },
         {
            "info" : {
               "GET" : {
                  "method" : "GET",
                  "description" : "Get next free VMID. If you pass an VMID it will raise an error if the ID is already used.",
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "description" : "The next free VMID.",
                     "type" : "integer"
                  },
                  "name" : "nextid",
                  "parameters" : {
                     "properties" : {
                        "vmid" : {
                           "description" : "The (unique) ID of the VM.",
                           "type" : "integer",
                           "optional" : 1,
                           "format" : "pve-vmid",
                           "minimum" : 1
                        }
                     },
                     "additionalProperties" : 0
                  }
               }
            },
            "path" : "/cluster/nextid",
            "leaf" : 1,
            "text" : "nextid"
         }
      ],
      "info" : {
         "GET" : {
            "permissions" : {
               "user" : "all"
            },
            "returns" : {
               "links" : [
                  {
                     "rel" : "child",
                     "href" : "{name}"
                  }
               ],
               "type" : "array",
               "items" : {
                  "properties" : {},
                  "type" : "object"
               }
            },
            "name" : "index",
            "parameters" : {
               "additionalProperties" : 0
            },
            "method" : "GET",
            "description" : "Cluster index."
         }
      },
      "text" : "cluster",
      "leaf" : 0,
      "path" : "/cluster"
   },
   {
      "leaf" : 0,
      "text" : "nodes",
      "path" : "/nodes",
      "info" : {
         "GET" : {
            "description" : "Cluster node index.",
            "method" : "GET",
            "permissions" : {
               "user" : "all"
            },
            "parameters" : {
               "additionalProperties" : 0
            },
            "name" : "index",
            "returns" : {
               "links" : [
                  {
                     "href" : "{node}",
                     "rel" : "child"
                  }
               ],
               "type" : "array",
               "items" : {
                  "type" : "object",
                  "properties" : {}
               }
            }
         }
      },
      "children" : [
         {
            "children" : [
               {
                  "info" : {
                     "GET" : {
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              }
                           }
                        },
                        "description" : "Virtual machine index (per node).",
                        "method" : "GET",
                        "permissions" : {
                           "user" : "all",
                           "description" : "Only list VMs where you have VM.Audit permissons on /vms/<vmid>."
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "name" : "vmlist",
                        "returns" : {
                           "type" : "array",
                           "items" : {
                              "type" : "object",
                              "properties" : {}
                           },
                           "links" : [
                              {
                                 "href" : "{vmid}",
                                 "rel" : "child"
                              }
                           ]
                        }
                     },
                     "POST" : {
                        "description" : "Create or restore a virtual machine.",
                        "method" : "POST",
                        "protected" : 1,
                        "permissions" : {
                           "description" : "You need 'VM.Allocate' permissions on /vms/{vmid} or on the VM pool /pool/{pool}. For restore (option 'archive'), it is enough if the user has 'VM.Backup' permission and the VM already exists. If you create disks you need 'Datastore.AllocateSpace' on any used storage.",
                           "user" : "all"
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        },
                        "name" : "create_vm",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "archive" : {
                                 "maxLength" : 255,
                                 "description" : "The backup file.",
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "vga" : {
                                 "optional" : 1,
                                 "enum" : [
                                    "std",
                                    "cirrus",
                                    "vmware",
                                    "qxl",
                                    "serial0",
                                    "serial1",
                                    "serial2",
                                    "serial3",
                                    "qxl2",
                                    "qxl3",
                                    "qxl4"
                                 ],
                                 "description" : "Select VGA type. If you want to use high resolution modes (>= 1280x1024x16) then you should use option 'std' or 'vmware'. Default is 'std' for win8/win7/w2k8, and 'cirrur' for other OS types. Option 'qxl' enables the SPICE display sever. You can also run without any graphic card using a serial devive as terminal.",
                                 "type" : "string"
                              },
                              "ide[n]" : {
                                 "format" : "pve-qm-drive",
                                 "optional" : 1,
                                 "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads] [,discard=ignore|on] [,serial=serial][,model=model]",
                                 "description" : "Use volume as IDE hard disk or CD-ROM (n is 0 to 3).",
                                 "type" : "string"
                              },
                              "numa" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "description" : "Enable/disable Numa.",
                                 "type" : "boolean"
                              },
                              "virtio[n]" : {
                                 "description" : "Use volume as VIRTIO hard disk (n is 0 to 15).",
                                 "type" : "string",
                                 "format" : "pve-qm-drive",
                                 "optional" : 1,
                                 "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads]  [,discard=ignore|on] [,iothread=on] [,serial=serial]"
                              },
                              "vcpus" : {
                                 "default" : 0,
                                 "optional" : 1,
                                 "minimum" : 1,
                                 "description" : "Number of hotplugged vcpus.",
                                 "type" : "integer"
                              },
                              "reboot" : {
                                 "default" : 1,
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Allow reboot. If set to '0' the VM exit on reboot."
                              },
                              "bootdisk" : {
                                 "format" : "pve-qm-bootdisk",
                                 "optional" : 1,
                                 "type" : "string",
                                 "pattern" : "(ide|sata|scsi|virtio)\\d+",
                                 "description" : "Enable booting from specified disk."
                              },
                              "kvm" : {
                                 "default" : 1,
                                 "optional" : 1,
                                 "description" : "Enable/disable KVM hardware virtualization.",
                                 "type" : "boolean"
                              },
                              "name" : {
                                 "description" : "Set a name for the VM. Only used on the configuration web interface.",
                                 "type" : "string",
                                 "format" : "dns-name",
                                 "optional" : 1
                              },
                              "cdrom" : {
                                 "description" : "This is an alias for option -ide2",
                                 "type" : "string",
                                 "optional" : 1,
                                 "format" : "pve-qm-drive",
                                 "typetext" : "volume"
                              },
                              "tablet" : {
                                 "default" : 1,
                                 "optional" : 1,
                                 "description" : "Enable/disable the usb tablet device. This device is usually needed to allow absolute mouse positioning with VNC. Else the mouse runs out of sync with normal VNC clients. If you're running lots of console-only guests on one host, you may consider disabling this to save some context switches. This is turned of by default if you use spice (vga=qxl).",
                                 "type" : "boolean"
                              },
                              "cpulimit" : {
                                 "description" : "Limit of CPU usage. Note if the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit.",
                                 "type" : "number",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "default" : 0,
                                 "maximum" : 128
                              },
                              "template" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "type" : "boolean",
                                 "description" : "Enable/disable Template."
                              },
                              "usb[n]" : {
                                 "description" : "Configure an USB device (n is 0 to 4). This can be used to\npass-through usb devices to the guest. HOSTUSBDEVICE syntax is:\n\n'bus-port(.port)*' (decimal numbers) or\n'vendor_id:product_id' (hexadeciaml numbers)\n\nYou can use the 'lsusb -t' command to list existing usb devices.\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nThe value 'spice' can be used to add a usb redirection devices for spice.\n\n",
                                 "type" : "string",
                                 "optional" : 1,
                                 "format" : "pve-qm-usb-device",
                                 "typetext" : "host=HOSTUSBDEVICE|spice"
                              },
                              "startup" : {
                                 "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped.",
                                 "type" : "string",
                                 "format" : "pve-startup-order",
                                 "optional" : 1,
                                 "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] "
                              },
                              "cores" : {
                                 "optional" : 1,
                                 "default" : 1,
                                 "minimum" : 1,
                                 "description" : "The number of cores per socket.",
                                 "type" : "integer"
                              },
                              "scsi[n]" : {
                                 "format" : "pve-qm-drive",
                                 "optional" : 1,
                                 "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads] [,discard=ignore|on] [,iothread=on] [,queues=<nbqueues>] [,serial=serial]",
                                 "description" : "Use volume as SCSI hard disk or CD-ROM (n is 0 to 13).",
                                 "type" : "string"
                              },
                              "boot" : {
                                 "optional" : 1,
                                 "default" : "cdn",
                                 "description" : "Boot on floppy (a), hard disk (c), CD-ROM (d), or network (n).",
                                 "pattern" : "[acdn]{1,4}",
                                 "type" : "string"
                              },
                              "cpu" : {
                                 "default" : "kvm64",
                                 "optional" : 1,
                                 "enum" : [
                                    "486",
                                    "athlon",
                                    "pentium",
                                    "pentium2",
                                    "pentium3",
                                    "coreduo",
                                    "core2duo",
                                    "kvm32",
                                    "kvm64",
                                    "qemu32",
                                    "qemu64",
                                    "phenom",
                                    "Conroe",
                                    "Penryn",
                                    "Nehalem",
                                    "Westmere",
                                    "SandyBridge",
                                    "IvyBridge",
                                    "Haswell",
                                    "Broadwell",
                                    "Opteron_G1",
                                    "Opteron_G2",
                                    "Opteron_G3",
                                    "Opteron_G4",
                                    "Opteron_G5",
                                    "host"
                                 ],
                                 "description" : "Emulated CPU type.",
                                 "type" : "string"
                              },
                              "cpuunits" : {
                                 "description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0.",
                                 "type" : "integer",
                                 "maximum" : 500000,
                                 "optional" : 1,
                                 "default" : 1000,
                                 "minimum" : 0
                              },
                              "vmid" : {
                                 "description" : "The (unique) ID of the VM.",
                                 "type" : "integer",
                                 "minimum" : 1,
                                 "format" : "pve-vmid"
                              },
                              "sata[n]" : {
                                 "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads]  [,discard=ignore|on] [,serial=serial]",
                                 "optional" : 1,
                                 "format" : "pve-qm-drive",
                                 "type" : "string",
                                 "description" : "Use volume as SATA hard disk or CD-ROM (n is 0 to 5)."
                              },
                              "protection" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "type" : "boolean",
                                 "description" : "Sets the protection flag of the VM. This will prevent the remove operation."
                              },
                              "numa[n]" : {
                                 "typetext" : "cpus=<id[-id],memory=<mb>[[,hostnodes=<id[-id]>] [,policy=<preferred|bind|interleave>]]",
                                 "optional" : 1,
                                 "format" : "pve-qm-numanode",
                                 "type" : "string",
                                 "description" : "numa topology"
                              },
                              "migrate_speed" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "default" : 0,
                                 "type" : "integer",
                                 "description" : "Set maximum speed (in MB/s) for migrations. Value 0 is no limit."
                              },
                              "parallel[n]" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "pattern" : "/dev/parport\\d+|/dev/usb/lp\\d+",
                                 "description" : "Map host parallel devices (n is 0 to 2).\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n"
                              },
                              "smp" : {
                                 "optional" : 1,
                                 "default" : 1,
                                 "minimum" : 1,
                                 "type" : "integer",
                                 "description" : "The number of CPUs. Please use option -sockets instead."
                              },
                              "machine" : {
                                 "optional" : 1,
                                 "pattern" : "(pc|pc(-i440fx)?-\\d+\\.\\d+|q35|pc-q35-\\d+\\.\\d+)",
                                 "type" : "string",
                                 "description" : "Specific the Qemu machine type.",
                                 "maxLength" : 40
                              },
                              "localtime" : {
                                 "optional" : 1,
                                 "description" : "Set the real time clock to local time. This is enabled by default if ostype indicates a Microsoft OS.",
                                 "type" : "boolean"
                              },
                              "sockets" : {
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "default" : 1,
                                 "type" : "integer",
                                 "description" : "The number of CPU sockets."
                              },
                              "agent" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "type" : "boolean",
                                 "description" : "Enable/disable Qemu GuestAgent."
                              },
                              "unused[n]" : {
                                 "format" : "pve-volume-id",
                                 "optional" : 1,
                                 "description" : "Reference to unused volumes.",
                                 "type" : "string"
                              },
                              "migrate_downtime" : {
                                 "minimum" : 0,
                                 "default" : 0.1,
                                 "optional" : 1,
                                 "description" : "Set maximum tolerated downtime (in seconds) for migrations.",
                                 "type" : "number"
                              },
                              "tdf" : {
                                 "description" : "Enable/disable time drift fix.",
                                 "type" : "boolean",
                                 "default" : 0,
                                 "optional" : 1
                              },
                              "shares" : {
                                 "minimum" : 0,
                                 "default" : 1000,
                                 "maximum" : 50000,
                                 "optional" : 1,
                                 "description" : "Amount of memory shares for auto-ballooning. The larger the number is, the more memory this VM gets. Number is relative to weights of all other running VMs. Using zero disables auto-ballooning",
                                 "type" : "integer"
                              },
                              "hostpci[n]" : {
                                 "type" : "string",
                                 "description" : "Map host pci devices. HOSTPCIDEVICE syntax is:\n\n'bus:dev.func' (hexadecimal numbers)\n\nYou can us the 'lspci' command to list existing pci devices.\n\nThe 'rombar' option determines whether or not the device's ROM will be visible in the guest's memory map (default is 'on').\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n",
                                 "typetext" : "[host=]HOSTPCIDEVICE [,rombar=on|off] [,pcie=0|1] [,x-vga=on|off]",
                                 "format" : "pve-qm-hostpci",
                                 "optional" : 1
                              },
                              "hotplug" : {
                                 "default" : "network,disk,usb",
                                 "optional" : 1,
                                 "format" : "pve-hotplug-features",
                                 "description" : "Selectively enable hotplug features. This is a comma separated list of hotplug features: 'network', 'disk', 'cpu', 'memory' and 'usb'. Use '0' to disable hotplug completely. Value '1' is an alias for the default 'network,disk,usb'.",
                                 "type" : "string"
                              },
                              "keyboard" : {
                                 "enum" : [
                                    "sl",
                                    "it",
                                    "es",
                                    "fr",
                                    "de-ch",
                                    "lt",
                                    "no",
                                    "fr-ch",
                                    "de",
                                    "en-us",
                                    "pt",
                                    "pt-br",
                                    "fr-be",
                                    "fr-ca",
                                    "tr",
                                    "da",
                                    "pl",
                                    "mk",
                                    "fi",
                                    "en-gb",
                                    "nl",
                                    "ja",
                                    "is",
                                    "hu",
                                    "sv"
                                 ],
                                 "optional" : 1,
                                 "default" : "en-us",
                                 "type" : "string",
                                 "description" : "Keybord layout for vnc server. Default is read from the datacenter configuration file."
                              },
                              "description" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Description for the VM. Only used on the configuration web interface. This is saved as comment inside the configuration file."
                              },
                              "watchdog" : {
                                 "format" : "pve-qm-watchdog",
                                 "optional" : 1,
                                 "typetext" : "[[model=]i6300esb|ib700] [,[action=]reset|shutdown|poweroff|pause|debug|none]",
                                 "description" : "Create a virtual hardware watchdog device.  Once enabled (by a guest action), the watchdog must be periodically polled by an agent inside the guest or else the guest will be restarted (or execute the action specified)",
                                 "type" : "string"
                              },
                              "unique" : {
                                 "optional" : 1,
                                 "description" : "Assign a unique random ethernet address.",
                                 "requires" : "archive",
                                 "type" : "boolean"
                              },
                              "balloon" : {
                                 "type" : "integer",
                                 "description" : "Amount of target RAM for the VM in MB. Using zero disables the ballon driver.",
                                 "optional" : 1,
                                 "minimum" : 0
                              },
                              "force" : {
                                 "type" : "boolean",
                                 "requires" : "archive",
                                 "description" : "Allow to overwrite existing VM.",
                                 "optional" : 1
                              },
                              "net[n]" : {
                                 "type" : "string",
                                 "description" : "Specify network devices.\n\nMODEL is one of: e1000 e1000-82540em e1000-82544gc e1000-82545em i82551 i82557b i82559er ne2k_isa ne2k_pci pcnet rtl8139 virtio vmxnet3\n\nXX:XX:XX:XX:XX:XX should be an unique MAC address. This is\nautomatically generated if not specified.\n\nThe bridge parameter can be used to automatically add the interface to a bridge device. The Proxmox VE standard bridge is called 'vmbr0'.\n\nOption 'rate' is used to limit traffic bandwidth from and to this interface. It is specified as floating point number, unit is 'Megabytes per second'.\n\nIf you specify no bridge, we create a kvm 'user' (NATed) network device, which provides DHCP and DNS services. The following addresses are used:\n\n10.0.2.2   Gateway\n10.0.2.3   DNS Server\n10.0.2.4   SMB Server\n\nThe DHCP server assign addresses to the guest starting from 10.0.2.15.\n\n",
                                 "typetext" : "MODEL=XX:XX:XX:XX:XX:XX [,bridge=<dev>][,queues=<nbqueues>][,rate=<mbps>] [,tag=<vlanid>][,firewall=0|1],link_down=0|1]",
                                 "format" : "pve-qm-net",
                                 "optional" : 1
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              },
                              "serial[n]" : {
                                 "optional" : 1,
                                 "description" : "Create a serial device inside the VM (n is 0 to 3), and pass through a host serial device (i.e. /dev/ttyS0), or create a unix socket on the host side (use 'qm terminal' to open a terminal connection).\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n",
                                 "type" : "string",
                                 "pattern" : "(/dev/.+|socket)"
                              },
                              "args" : {
                                 "type" : "string",
                                 "description" : "Note: this option is for experts only. It allows you to pass arbitrary arguments to kvm, for example:\n\nargs: -no-reboot -no-hpet\n",
                                 "optional" : 1
                              },
                              "onboot" : {
                                 "description" : "Specifies whether a VM will be started during system bootup.",
                                 "type" : "boolean",
                                 "optional" : 1,
                                 "default" : 0
                              },
                              "scsihw" : {
                                 "description" : "scsi controller model",
                                 "type" : "string",
                                 "enum" : [
                                    "lsi",
                                    "lsi53c810",
                                    "virtio-scsi-pci",
                                    "virtio-scsi-single",
                                    "megasas",
                                    "pvscsi"
                                 ],
                                 "optional" : 1,
                                 "default" : "lsi"
                              },
                              "ostype" : {
                                 "enum" : [
                                    "other",
                                    "wxp",
                                    "w2k",
                                    "w2k3",
                                    "w2k8",
                                    "wvista",
                                    "win7",
                                    "win8",
                                    "l24",
                                    "l26",
                                    "solaris"
                                 ],
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Used to enable special optimization/features for specific\noperating systems:\n\nother  => unspecified OS\nwxp    => Microsoft Windows XP\nw2k    => Microsoft Windows 2000\nw2k3   => Microsoft Windows 2003\nw2k8   => Microsoft Windows 2008\nwvista => Microsoft Windows Vista\nwin7   => Microsoft Windows 7\nwin8   => Microsoft Windows 8/2012\nl24    => Linux 2.4 Kernel\nl26    => Linux 2.6/3.X Kernel\nsolaris => solaris/opensolaris/openindiania kernel\n\nother|l24|l26|solaris                       ... no special behaviour\nwxp|w2k|w2k3|w2k8|wvista|win7|win8  ... use --localtime switch\n"
                              },
                              "memory" : {
                                 "description" : "Amount of RAM for the VM in MB. This is the maximum available memory when you use the balloon device.",
                                 "type" : "integer",
                                 "default" : 512,
                                 "optional" : 1,
                                 "minimum" : 16
                              },
                              "freeze" : {
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Freeze CPU at startup (use 'c' monitor command to start execution)."
                              },
                              "startdate" : {
                                 "pattern" : "(now|\\d{4}-\\d{1,2}-\\d{1,2}(T\\d{1,2}:\\d{1,2}:\\d{1,2})?)",
                                 "type" : "string",
                                 "description" : "Set the initial date of the real time clock. Valid format for date are: 'now' or '2006-06-17T16:01:21' or '2006-06-17'.",
                                 "typetext" : "(now | YYYY-MM-DD | YYYY-MM-DDTHH:MM:SS)",
                                 "optional" : 1,
                                 "default" : "now"
                              },
                              "acpi" : {
                                 "optional" : 1,
                                 "default" : 1,
                                 "description" : "Enable/disable ACPI.",
                                 "type" : "boolean"
                              },
                              "autostart" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "description" : "Automatic restart after crash (currently ignored).",
                                 "type" : "boolean"
                              },
                              "storage" : {
                                 "format" : "pve-storage-id",
                                 "optional" : 1,
                                 "description" : "Default storage.",
                                 "type" : "string"
                              },
                              "lock" : {
                                 "optional" : 1,
                                 "enum" : [
                                    "migrate",
                                    "backup",
                                    "snapshot",
                                    "rollback"
                                 ],
                                 "type" : "string",
                                 "description" : "Lock/unlock the VM."
                              },
                              "pool" : {
                                 "optional" : 1,
                                 "format" : "pve-poolid",
                                 "description" : "Add the VM to the specified pool.",
                                 "type" : "string"
                              }
                           }
                        }
                     }
                  },
                  "leaf" : 0,
                  "text" : "qemu",
                  "path" : "/nodes/{node}/qemu",
                  "children" : [
                     {
                        "children" : [
                           {
                              "children" : [
                                 {
                                    "text" : "rules",
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/rules",
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "digest" : {
                                                   "type" : "string",
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40,
                                                   "optional" : 1
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "enable" : {
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iface" : {
                                                   "optional" : 1,
                                                   "minLength" : 2,
                                                   "format" : "pve-iface",
                                                   "type" : "string",
                                                   "maxLength" : 20,
                                                   "description" : "Network interface name."
                                                },
                                                "macro" : {
                                                   "optional" : 1,
                                                   "type" : "string",
                                                   "maxLength" : 128
                                                },
                                                "proto" : {
                                                   "optional" : 1,
                                                   "format" : "pve-fw-protocol-spec",
                                                   "type" : "string"
                                                },
                                                "dest" : {
                                                   "type" : "string",
                                                   "format" : "pve-fw-addr-spec",
                                                   "optional" : 1
                                                },
                                                "source" : {
                                                   "type" : "string",
                                                   "format" : "pve-fw-addr-spec",
                                                   "optional" : 1
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                },
                                                "type" : {
                                                   "optional" : 0,
                                                   "enum" : [
                                                      "in",
                                                      "out",
                                                      "group"
                                                   ],
                                                   "type" : "string"
                                                },
                                                "pos" : {
                                                   "description" : "Update rule at position <pos>.",
                                                   "type" : "integer",
                                                   "optional" : 1,
                                                   "minimum" : 0
                                                },
                                                "dport" : {
                                                   "format" : "pve-fw-port-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "action" : {
                                                   "optional" : 0,
                                                   "minLength" : 2,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string",
                                                   "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                                   "maxLength" : 20
                                                },
                                                "comment" : {
                                                   "type" : "string",
                                                   "optional" : 1
                                                },
                                                "sport" : {
                                                   "type" : "string",
                                                   "optional" : 1,
                                                   "format" : "pve-fw-port-spec"
                                                }
                                             }
                                          },
                                          "method" : "POST",
                                          "description" : "Create new rule.",
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "proxyto" : null,
                                          "name" : "create_rule",
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          }
                                       },
                                       "GET" : {
                                          "description" : "List rules.",
                                          "method" : "GET",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "vmid" : {
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer"
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                }
                                             }
                                          },
                                          "proxyto" : null,
                                          "returns" : {
                                             "type" : "array",
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {
                                                   "pos" : {
                                                      "type" : "integer"
                                                   }
                                                }
                                             },
                                             "links" : [
                                                {
                                                   "rel" : "child",
                                                   "href" : "{pos}"
                                                }
                                             ]
                                          },
                                          "name" : "get_rules",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          }
                                       }
                                    },
                                    "children" : [
                                       {
                                          "leaf" : 1,
                                          "text" : "{pos}",
                                          "path" : "/nodes/{node}/qemu/{vmid}/firewall/rules/{pos}",
                                          "info" : {
                                             "DELETE" : {
                                                "protected" : 1,
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "name" : "delete_rule",
                                                "proxyto" : null,
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "description" : "Delete rule.",
                                                "method" : "DELETE",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "vmid" : {
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer"
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "digest" : {
                                                         "optional" : 1,
                                                         "maxLength" : 40,
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "type" : "string"
                                                      },
                                                      "pos" : {
                                                         "optional" : 1,
                                                         "minimum" : 0,
                                                         "type" : "integer",
                                                         "description" : "Update rule at position <pos>."
                                                      }
                                                   }
                                                }
                                             },
                                             "PUT" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "update_rule",
                                                "proxyto" : null,
                                                "description" : "Modify rule data.",
                                                "method" : "PUT",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "type" : {
                                                         "enum" : [
                                                            "in",
                                                            "out",
                                                            "group"
                                                         ],
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "type" : "string",
                                                         "format" : "pve-node"
                                                      },
                                                      "moveto" : {
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                                         "type" : "integer"
                                                      },
                                                      "digest" : {
                                                         "optional" : 1,
                                                         "type" : "string",
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer",
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid"
                                                      },
                                                      "macro" : {
                                                         "maxLength" : 128,
                                                         "type" : "string",
                                                         "optional" : 1
                                                      },
                                                      "pos" : {
                                                         "type" : "integer",
                                                         "description" : "Update rule at position <pos>.",
                                                         "minimum" : 0,
                                                         "optional" : 1
                                                      },
                                                      "source" : {
                                                         "type" : "string",
                                                         "format" : "pve-fw-addr-spec",
                                                         "optional" : 1
                                                      },
                                                      "action" : {
                                                         "optional" : 1,
                                                         "minLength" : 2,
                                                         "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                                         "maxLength" : 20,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "dport" : {
                                                         "format" : "pve-fw-port-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "sport" : {
                                                         "optional" : 1,
                                                         "format" : "pve-fw-port-spec",
                                                         "type" : "string"
                                                      },
                                                      "comment" : {
                                                         "type" : "string",
                                                         "optional" : 1
                                                      },
                                                      "enable" : {
                                                         "type" : "integer",
                                                         "minimum" : 0,
                                                         "optional" : 1
                                                      },
                                                      "iface" : {
                                                         "type" : "string",
                                                         "maxLength" : 20,
                                                         "description" : "Network interface name.",
                                                         "minLength" : 2,
                                                         "optional" : 1,
                                                         "format" : "pve-iface"
                                                      },
                                                      "delete" : {
                                                         "format" : "pve-configid-list",
                                                         "optional" : 1,
                                                         "description" : "A list of settings you want to delete.",
                                                         "type" : "string"
                                                      },
                                                      "dest" : {
                                                         "optional" : 1,
                                                         "format" : "pve-fw-addr-spec",
                                                         "type" : "string"
                                                      },
                                                      "proto" : {
                                                         "type" : "string",
                                                         "optional" : 1,
                                                         "format" : "pve-fw-protocol-spec"
                                                      }
                                                   }
                                                }
                                             },
                                             "GET" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "vmid" : {
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid"
                                                      },
                                                      "pos" : {
                                                         "optional" : 1,
                                                         "minimum" : 0,
                                                         "type" : "integer",
                                                         "description" : "Update rule at position <pos>."
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "type" : "string",
                                                         "format" : "pve-node"
                                                      }
                                                   }
                                                },
                                                "name" : "get_rule",
                                                "proxyto" : null,
                                                "returns" : {
                                                   "type" : "object",
                                                   "properties" : {
                                                      "pos" : {
                                                         "type" : "integer"
                                                      }
                                                   }
                                                },
                                                "description" : "Get single rule data.",
                                                "method" : "GET"
                                             }
                                          }
                                       }
                                    ]
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "name" : "create_alias",
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "vmid" : {
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "cidr" : {
                                                   "description" : "Network/IP specification in CIDR format.",
                                                   "type" : "string",
                                                   "format" : "IPorCIDR"
                                                },
                                                "comment" : {
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "name" : {
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string",
                                                   "description" : "Alias name.",
                                                   "maxLength" : 64,
                                                   "minLength" : 2
                                                }
                                             }
                                          },
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "method" : "POST",
                                          "description" : "Create IP or Network Alias."
                                       },
                                       "GET" : {
                                          "method" : "GET",
                                          "description" : "List aliases",
                                          "name" : "get_aliases",
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "name" : {
                                                      "type" : "string"
                                                   },
                                                   "digest" : {
                                                      "type" : "string",
                                                      "maxLength" : 40,
                                                      "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                      "optional" : 0
                                                   },
                                                   "cidr" : {
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "type" : "array",
                                             "links" : [
                                                {
                                                   "href" : "{name}",
                                                   "rel" : "child"
                                                }
                                             ]
                                          },
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "vmid" : {
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer"
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          }
                                       }
                                    },
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/aliases",
                                    "leaf" : 0,
                                    "text" : "aliases",
                                    "children" : [
                                       {
                                          "text" : "{name}",
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/qemu/{vmid}/firewall/aliases/{name}",
                                          "info" : {
                                             "GET" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "returns" : {
                                                   "type" : "object"
                                                },
                                                "name" : "read_alias",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "name" : {
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "maxLength" : 64,
                                                         "description" : "Alias name.",
                                                         "minLength" : 2
                                                      },
                                                      "vmid" : {
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "type" : "string",
                                                         "format" : "pve-node"
                                                      }
                                                   }
                                                },
                                                "method" : "GET",
                                                "description" : "Read alias."
                                             },
                                             "PUT" : {
                                                "description" : "Update IP or Network alias.",
                                                "method" : "PUT",
                                                "parameters" : {
                                                   "properties" : {
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "type" : "string",
                                                         "format" : "pve-node"
                                                      },
                                                      "digest" : {
                                                         "optional" : 1,
                                                         "type" : "string",
                                                         "maxLength" : 40,
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications."
                                                      },
                                                      "vmid" : {
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid",
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM."
                                                      },
                                                      "cidr" : {
                                                         "description" : "Network/IP specification in CIDR format.",
                                                         "type" : "string",
                                                         "format" : "IPorCIDR"
                                                      },
                                                      "rename" : {
                                                         "description" : "Rename an existing alias.",
                                                         "maxLength" : 64,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string",
                                                         "minLength" : 2,
                                                         "optional" : 1
                                                      },
                                                      "comment" : {
                                                         "type" : "string",
                                                         "optional" : 1
                                                      },
                                                      "name" : {
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string",
                                                         "description" : "Alias name.",
                                                         "maxLength" : 64
                                                      }
                                                   },
                                                   "additionalProperties" : 0
                                                },
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "update_alias",
                                                "protected" : 1,
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                }
                                             },
                                             "DELETE" : {
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "remove_alias",
                                                "parameters" : {
                                                   "properties" : {
                                                      "digest" : {
                                                         "optional" : 1,
                                                         "maxLength" : 40,
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "type" : "string",
                                                         "format" : "pve-node"
                                                      },
                                                      "name" : {
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "maxLength" : 64,
                                                         "description" : "Alias name.",
                                                         "minLength" : 2
                                                      }
                                                   },
                                                   "additionalProperties" : 0
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "method" : "DELETE",
                                                "description" : "Remove IP or Network alias."
                                             }
                                          }
                                       }
                                    ]
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "method" : "GET",
                                          "description" : "List IPSets",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "links" : [
                                                {
                                                   "href" : "{name}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array",
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {
                                                   "name" : {
                                                      "minLength" : 2,
                                                      "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                      "type" : "string",
                                                      "description" : "IP set name.",
                                                      "maxLength" : 64
                                                   },
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "digest" : {
                                                      "type" : "string",
                                                      "maxLength" : 40,
                                                      "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                      "optional" : 0
                                                   }
                                                }
                                             }
                                          },
                                          "name" : "ipset_index",
                                          "parameters" : {
                                             "properties" : {
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                }
                                             },
                                             "additionalProperties" : 0
                                          }
                                       },
                                       "POST" : {
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "digest" : {
                                                   "type" : "string",
                                                   "maxLength" : 40,
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "optional" : 1
                                                },
                                                "vmid" : {
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer"
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                },
                                                "comment" : {
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "rename" : {
                                                   "maxLength" : 64,
                                                   "description" : "Rename an existing IPSet. You can set 'rename' to the same value as 'name' to update the 'comment' of an existing IPSet.",
                                                   "type" : "string",
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "optional" : 1,
                                                   "minLength" : 2
                                                },
                                                "name" : {
                                                   "description" : "IP set name.",
                                                   "maxLength" : 64,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string",
                                                   "minLength" : 2
                                                }
                                             }
                                          },
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "name" : "create_ipset",
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "description" : "Create new IPSet",
                                          "method" : "POST"
                                       }
                                    },
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/ipset",
                                    "leaf" : 0,
                                    "text" : "ipset",
                                    "children" : [
                                       {
                                          "children" : [
                                             {
                                                "text" : "{cidr}",
                                                "leaf" : 1,
                                                "path" : "/nodes/{node}/qemu/{vmid}/firewall/ipset/{name}/{cidr}",
                                                "info" : {
                                                   "DELETE" : {
                                                      "method" : "DELETE",
                                                      "description" : "Remove IP or Network from IPSet.",
                                                      "protected" : 1,
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Config.Network"
                                                            ]
                                                         ]
                                                      },
                                                      "returns" : {
                                                         "type" : "null"
                                                      },
                                                      "name" : "remove_ip",
                                                      "parameters" : {
                                                         "properties" : {
                                                            "cidr" : {
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string",
                                                               "description" : "Network/IP specification in CIDR format."
                                                            },
                                                            "digest" : {
                                                               "optional" : 1,
                                                               "type" : "string",
                                                               "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                               "maxLength" : 40
                                                            },
                                                            "node" : {
                                                               "format" : "pve-node",
                                                               "description" : "The cluster node name.",
                                                               "type" : "string"
                                                            },
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "type" : "integer",
                                                               "minimum" : 1,
                                                               "format" : "pve-vmid"
                                                            },
                                                            "name" : {
                                                               "type" : "string",
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "maxLength" : 64,
                                                               "description" : "IP set name.",
                                                               "minLength" : 2
                                                            }
                                                         },
                                                         "additionalProperties" : 0
                                                      }
                                                   },
                                                   "PUT" : {
                                                      "method" : "PUT",
                                                      "description" : "Update IP or Network settings",
                                                      "name" : "update_ip",
                                                      "returns" : {
                                                         "type" : "null"
                                                      },
                                                      "parameters" : {
                                                         "additionalProperties" : 0,
                                                         "properties" : {
                                                            "name" : {
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string",
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2
                                                            },
                                                            "comment" : {
                                                               "type" : "string",
                                                               "optional" : 1
                                                            },
                                                            "nomatch" : {
                                                               "optional" : 1,
                                                               "type" : "boolean"
                                                            },
                                                            "node" : {
                                                               "format" : "pve-node",
                                                               "description" : "The cluster node name.",
                                                               "type" : "string"
                                                            },
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "type" : "integer",
                                                               "minimum" : 1,
                                                               "format" : "pve-vmid"
                                                            },
                                                            "digest" : {
                                                               "type" : "string",
                                                               "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                               "maxLength" : 40,
                                                               "optional" : 1
                                                            },
                                                            "cidr" : {
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string",
                                                               "description" : "Network/IP specification in CIDR format."
                                                            }
                                                         }
                                                      },
                                                      "protected" : 1,
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Config.Network"
                                                            ]
                                                         ]
                                                      }
                                                   },
                                                   "GET" : {
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Audit"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "name" : "read_ip",
                                                      "returns" : {
                                                         "type" : "object"
                                                      },
                                                      "parameters" : {
                                                         "properties" : {
                                                            "name" : {
                                                               "minLength" : 2,
                                                               "maxLength" : 64,
                                                               "description" : "IP set name.",
                                                               "type" : "string",
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+"
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "type" : "string",
                                                               "format" : "pve-node"
                                                            },
                                                            "vmid" : {
                                                               "minimum" : 1,
                                                               "format" : "pve-vmid",
                                                               "description" : "The (unique) ID of the VM.",
                                                               "type" : "integer"
                                                            },
                                                            "cidr" : {
                                                               "type" : "string",
                                                               "description" : "Network/IP specification in CIDR format.",
                                                               "format" : "IPorCIDRorAlias"
                                                            }
                                                         },
                                                         "additionalProperties" : 0
                                                      },
                                                      "method" : "GET",
                                                      "description" : "Read IP or Network settings from IPSet."
                                                   }
                                                }
                                             }
                                          ],
                                          "path" : "/nodes/{node}/qemu/{vmid}/firewall/ipset/{name}",
                                          "text" : "{name}",
                                          "leaf" : 0,
                                          "info" : {
                                             "GET" : {
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "description" : "The cluster node name.",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer",
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid"
                                                      },
                                                      "name" : {
                                                         "maxLength" : 64,
                                                         "description" : "IP set name.",
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "minLength" : 2
                                                      }
                                                   }
                                                },
                                                "name" : "get_ipset",
                                                "returns" : {
                                                   "links" : [
                                                      {
                                                         "href" : "{cidr}",
                                                         "rel" : "child"
                                                      }
                                                   ],
                                                   "items" : {
                                                      "properties" : {
                                                         "nomatch" : {
                                                            "optional" : 1,
                                                            "type" : "boolean"
                                                         },
                                                         "digest" : {
                                                            "maxLength" : 40,
                                                            "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                            "type" : "string",
                                                            "optional" : 0
                                                         },
                                                         "cidr" : {
                                                            "type" : "string"
                                                         },
                                                         "comment" : {
                                                            "optional" : 1,
                                                            "type" : "string"
                                                         }
                                                      },
                                                      "type" : "object"
                                                   },
                                                   "type" : "array"
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "description" : "List IPSet content",
                                                "method" : "GET"
                                             },
                                             "POST" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "name" : "create_ip",
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "parameters" : {
                                                   "properties" : {
                                                      "nomatch" : {
                                                         "optional" : 1,
                                                         "type" : "boolean"
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "description" : "The cluster node name.",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1
                                                      },
                                                      "cidr" : {
                                                         "description" : "Network/IP specification in CIDR format.",
                                                         "type" : "string",
                                                         "format" : "IPorCIDRorAlias"
                                                      },
                                                      "name" : {
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "maxLength" : 64,
                                                         "description" : "IP set name.",
                                                         "minLength" : 2
                                                      },
                                                      "comment" : {
                                                         "type" : "string",
                                                         "optional" : 1
                                                      }
                                                   },
                                                   "additionalProperties" : 0
                                                },
                                                "method" : "POST",
                                                "description" : "Add IP or Network to IPSet."
                                             },
                                             "DELETE" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "vmid" : {
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer"
                                                      },
                                                      "node" : {
                                                         "type" : "string",
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node"
                                                      },
                                                      "name" : {
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string",
                                                         "description" : "IP set name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2
                                                      }
                                                   }
                                                },
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "delete_ipset",
                                                "description" : "Delete IPSet",
                                                "method" : "DELETE"
                                             }
                                          }
                                       }
                                    ]
                                 },
                                 {
                                    "text" : "options",
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/options",
                                    "info" : {
                                       "GET" : {
                                          "method" : "GET",
                                          "description" : "Get VM firewall options.",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "object",
                                             "properties" : {
                                                "log_level_out" : {
                                                   "type" : "string",
                                                   "description" : "Log level for outgoing traffic.",
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ]
                                                },
                                                "enable" : {
                                                   "optional" : 1,
                                                   "description" : "Enable host firewall rules.",
                                                   "type" : "boolean"
                                                },
                                                "log_level_in" : {
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "description" : "Log level for incoming traffic.",
                                                   "type" : "string"
                                                },
                                                "dhcp" : {
                                                   "optional" : 1,
                                                   "description" : "Enable DHCP.",
                                                   "type" : "boolean"
                                                },
                                                "policy_in" : {
                                                   "type" : "string",
                                                   "description" : "Input policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1
                                                },
                                                "macfilter" : {
                                                   "description" : "Enable/disable MAC address filter.",
                                                   "type" : "boolean",
                                                   "optional" : 1
                                                },
                                                "policy_out" : {
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "description" : "Output policy.",
                                                   "type" : "string"
                                                }
                                             }
                                          },
                                          "name" : "get_options",
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                }
                                             },
                                             "additionalProperties" : 0
                                          }
                                       },
                                       "PUT" : {
                                          "description" : "Set Firewall options.",
                                          "method" : "PUT",
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "proxyto" : "node",
                                          "name" : "set_options",
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "parameters" : {
                                             "properties" : {
                                                "macfilter" : {
                                                   "optional" : 1,
                                                   "type" : "boolean",
                                                   "description" : "Enable/disable MAC address filter."
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "policy_in" : {
                                                   "description" : "Input policy.",
                                                   "type" : "string",
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ]
                                                },
                                                "dhcp" : {
                                                   "optional" : 1,
                                                   "type" : "boolean",
                                                   "description" : "Enable DHCP."
                                                },
                                                "delete" : {
                                                   "description" : "A list of settings you want to delete.",
                                                   "type" : "string",
                                                   "optional" : 1,
                                                   "format" : "pve-configid-list"
                                                },
                                                "policy_out" : {
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string",
                                                   "description" : "Output policy."
                                                },
                                                "digest" : {
                                                   "optional" : 1,
                                                   "type" : "string",
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                },
                                                "log_level_out" : {
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "type" : "string",
                                                   "description" : "Log level for outgoing traffic."
                                                },
                                                "log_level_in" : {
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "description" : "Log level for incoming traffic.",
                                                   "type" : "string"
                                                },
                                                "enable" : {
                                                   "optional" : 1,
                                                   "type" : "boolean",
                                                   "description" : "Enable host firewall rules."
                                                }
                                             },
                                             "additionalProperties" : 0
                                          }
                                       }
                                    }
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "limit" : {
                                                   "type" : "integer",
                                                   "optional" : 1,
                                                   "minimum" : 0
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "start" : {
                                                   "optional" : 1,
                                                   "minimum" : 0,
                                                   "type" : "integer"
                                                }
                                             }
                                          },
                                          "description" : "Read firewall log",
                                          "method" : "GET",
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Console"
                                                ]
                                             ]
                                          },
                                          "name" : "log",
                                          "proxyto" : "node",
                                          "returns" : {
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {
                                                   "n" : {
                                                      "type" : "integer",
                                                      "description" : "Line number"
                                                   },
                                                   "t" : {
                                                      "type" : "string",
                                                      "description" : "Line text"
                                                   }
                                                }
                                             },
                                             "type" : "array"
                                          }
                                       }
                                    },
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/log",
                                    "text" : "log",
                                    "leaf" : 1
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "type" : {
                                                   "type" : "string",
                                                   "description" : "Only list references of specified type.",
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "alias",
                                                      "ipset"
                                                   ]
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                }
                                             }
                                          },
                                          "returns" : {
                                             "type" : "array",
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {
                                                   "type" : {
                                                      "type" : "string",
                                                      "enum" : [
                                                         "alias",
                                                         "ipset"
                                                      ]
                                                   },
                                                   "name" : {
                                                      "type" : "string"
                                                   },
                                                   "comment" : {
                                                      "type" : "string",
                                                      "optional" : 1
                                                   }
                                                }
                                             }
                                          },
                                          "name" : "refs",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "description" : "Lists possible IPSet/Alias reference which are allowed in source/dest properties.",
                                          "method" : "GET"
                                       }
                                    },
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/refs",
                                    "leaf" : 1,
                                    "text" : "refs"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "returns" : {
                                       "links" : [
                                          {
                                             "href" : "{name}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "items" : {
                                          "type" : "object",
                                          "properties" : {}
                                       },
                                       "type" : "array"
                                    },
                                    "name" : "index",
                                    "parameters" : {
                                       "properties" : {
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "permissions" : {
                                       "user" : "all"
                                    },
                                    "method" : "GET",
                                    "description" : "Directory index."
                                 }
                              },
                              "path" : "/nodes/{node}/qemu/{vmid}/firewall",
                              "text" : "firewall",
                              "leaf" : 0
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read VM RRD statistics (returns PNG)",
                                    "method" : "GET",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "timeframe" : {
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string",
                                             "description" : "Specify the time frame you are interested in."
                                          },
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "type" : "string",
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1
                                          },
                                          "ds" : {
                                             "description" : "The list of datasources you want to display.",
                                             "type" : "string",
                                             "format" : "pve-configid-list"
                                          }
                                       }
                                    },
                                    "returns" : {
                                       "type" : "object",
                                       "properties" : {
                                          "filename" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "name" : "rrd"
                                 }
                              },
                              "text" : "rrd",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/rrd"
                           },
                           {
                              "text" : "rrddata",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/rrddata",
                              "info" : {
                                 "GET" : {
                                    "name" : "rrddata",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "type" : "array"
                                    },
                                    "parameters" : {
                                       "properties" : {
                                          "timeframe" : {
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "description" : "Specify the time frame you are interested in.",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "vmid" : {
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer"
                                          },
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "type" : "string",
                                             "optional" : 1,
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ]
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "method" : "GET",
                                    "description" : "Read VM RRD statistics"
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Set virtual machine options (asynchrounous API).",
                                    "method" : "POST",
                                    "returns" : {
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "name" : "update_vm_async",
                                    "proxyto" : "node",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk",
                                             "VM.Config.CDROM",
                                             "VM.Config.CPU",
                                             "VM.Config.Memory",
                                             "VM.Config.Network",
                                             "VM.Config.HWType",
                                             "VM.Config.Options"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "skiplock" : {
                                             "description" : "Ignore locks - only root is allowed to use this option.",
                                             "type" : "boolean",
                                             "optional" : 1
                                          },
                                          "hostpci[n]" : {
                                             "description" : "Map host pci devices. HOSTPCIDEVICE syntax is:\n\n'bus:dev.func' (hexadecimal numbers)\n\nYou can us the 'lspci' command to list existing pci devices.\n\nThe 'rombar' option determines whether or not the device's ROM will be visible in the guest's memory map (default is 'on').\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-qm-hostpci",
                                             "typetext" : "[host=]HOSTPCIDEVICE [,rombar=on|off] [,pcie=0|1] [,x-vga=on|off]"
                                          },
                                          "shares" : {
                                             "type" : "integer",
                                             "description" : "Amount of memory shares for auto-ballooning. The larger the number is, the more memory this VM gets. Number is relative to weights of all other running VMs. Using zero disables auto-ballooning",
                                             "maximum" : 50000,
                                             "default" : 1000,
                                             "optional" : 1,
                                             "minimum" : 0
                                          },
                                          "tdf" : {
                                             "type" : "boolean",
                                             "description" : "Enable/disable time drift fix.",
                                             "optional" : 1,
                                             "default" : 0
                                          },
                                          "migrate_downtime" : {
                                             "default" : 0.1,
                                             "optional" : 1,
                                             "minimum" : 0,
                                             "description" : "Set maximum tolerated downtime (in seconds) for migrations.",
                                             "type" : "number"
                                          },
                                          "unused[n]" : {
                                             "description" : "Reference to unused volumes.",
                                             "type" : "string",
                                             "format" : "pve-volume-id",
                                             "optional" : 1
                                          },
                                          "net[n]" : {
                                             "type" : "string",
                                             "description" : "Specify network devices.\n\nMODEL is one of: e1000 e1000-82540em e1000-82544gc e1000-82545em i82551 i82557b i82559er ne2k_isa ne2k_pci pcnet rtl8139 virtio vmxnet3\n\nXX:XX:XX:XX:XX:XX should be an unique MAC address. This is\nautomatically generated if not specified.\n\nThe bridge parameter can be used to automatically add the interface to a bridge device. The Proxmox VE standard bridge is called 'vmbr0'.\n\nOption 'rate' is used to limit traffic bandwidth from and to this interface. It is specified as floating point number, unit is 'Megabytes per second'.\n\nIf you specify no bridge, we create a kvm 'user' (NATed) network device, which provides DHCP and DNS services. The following addresses are used:\n\n10.0.2.2   Gateway\n10.0.2.3   DNS Server\n10.0.2.4   SMB Server\n\nThe DHCP server assign addresses to the guest starting from 10.0.2.15.\n\n",
                                             "typetext" : "MODEL=XX:XX:XX:XX:XX:XX [,bridge=<dev>][,queues=<nbqueues>][,rate=<mbps>] [,tag=<vlanid>][,firewall=0|1],link_down=0|1]",
                                             "optional" : 1,
                                             "format" : "pve-qm-net"
                                          },
                                          "force" : {
                                             "optional" : 1,
                                             "requires" : "delete",
                                             "description" : "Force physical removal. Without this, we simple remove the disk from the config file and create an additional configuration entry called 'unused[n]', which contains the volume ID. Unlink of unused[n] always cause physical removal.",
                                             "type" : "boolean"
                                          },
                                          "balloon" : {
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "description" : "Amount of target RAM for the VM in MB. Using zero disables the ballon driver.",
                                             "type" : "integer"
                                          },
                                          "description" : {
                                             "type" : "string",
                                             "description" : "Description for the VM. Only used on the configuration web interface. This is saved as comment inside the configuration file.",
                                             "optional" : 1
                                          },
                                          "watchdog" : {
                                             "description" : "Create a virtual hardware watchdog device.  Once enabled (by a guest action), the watchdog must be periodically polled by an agent inside the guest or else the guest will be restarted (or execute the action specified)",
                                             "type" : "string",
                                             "format" : "pve-qm-watchdog",
                                             "optional" : 1,
                                             "typetext" : "[[model=]i6300esb|ib700] [,[action=]reset|shutdown|poweroff|pause|debug|none]"
                                          },
                                          "keyboard" : {
                                             "enum" : [
                                                "sl",
                                                "it",
                                                "es",
                                                "fr",
                                                "de-ch",
                                                "lt",
                                                "no",
                                                "fr-ch",
                                                "de",
                                                "en-us",
                                                "pt",
                                                "pt-br",
                                                "fr-be",
                                                "fr-ca",
                                                "tr",
                                                "da",
                                                "pl",
                                                "mk",
                                                "fi",
                                                "en-gb",
                                                "nl",
                                                "ja",
                                                "is",
                                                "hu",
                                                "sv"
                                             ],
                                             "default" : "en-us",
                                             "optional" : 1,
                                             "description" : "Keybord layout for vnc server. Default is read from the datacenter configuration file.",
                                             "type" : "string"
                                          },
                                          "hotplug" : {
                                             "description" : "Selectively enable hotplug features. This is a comma separated list of hotplug features: 'network', 'disk', 'cpu', 'memory' and 'usb'. Use '0' to disable hotplug completely. Value '1' is an alias for the default 'network,disk,usb'.",
                                             "type" : "string",
                                             "default" : "network,disk,usb",
                                             "optional" : 1,
                                             "format" : "pve-hotplug-features"
                                          },
                                          "freeze" : {
                                             "type" : "boolean",
                                             "description" : "Freeze CPU at startup (use 'c' monitor command to start execution).",
                                             "optional" : 1
                                          },
                                          "memory" : {
                                             "default" : 512,
                                             "optional" : 1,
                                             "minimum" : 16,
                                             "description" : "Amount of RAM for the VM in MB. This is the maximum available memory when you use the balloon device.",
                                             "type" : "integer"
                                          },
                                          "ostype" : {
                                             "description" : "Used to enable special optimization/features for specific\noperating systems:\n\nother  => unspecified OS\nwxp    => Microsoft Windows XP\nw2k    => Microsoft Windows 2000\nw2k3   => Microsoft Windows 2003\nw2k8   => Microsoft Windows 2008\nwvista => Microsoft Windows Vista\nwin7   => Microsoft Windows 7\nwin8   => Microsoft Windows 8/2012\nl24    => Linux 2.4 Kernel\nl26    => Linux 2.6/3.X Kernel\nsolaris => solaris/opensolaris/openindiania kernel\n\nother|l24|l26|solaris                       ... no special behaviour\nwxp|w2k|w2k3|w2k8|wvista|win7|win8  ... use --localtime switch\n",
                                             "type" : "string",
                                             "optional" : 1,
                                             "enum" : [
                                                "other",
                                                "wxp",
                                                "w2k",
                                                "w2k3",
                                                "w2k8",
                                                "wvista",
                                                "win7",
                                                "win8",
                                                "l24",
                                                "l26",
                                                "solaris"
                                             ]
                                          },
                                          "scsihw" : {
                                             "description" : "scsi controller model",
                                             "type" : "string",
                                             "enum" : [
                                                "lsi",
                                                "lsi53c810",
                                                "virtio-scsi-pci",
                                                "virtio-scsi-single",
                                                "megasas",
                                                "pvscsi"
                                             ],
                                             "optional" : 1,
                                             "default" : "lsi"
                                          },
                                          "onboot" : {
                                             "type" : "boolean",
                                             "description" : "Specifies whether a VM will be started during system bootup.",
                                             "default" : 0,
                                             "optional" : 1
                                          },
                                          "args" : {
                                             "description" : "Note: this option is for experts only. It allows you to pass arbitrary arguments to kvm, for example:\n\nargs: -no-reboot -no-hpet\n",
                                             "type" : "string",
                                             "optional" : 1
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          },
                                          "serial[n]" : {
                                             "optional" : 1,
                                             "pattern" : "(/dev/.+|socket)",
                                             "type" : "string",
                                             "description" : "Create a serial device inside the VM (n is 0 to 3), and pass through a host serial device (i.e. /dev/ttyS0), or create a unix socket on the host side (use 'qm terminal' to open a terminal connection).\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n"
                                          },
                                          "lock" : {
                                             "enum" : [
                                                "migrate",
                                                "backup",
                                                "snapshot",
                                                "rollback"
                                             ],
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "Lock/unlock the VM."
                                          },
                                          "acpi" : {
                                             "type" : "boolean",
                                             "description" : "Enable/disable ACPI.",
                                             "optional" : 1,
                                             "default" : 1
                                          },
                                          "autostart" : {
                                             "description" : "Automatic restart after crash (currently ignored).",
                                             "type" : "boolean",
                                             "optional" : 1,
                                             "default" : 0
                                          },
                                          "startdate" : {
                                             "default" : "now",
                                             "optional" : 1,
                                             "typetext" : "(now | YYYY-MM-DD | YYYY-MM-DDTHH:MM:SS)",
                                             "description" : "Set the initial date of the real time clock. Valid format for date are: 'now' or '2006-06-17T16:01:21' or '2006-06-17'.",
                                             "type" : "string",
                                             "pattern" : "(now|\\d{4}-\\d{1,2}-\\d{1,2}(T\\d{1,2}:\\d{1,2}:\\d{1,2})?)"
                                          },
                                          "virtio[n]" : {
                                             "type" : "string",
                                             "description" : "Use volume as VIRTIO hard disk (n is 0 to 15).",
                                             "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads]  [,discard=ignore|on] [,iothread=on] [,serial=serial]",
                                             "optional" : 1,
                                             "format" : "pve-qm-drive"
                                          },
                                          "numa" : {
                                             "type" : "boolean",
                                             "description" : "Enable/disable Numa.",
                                             "optional" : 1,
                                             "default" : 0
                                          },
                                          "background_delay" : {
                                             "description" : "Time to wait for the task to finish. We return 'null' if the task finish within that time.",
                                             "type" : "integer",
                                             "optional" : 1,
                                             "maximum" : 30,
                                             "minimum" : 1
                                          },
                                          "ide[n]" : {
                                             "type" : "string",
                                             "description" : "Use volume as IDE hard disk or CD-ROM (n is 0 to 3).",
                                             "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads] [,discard=ignore|on] [,serial=serial][,model=model]",
                                             "format" : "pve-qm-drive",
                                             "optional" : 1
                                          },
                                          "vga" : {
                                             "optional" : 1,
                                             "enum" : [
                                                "std",
                                                "cirrus",
                                                "vmware",
                                                "qxl",
                                                "serial0",
                                                "serial1",
                                                "serial2",
                                                "serial3",
                                                "qxl2",
                                                "qxl3",
                                                "qxl4"
                                             ],
                                             "type" : "string",
                                             "description" : "Select VGA type. If you want to use high resolution modes (>= 1280x1024x16) then you should use option 'std' or 'vmware'. Default is 'std' for win8/win7/w2k8, and 'cirrur' for other OS types. Option 'qxl' enables the SPICE display sever. You can also run without any graphic card using a serial devive as terminal."
                                          },
                                          "cpulimit" : {
                                             "minimum" : 0,
                                             "maximum" : 128,
                                             "default" : 0,
                                             "optional" : 1,
                                             "description" : "Limit of CPU usage. Note if the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit.",
                                             "type" : "number"
                                          },
                                          "delete" : {
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "A list of settings you want to delete."
                                          },
                                          "cdrom" : {
                                             "type" : "string",
                                             "description" : "This is an alias for option -ide2",
                                             "typetext" : "volume",
                                             "format" : "pve-qm-drive",
                                             "optional" : 1
                                          },
                                          "tablet" : {
                                             "default" : 1,
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "description" : "Enable/disable the usb tablet device. This device is usually needed to allow absolute mouse positioning with VNC. Else the mouse runs out of sync with normal VNC clients. If you're running lots of console-only guests on one host, you may consider disabling this to save some context switches. This is turned of by default if you use spice (vga=qxl)."
                                          },
                                          "name" : {
                                             "description" : "Set a name for the VM. Only used on the configuration web interface.",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "dns-name"
                                          },
                                          "kvm" : {
                                             "default" : 1,
                                             "optional" : 1,
                                             "description" : "Enable/disable KVM hardware virtualization.",
                                             "type" : "boolean"
                                          },
                                          "reboot" : {
                                             "description" : "Allow reboot. If set to '0' the VM exit on reboot.",
                                             "type" : "boolean",
                                             "optional" : 1,
                                             "default" : 1
                                          },
                                          "bootdisk" : {
                                             "description" : "Enable booting from specified disk.",
                                             "pattern" : "(ide|sata|scsi|virtio)\\d+",
                                             "type" : "string",
                                             "format" : "pve-qm-bootdisk",
                                             "optional" : 1
                                          },
                                          "revert" : {
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "description" : "Revert a pending change.",
                                             "type" : "string"
                                          },
                                          "vcpus" : {
                                             "minimum" : 1,
                                             "default" : 0,
                                             "optional" : 1,
                                             "description" : "Number of hotplugged vcpus.",
                                             "type" : "integer"
                                          },
                                          "cpu" : {
                                             "default" : "kvm64",
                                             "optional" : 1,
                                             "enum" : [
                                                "486",
                                                "athlon",
                                                "pentium",
                                                "pentium2",
                                                "pentium3",
                                                "coreduo",
                                                "core2duo",
                                                "kvm32",
                                                "kvm64",
                                                "qemu32",
                                                "qemu64",
                                                "phenom",
                                                "Conroe",
                                                "Penryn",
                                                "Nehalem",
                                                "Westmere",
                                                "SandyBridge",
                                                "IvyBridge",
                                                "Haswell",
                                                "Broadwell",
                                                "Opteron_G1",
                                                "Opteron_G2",
                                                "Opteron_G3",
                                                "Opteron_G4",
                                                "Opteron_G5",
                                                "host"
                                             ],
                                             "description" : "Emulated CPU type.",
                                             "type" : "string"
                                          },
                                          "boot" : {
                                             "optional" : 1,
                                             "default" : "cdn",
                                             "type" : "string",
                                             "pattern" : "[acdn]{1,4}",
                                             "description" : "Boot on floppy (a), hard disk (c), CD-ROM (d), or network (n)."
                                          },
                                          "cpuunits" : {
                                             "optional" : 1,
                                             "maximum" : 500000,
                                             "default" : 1000,
                                             "minimum" : 0,
                                             "type" : "integer",
                                             "description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0."
                                          },
                                          "scsi[n]" : {
                                             "type" : "string",
                                             "description" : "Use volume as SCSI hard disk or CD-ROM (n is 0 to 13).",
                                             "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads] [,discard=ignore|on] [,iothread=on] [,queues=<nbqueues>] [,serial=serial]",
                                             "format" : "pve-qm-drive",
                                             "optional" : 1
                                          },
                                          "cores" : {
                                             "default" : 1,
                                             "optional" : 1,
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "description" : "The number of cores per socket."
                                          },
                                          "startup" : {
                                             "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped.",
                                             "type" : "string",
                                             "format" : "pve-startup-order",
                                             "optional" : 1,
                                             "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] "
                                          },
                                          "usb[n]" : {
                                             "description" : "Configure an USB device (n is 0 to 4). This can be used to\npass-through usb devices to the guest. HOSTUSBDEVICE syntax is:\n\n'bus-port(.port)*' (decimal numbers) or\n'vendor_id:product_id' (hexadeciaml numbers)\n\nYou can use the 'lsusb -t' command to list existing usb devices.\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nThe value 'spice' can be used to add a usb redirection devices for spice.\n\n",
                                             "type" : "string",
                                             "format" : "pve-qm-usb-device",
                                             "optional" : 1,
                                             "typetext" : "host=HOSTUSBDEVICE|spice"
                                          },
                                          "template" : {
                                             "description" : "Enable/disable Template.",
                                             "type" : "boolean",
                                             "default" : 0,
                                             "optional" : 1
                                          },
                                          "sockets" : {
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "default" : 1,
                                             "type" : "integer",
                                             "description" : "The number of CPU sockets."
                                          },
                                          "agent" : {
                                             "type" : "boolean",
                                             "description" : "Enable/disable Qemu GuestAgent.",
                                             "default" : 0,
                                             "optional" : 1
                                          },
                                          "localtime" : {
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "description" : "Set the real time clock to local time. This is enabled by default if ostype indicates a Microsoft OS."
                                          },
                                          "parallel[n]" : {
                                             "optional" : 1,
                                             "description" : "Map host parallel devices (n is 0 to 2).\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n",
                                             "pattern" : "/dev/parport\\d+|/dev/usb/lp\\d+",
                                             "type" : "string"
                                          },
                                          "smp" : {
                                             "description" : "The number of CPUs. Please use option -sockets instead.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "default" : 1
                                          },
                                          "machine" : {
                                             "optional" : 1,
                                             "maxLength" : 40,
                                             "description" : "Specific the Qemu machine type.",
                                             "type" : "string",
                                             "pattern" : "(pc|pc(-i440fx)?-\\d+\\.\\d+|q35|pc-q35-\\d+\\.\\d+)"
                                          },
                                          "migrate_speed" : {
                                             "minimum" : 0,
                                             "default" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "description" : "Set maximum speed (in MB/s) for migrations. Value 0 is no limit."
                                          },
                                          "protection" : {
                                             "type" : "boolean",
                                             "description" : "Sets the protection flag of the VM. This will prevent the remove operation.",
                                             "default" : 0,
                                             "optional" : 1
                                          },
                                          "numa[n]" : {
                                             "type" : "string",
                                             "description" : "numa topology",
                                             "typetext" : "cpus=<id[-id],memory=<mb>[[,hostnodes=<id[-id]>] [,policy=<preferred|bind|interleave>]]",
                                             "format" : "pve-qm-numanode",
                                             "optional" : 1
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "digest" : {
                                             "optional" : 1,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "type" : "string"
                                          },
                                          "sata[n]" : {
                                             "description" : "Use volume as SATA hard disk or CD-ROM (n is 0 to 5).",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-qm-drive",
                                             "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads]  [,discard=ignore|on] [,serial=serial]"
                                          }
                                       }
                                    }
                                 },
                                 "PUT" : {
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk",
                                             "VM.Config.CDROM",
                                             "VM.Config.CPU",
                                             "VM.Config.Memory",
                                             "VM.Config.Network",
                                             "VM.Config.HWType",
                                             "VM.Config.Options"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "name" : "update_vm",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "proxyto" : "node",
                                    "method" : "PUT",
                                    "description" : "Set virtual machine options (synchrounous API) - You should consider using the POST method instead for any actions involving hotplug or storage allocation.",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "numa" : {
                                             "optional" : 1,
                                             "default" : 0,
                                             "type" : "boolean",
                                             "description" : "Enable/disable Numa."
                                          },
                                          "vga" : {
                                             "enum" : [
                                                "std",
                                                "cirrus",
                                                "vmware",
                                                "qxl",
                                                "serial0",
                                                "serial1",
                                                "serial2",
                                                "serial3",
                                                "qxl2",
                                                "qxl3",
                                                "qxl4"
                                             ],
                                             "optional" : 1,
                                             "description" : "Select VGA type. If you want to use high resolution modes (>= 1280x1024x16) then you should use option 'std' or 'vmware'. Default is 'std' for win8/win7/w2k8, and 'cirrur' for other OS types. Option 'qxl' enables the SPICE display sever. You can also run without any graphic card using a serial devive as terminal.",
                                             "type" : "string"
                                          },
                                          "ide[n]" : {
                                             "description" : "Use volume as IDE hard disk or CD-ROM (n is 0 to 3).",
                                             "type" : "string",
                                             "format" : "pve-qm-drive",
                                             "optional" : 1,
                                             "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads] [,discard=ignore|on] [,serial=serial][,model=model]"
                                          },
                                          "virtio[n]" : {
                                             "format" : "pve-qm-drive",
                                             "optional" : 1,
                                             "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads]  [,discard=ignore|on] [,iothread=on] [,serial=serial]",
                                             "description" : "Use volume as VIRTIO hard disk (n is 0 to 15).",
                                             "type" : "string"
                                          },
                                          "kvm" : {
                                             "type" : "boolean",
                                             "description" : "Enable/disable KVM hardware virtualization.",
                                             "optional" : 1,
                                             "default" : 1
                                          },
                                          "reboot" : {
                                             "default" : 1,
                                             "optional" : 1,
                                             "description" : "Allow reboot. If set to '0' the VM exit on reboot.",
                                             "type" : "boolean"
                                          },
                                          "bootdisk" : {
                                             "type" : "string",
                                             "pattern" : "(ide|sata|scsi|virtio)\\d+",
                                             "description" : "Enable booting from specified disk.",
                                             "format" : "pve-qm-bootdisk",
                                             "optional" : 1
                                          },
                                          "vcpus" : {
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "default" : 0,
                                             "description" : "Number of hotplugged vcpus.",
                                             "type" : "integer"
                                          },
                                          "revert" : {
                                             "type" : "string",
                                             "description" : "Revert a pending change.",
                                             "format" : "pve-configid-list",
                                             "optional" : 1
                                          },
                                          "cpulimit" : {
                                             "description" : "Limit of CPU usage. Note if the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit.",
                                             "type" : "number",
                                             "minimum" : 0,
                                             "maximum" : 128,
                                             "default" : 0,
                                             "optional" : 1
                                          },
                                          "delete" : {
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "description" : "A list of settings you want to delete.",
                                             "type" : "string"
                                          },
                                          "tablet" : {
                                             "optional" : 1,
                                             "default" : 1,
                                             "description" : "Enable/disable the usb tablet device. This device is usually needed to allow absolute mouse positioning with VNC. Else the mouse runs out of sync with normal VNC clients. If you're running lots of console-only guests on one host, you may consider disabling this to save some context switches. This is turned of by default if you use spice (vga=qxl).",
                                             "type" : "boolean"
                                          },
                                          "cdrom" : {
                                             "type" : "string",
                                             "description" : "This is an alias for option -ide2",
                                             "typetext" : "volume",
                                             "format" : "pve-qm-drive",
                                             "optional" : 1
                                          },
                                          "name" : {
                                             "description" : "Set a name for the VM. Only used on the configuration web interface.",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "dns-name"
                                          },
                                          "template" : {
                                             "description" : "Enable/disable Template.",
                                             "type" : "boolean",
                                             "optional" : 1,
                                             "default" : 0
                                          },
                                          "usb[n]" : {
                                             "typetext" : "host=HOSTUSBDEVICE|spice",
                                             "optional" : 1,
                                             "format" : "pve-qm-usb-device",
                                             "type" : "string",
                                             "description" : "Configure an USB device (n is 0 to 4). This can be used to\npass-through usb devices to the guest. HOSTUSBDEVICE syntax is:\n\n'bus-port(.port)*' (decimal numbers) or\n'vendor_id:product_id' (hexadeciaml numbers)\n\nYou can use the 'lsusb -t' command to list existing usb devices.\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nThe value 'spice' can be used to add a usb redirection devices for spice.\n\n"
                                          },
                                          "cpuunits" : {
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "default" : 1000,
                                             "maximum" : 500000,
                                             "type" : "integer",
                                             "description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0."
                                          },
                                          "cpu" : {
                                             "default" : "kvm64",
                                             "optional" : 1,
                                             "enum" : [
                                                "486",
                                                "athlon",
                                                "pentium",
                                                "pentium2",
                                                "pentium3",
                                                "coreduo",
                                                "core2duo",
                                                "kvm32",
                                                "kvm64",
                                                "qemu32",
                                                "qemu64",
                                                "phenom",
                                                "Conroe",
                                                "Penryn",
                                                "Nehalem",
                                                "Westmere",
                                                "SandyBridge",
                                                "IvyBridge",
                                                "Haswell",
                                                "Broadwell",
                                                "Opteron_G1",
                                                "Opteron_G2",
                                                "Opteron_G3",
                                                "Opteron_G4",
                                                "Opteron_G5",
                                                "host"
                                             ],
                                             "description" : "Emulated CPU type.",
                                             "type" : "string"
                                          },
                                          "boot" : {
                                             "description" : "Boot on floppy (a), hard disk (c), CD-ROM (d), or network (n).",
                                             "type" : "string",
                                             "pattern" : "[acdn]{1,4}",
                                             "default" : "cdn",
                                             "optional" : 1
                                          },
                                          "cores" : {
                                             "description" : "The number of cores per socket.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "default" : 1,
                                             "optional" : 1
                                          },
                                          "startup" : {
                                             "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] ",
                                             "optional" : 1,
                                             "format" : "pve-startup-order",
                                             "type" : "string",
                                             "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped."
                                          },
                                          "scsi[n]" : {
                                             "optional" : 1,
                                             "format" : "pve-qm-drive",
                                             "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads] [,discard=ignore|on] [,iothread=on] [,queues=<nbqueues>] [,serial=serial]",
                                             "description" : "Use volume as SCSI hard disk or CD-ROM (n is 0 to 13).",
                                             "type" : "string"
                                          },
                                          "smp" : {
                                             "default" : 1,
                                             "optional" : 1,
                                             "minimum" : 1,
                                             "description" : "The number of CPUs. Please use option -sockets instead.",
                                             "type" : "integer"
                                          },
                                          "machine" : {
                                             "maxLength" : 40,
                                             "description" : "Specific the Qemu machine type.",
                                             "type" : "string",
                                             "pattern" : "(pc|pc(-i440fx)?-\\d+\\.\\d+|q35|pc-q35-\\d+\\.\\d+)",
                                             "optional" : 1
                                          },
                                          "parallel[n]" : {
                                             "optional" : 1,
                                             "type" : "string",
                                             "pattern" : "/dev/parport\\d+|/dev/usb/lp\\d+",
                                             "description" : "Map host parallel devices (n is 0 to 2).\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n"
                                          },
                                          "migrate_speed" : {
                                             "minimum" : 0,
                                             "default" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "description" : "Set maximum speed (in MB/s) for migrations. Value 0 is no limit."
                                          },
                                          "numa[n]" : {
                                             "typetext" : "cpus=<id[-id],memory=<mb>[[,hostnodes=<id[-id]>] [,policy=<preferred|bind|interleave>]]",
                                             "format" : "pve-qm-numanode",
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "numa topology"
                                          },
                                          "protection" : {
                                             "description" : "Sets the protection flag of the VM. This will prevent the remove operation.",
                                             "type" : "boolean",
                                             "optional" : 1,
                                             "default" : 0
                                          },
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer"
                                          },
                                          "digest" : {
                                             "type" : "string",
                                             "maxLength" : 40,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "optional" : 1
                                          },
                                          "sata[n]" : {
                                             "description" : "Use volume as SATA hard disk or CD-ROM (n is 0 to 5).",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-qm-drive",
                                             "typetext" : "[volume=]volume,] [,media=cdrom|disk] [,cyls=c,heads=h,secs=s[,trans=t]] [,snapshot=on|off] [,cache=none|writethrough|writeback|unsafe|directsync] [,format=f] [,backup=yes|no] [,rerror=ignore|report|stop] [,werror=enospc|ignore|report|stop] [,aio=native|threads]  [,discard=ignore|on] [,serial=serial]"
                                          },
                                          "localtime" : {
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "description" : "Set the real time clock to local time. This is enabled by default if ostype indicates a Microsoft OS."
                                          },
                                          "agent" : {
                                             "description" : "Enable/disable Qemu GuestAgent.",
                                             "type" : "boolean",
                                             "default" : 0,
                                             "optional" : 1
                                          },
                                          "sockets" : {
                                             "description" : "The number of CPU sockets.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "default" : 1,
                                             "optional" : 1
                                          },
                                          "tdf" : {
                                             "optional" : 1,
                                             "default" : 0,
                                             "type" : "boolean",
                                             "description" : "Enable/disable time drift fix."
                                          },
                                          "migrate_downtime" : {
                                             "minimum" : 0,
                                             "default" : 0.1,
                                             "optional" : 1,
                                             "description" : "Set maximum tolerated downtime (in seconds) for migrations.",
                                             "type" : "number"
                                          },
                                          "unused[n]" : {
                                             "description" : "Reference to unused volumes.",
                                             "type" : "string",
                                             "format" : "pve-volume-id",
                                             "optional" : 1
                                          },
                                          "skiplock" : {
                                             "optional" : 1,
                                             "description" : "Ignore locks - only root is allowed to use this option.",
                                             "type" : "boolean"
                                          },
                                          "hostpci[n]" : {
                                             "typetext" : "[host=]HOSTPCIDEVICE [,rombar=on|off] [,pcie=0|1] [,x-vga=on|off]",
                                             "format" : "pve-qm-hostpci",
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "Map host pci devices. HOSTPCIDEVICE syntax is:\n\n'bus:dev.func' (hexadecimal numbers)\n\nYou can us the 'lspci' command to list existing pci devices.\n\nThe 'rombar' option determines whether or not the device's ROM will be visible in the guest's memory map (default is 'on').\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n"
                                          },
                                          "shares" : {
                                             "minimum" : 0,
                                             "default" : 1000,
                                             "optional" : 1,
                                             "maximum" : 50000,
                                             "description" : "Amount of memory shares for auto-ballooning. The larger the number is, the more memory this VM gets. Number is relative to weights of all other running VMs. Using zero disables auto-ballooning",
                                             "type" : "integer"
                                          },
                                          "description" : {
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "Description for the VM. Only used on the configuration web interface. This is saved as comment inside the configuration file."
                                          },
                                          "watchdog" : {
                                             "type" : "string",
                                             "description" : "Create a virtual hardware watchdog device.  Once enabled (by a guest action), the watchdog must be periodically polled by an agent inside the guest or else the guest will be restarted (or execute the action specified)",
                                             "typetext" : "[[model=]i6300esb|ib700] [,[action=]reset|shutdown|poweroff|pause|debug|none]",
                                             "optional" : 1,
                                             "format" : "pve-qm-watchdog"
                                          },
                                          "keyboard" : {
                                             "description" : "Keybord layout for vnc server. Default is read from the datacenter configuration file.",
                                             "type" : "string",
                                             "default" : "en-us",
                                             "optional" : 1,
                                             "enum" : [
                                                "sl",
                                                "it",
                                                "es",
                                                "fr",
                                                "de-ch",
                                                "lt",
                                                "no",
                                                "fr-ch",
                                                "de",
                                                "en-us",
                                                "pt",
                                                "pt-br",
                                                "fr-be",
                                                "fr-ca",
                                                "tr",
                                                "da",
                                                "pl",
                                                "mk",
                                                "fi",
                                                "en-gb",
                                                "nl",
                                                "ja",
                                                "is",
                                                "hu",
                                                "sv"
                                             ]
                                          },
                                          "hotplug" : {
                                             "description" : "Selectively enable hotplug features. This is a comma separated list of hotplug features: 'network', 'disk', 'cpu', 'memory' and 'usb'. Use '0' to disable hotplug completely. Value '1' is an alias for the default 'network,disk,usb'.",
                                             "type" : "string",
                                             "format" : "pve-hotplug-features",
                                             "optional" : 1,
                                             "default" : "network,disk,usb"
                                          },
                                          "net[n]" : {
                                             "type" : "string",
                                             "description" : "Specify network devices.\n\nMODEL is one of: e1000 e1000-82540em e1000-82544gc e1000-82545em i82551 i82557b i82559er ne2k_isa ne2k_pci pcnet rtl8139 virtio vmxnet3\n\nXX:XX:XX:XX:XX:XX should be an unique MAC address. This is\nautomatically generated if not specified.\n\nThe bridge parameter can be used to automatically add the interface to a bridge device. The Proxmox VE standard bridge is called 'vmbr0'.\n\nOption 'rate' is used to limit traffic bandwidth from and to this interface. It is specified as floating point number, unit is 'Megabytes per second'.\n\nIf you specify no bridge, we create a kvm 'user' (NATed) network device, which provides DHCP and DNS services. The following addresses are used:\n\n10.0.2.2   Gateway\n10.0.2.3   DNS Server\n10.0.2.4   SMB Server\n\nThe DHCP server assign addresses to the guest starting from 10.0.2.15.\n\n",
                                             "typetext" : "MODEL=XX:XX:XX:XX:XX:XX [,bridge=<dev>][,queues=<nbqueues>][,rate=<mbps>] [,tag=<vlanid>][,firewall=0|1],link_down=0|1]",
                                             "optional" : 1,
                                             "format" : "pve-qm-net"
                                          },
                                          "force" : {
                                             "type" : "boolean",
                                             "description" : "Force physical removal. Without this, we simple remove the disk from the config file and create an additional configuration entry called 'unused[n]', which contains the volume ID. Unlink of unused[n] always cause physical removal.",
                                             "requires" : "delete",
                                             "optional" : 1
                                          },
                                          "balloon" : {
                                             "description" : "Amount of target RAM for the VM in MB. Using zero disables the ballon driver.",
                                             "type" : "integer",
                                             "optional" : 1,
                                             "minimum" : 0
                                          },
                                          "onboot" : {
                                             "description" : "Specifies whether a VM will be started during system bootup.",
                                             "type" : "boolean",
                                             "optional" : 1,
                                             "default" : 0
                                          },
                                          "args" : {
                                             "type" : "string",
                                             "description" : "Note: this option is for experts only. It allows you to pass arbitrary arguments to kvm, for example:\n\nargs: -no-reboot -no-hpet\n",
                                             "optional" : 1
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "serial[n]" : {
                                             "pattern" : "(/dev/.+|socket)",
                                             "type" : "string",
                                             "description" : "Create a serial device inside the VM (n is 0 to 3), and pass through a host serial device (i.e. /dev/ttyS0), or create a unix socket on the host side (use 'qm terminal' to open a terminal connection).\n\nNote: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nExperimental: user reported problems with this option.\n",
                                             "optional" : 1
                                          },
                                          "memory" : {
                                             "description" : "Amount of RAM for the VM in MB. This is the maximum available memory when you use the balloon device.",
                                             "type" : "integer",
                                             "optional" : 1,
                                             "default" : 512,
                                             "minimum" : 16
                                          },
                                          "freeze" : {
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "description" : "Freeze CPU at startup (use 'c' monitor command to start execution)."
                                          },
                                          "scsihw" : {
                                             "type" : "string",
                                             "description" : "scsi controller model",
                                             "optional" : 1,
                                             "default" : "lsi",
                                             "enum" : [
                                                "lsi",
                                                "lsi53c810",
                                                "virtio-scsi-pci",
                                                "virtio-scsi-single",
                                                "megasas",
                                                "pvscsi"
                                             ]
                                          },
                                          "ostype" : {
                                             "description" : "Used to enable special optimization/features for specific\noperating systems:\n\nother  => unspecified OS\nwxp    => Microsoft Windows XP\nw2k    => Microsoft Windows 2000\nw2k3   => Microsoft Windows 2003\nw2k8   => Microsoft Windows 2008\nwvista => Microsoft Windows Vista\nwin7   => Microsoft Windows 7\nwin8   => Microsoft Windows 8/2012\nl24    => Linux 2.4 Kernel\nl26    => Linux 2.6/3.X Kernel\nsolaris => solaris/opensolaris/openindiania kernel\n\nother|l24|l26|solaris                       ... no special behaviour\nwxp|w2k|w2k3|w2k8|wvista|win7|win8  ... use --localtime switch\n",
                                             "type" : "string",
                                             "optional" : 1,
                                             "enum" : [
                                                "other",
                                                "wxp",
                                                "w2k",
                                                "w2k3",
                                                "w2k8",
                                                "wvista",
                                                "win7",
                                                "win8",
                                                "l24",
                                                "l26",
                                                "solaris"
                                             ]
                                          },
                                          "autostart" : {
                                             "description" : "Automatic restart after crash (currently ignored).",
                                             "type" : "boolean",
                                             "optional" : 1,
                                             "default" : 0
                                          },
                                          "acpi" : {
                                             "default" : 1,
                                             "optional" : 1,
                                             "description" : "Enable/disable ACPI.",
                                             "type" : "boolean"
                                          },
                                          "startdate" : {
                                             "default" : "now",
                                             "optional" : 1,
                                             "typetext" : "(now | YYYY-MM-DD | YYYY-MM-DDTHH:MM:SS)",
                                             "description" : "Set the initial date of the real time clock. Valid format for date are: 'now' or '2006-06-17T16:01:21' or '2006-06-17'.",
                                             "type" : "string",
                                             "pattern" : "(now|\\d{4}-\\d{1,2}-\\d{1,2}(T\\d{1,2}:\\d{1,2}:\\d{1,2})?)"
                                          },
                                          "lock" : {
                                             "description" : "Lock/unlock the VM.",
                                             "type" : "string",
                                             "enum" : [
                                                "migrate",
                                                "backup",
                                                "snapshot",
                                                "rollback"
                                             ],
                                             "optional" : 1
                                          }
                                       }
                                    }
                                 },
                                 "GET" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "current" : {
                                             "type" : "boolean",
                                             "description" : "Get current values (instead of pending values).",
                                             "optional" : 1,
                                             "default" : 0
                                          }
                                       }
                                    },
                                    "name" : "vm_config",
                                    "returns" : {
                                       "type" : "object",
                                       "properties" : {
                                          "digest" : {
                                             "type" : "string",
                                             "description" : "SHA1 digest of configuration file. This can be used to prevent concurrent modifications."
                                          }
                                       }
                                    },
                                    "proxyto" : "node",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "description" : "Get current virtual machine configuration. This does not include pending configuration changes (see 'pending' API).",
                                    "method" : "GET"
                                 }
                              },
                              "path" : "/nodes/{node}/qemu/{vmid}/config",
                              "text" : "config",
                              "leaf" : 1
                           },
                           {
                              "path" : "/nodes/{node}/qemu/{vmid}/pending",
                              "text" : "pending",
                              "leaf" : 1,
                              "info" : {
                                 "GET" : {
                                    "parameters" : {
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "name" : "vm_pending",
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "array",
                                       "items" : {
                                          "properties" : {
                                             "pending" : {
                                                "description" : "Pending value.",
                                                "type" : "string",
                                                "optional" : 1
                                             },
                                             "delete" : {
                                                "optional" : 1,
                                                "maximum" : 2,
                                                "minimum" : 0,
                                                "type" : "integer",
                                                "description" : "Indicates a pending delete request if present and not 0. The value 2 indicates a force-delete request."
                                             },
                                             "value" : {
                                                "type" : "string",
                                                "description" : "Current value.",
                                                "optional" : 1
                                             },
                                             "key" : {
                                                "type" : "string",
                                                "description" : "Configuration option name."
                                             }
                                          },
                                          "type" : "object"
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "description" : "Get virtual machine configuration, including pending changes.",
                                    "method" : "GET"
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "PUT" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1
                                          },
                                          "idlist" : {
                                             "format" : "pve-configid-list",
                                             "description" : "A list of disk IDs you want to delete.",
                                             "type" : "string"
                                          },
                                          "force" : {
                                             "type" : "boolean",
                                             "description" : "Force physical removal. Without this, we simple remove the disk from the config file and create an additional configuration entry called 'unused[n]', which contains the volume ID. Unlink of unused[n] always cause physical removal.",
                                             "optional" : 1
                                          }
                                       }
                                    },
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "proxyto" : "node",
                                    "name" : "unlink",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk"
                                          ]
                                       ]
                                    },
                                    "description" : "Unlink/delete disk images.",
                                    "method" : "PUT"
                                 }
                              },
                              "path" : "/nodes/{node}/qemu/{vmid}/unlink",
                              "leaf" : 1,
                              "text" : "unlink"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Creates a TCP VNC proxy connections.",
                                    "method" : "POST",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "websocket" : {
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "description" : "starts websockify instead of vncproxy"
                                          }
                                       }
                                    },
                                    "returns" : {
                                       "properties" : {
                                          "ticket" : {
                                             "type" : "string"
                                          },
                                          "upid" : {
                                             "type" : "string"
                                          },
                                          "port" : {
                                             "type" : "integer"
                                          },
                                          "cert" : {
                                             "type" : "string"
                                          },
                                          "user" : {
                                             "type" : "string"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "name" : "vncproxy"
                                 }
                              },
                              "path" : "/nodes/{node}/qemu/{vmid}/vncproxy",
                              "text" : "vncproxy",
                              "leaf" : 1
                           },
                           {
                              "text" : "vncwebsocket",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/vncwebsocket",
                              "info" : {
                                 "GET" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vncticket" : {
                                             "maxLength" : 512,
                                             "description" : "Ticket from previous call to vncproxy.",
                                             "type" : "string"
                                          },
                                          "port" : {
                                             "maximum" : 5999,
                                             "minimum" : 5900,
                                             "type" : "integer",
                                             "description" : "Port number returned by previous vncproxy call."
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          }
                                       }
                                    },
                                    "name" : "vncwebsocket",
                                    "returns" : {
                                       "properties" : {
                                          "port" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    },
                                    "permissions" : {
                                       "description" : "You also need to pass a valid ticket (vncticket).",
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "description" : "Opens a weksocket for VNC traffic.",
                                    "method" : "GET"
                                 }
                              }
                           },
                           {
                              "leaf" : 1,
                              "text" : "spiceproxy",
                              "path" : "/nodes/{node}/qemu/{vmid}/spiceproxy",
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "properties" : {
                                          "proxy" : {
                                             "format" : "address",
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "SPICE proxy server. This can be used by the client to specify the proxy server. All nodes in a cluster runs 'spiceproxy', so it is up to the client to choose one. By default, we return the node where the VM is currently running. As resonable setting is to use same node you use to connect to the API (This is window.location.hostname for the JS GUI)."
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "name" : "spiceproxy",
                                    "proxyto" : "node",
                                    "returns" : {
                                       "additionalProperties" : 1,
                                       "description" : "Returned values can be directly passed to the 'remote-viewer' application.",
                                       "properties" : {
                                          "proxy" : {
                                             "type" : "string"
                                          },
                                          "host" : {
                                             "type" : "string"
                                          },
                                          "type" : {
                                             "type" : "string"
                                          },
                                          "tls-port" : {
                                             "type" : "integer"
                                          },
                                          "password" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "description" : "Returns a SPICE configuration to connect to the VM.",
                                    "method" : "POST"
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "permissions" : {
                                       "user" : "all"
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "links" : [
                                          {
                                             "href" : "{subdir}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "items" : {
                                          "type" : "object",
                                          "properties" : {
                                             "subdir" : {
                                                "type" : "string"
                                             }
                                          }
                                       },
                                       "type" : "array"
                                    },
                                    "name" : "vmcmdidx",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "format" : "pve-vmid",
                                             "minimum" : 1
                                          }
                                       }
                                    },
                                    "method" : "GET",
                                    "description" : "Directory index"
                                 }
                              },
                              "leaf" : 0,
                              "text" : "status",
                              "path" : "/nodes/{node}/qemu/{vmid}/status",
                              "children" : [
                                 {
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/current",
                                    "leaf" : 1,
                                    "text" : "current",
                                    "info" : {
                                       "GET" : {
                                          "method" : "GET",
                                          "description" : "Get virtual machine status.",
                                          "returns" : {
                                             "type" : "object"
                                          },
                                          "proxyto" : "node",
                                          "name" : "vm_status",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "vmid" : {
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer"
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                }
                                             }
                                          }
                                       }
                                    }
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM."
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "stateuri" : {
                                                   "optional" : 1,
                                                   "maxLength" : 128,
                                                   "description" : "Some command save/restore state from this location.",
                                                   "type" : "string"
                                                },
                                                "migratedfrom" : {
                                                   "optional" : 1,
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "machine" : {
                                                   "optional" : 1,
                                                   "type" : "string",
                                                   "pattern" : "(pc|pc(-i440fx)?-\\d+\\.\\d+|q35|pc-q35-\\d+\\.\\d+)",
                                                   "maxLength" : 40,
                                                   "description" : "Specific the Qemu machine type."
                                                },
                                                "skiplock" : {
                                                   "optional" : 1,
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "type" : "boolean"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "name" : "vm_start",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "description" : "Start virtual machine.",
                                          "method" : "POST"
                                       }
                                    },
                                    "leaf" : 1,
                                    "text" : "start",
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/start"
                                 },
                                 {
                                    "leaf" : 1,
                                    "text" : "stop",
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/stop",
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "properties" : {
                                                "timeout" : {
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "description" : "Wait maximal timeout seconds."
                                                },
                                                "skiplock" : {
                                                   "optional" : 1,
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "type" : "boolean"
                                                },
                                                "vmid" : {
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM."
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "migratedfrom" : {
                                                   "format" : "pve-node",
                                                   "optional" : 1,
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "keepActive" : {
                                                   "default" : 0,
                                                   "optional" : 1,
                                                   "description" : "Do not decativate storage volumes.",
                                                   "type" : "boolean"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "proxyto" : "node",
                                          "name" : "vm_stop",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "description" : "Stop virtual machine.",
                                          "method" : "POST"
                                       }
                                    }
                                 },
                                 {
                                    "text" : "reset",
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/reset",
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "properties" : {
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "type" : "boolean",
                                                   "optional" : 1
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "name" : "vm_reset",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "proxyto" : "node",
                                          "description" : "Reset virtual machine.",
                                          "method" : "POST"
                                       }
                                    }
                                 },
                                 {
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/shutdown",
                                    "text" : "shutdown",
                                    "leaf" : 1,
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "properties" : {
                                                "keepActive" : {
                                                   "description" : "Do not decativate storage volumes.",
                                                   "type" : "boolean",
                                                   "optional" : 1,
                                                   "default" : 0
                                                },
                                                "forceStop" : {
                                                   "type" : "boolean",
                                                   "description" : "Make sure the VM stops.",
                                                   "default" : 0,
                                                   "optional" : 1
                                                },
                                                "vmid" : {
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "type" : "boolean",
                                                   "optional" : 1
                                                },
                                                "timeout" : {
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "description" : "Wait maximal timeout seconds.",
                                                   "type" : "integer"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "POST",
                                          "description" : "Shutdown virtual machine.",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "proxyto" : "node",
                                          "name" : "vm_shutdown",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1
                                       }
                                    }
                                 },
                                 {
                                    "leaf" : 1,
                                    "text" : "suspend",
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/suspend",
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM."
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                },
                                                "skiplock" : {
                                                   "optional" : 1,
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "type" : "boolean"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "name" : "vm_suspend",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "description" : "Suspend virtual machine.",
                                          "method" : "POST"
                                       }
                                    }
                                 },
                                 {
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/resume",
                                    "leaf" : 1,
                                    "text" : "resume",
                                    "info" : {
                                       "POST" : {
                                          "name" : "vm_resume",
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "description" : "Resume virtual machine.",
                                          "method" : "POST",
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "optional" : 1,
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "type" : "boolean"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          }
                                       }
                                    }
                                 }
                              ]
                           },
                           {
                              "leaf" : 1,
                              "text" : "sendkey",
                              "path" : "/nodes/{node}/qemu/{vmid}/sendkey",
                              "info" : {
                                 "PUT" : {
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "name" : "vm_sendkey",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "proxyto" : "node",
                                    "description" : "Send key event to virtual machine.",
                                    "method" : "PUT",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "skiplock" : {
                                             "description" : "Ignore locks - only root is allowed to use this option.",
                                             "type" : "boolean",
                                             "optional" : 1
                                          },
                                          "key" : {
                                             "type" : "string",
                                             "description" : "The key (qemu monitor encoding)."
                                          },
                                          "vmid" : {
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          }
                                       }
                                    }
                                 }
                              }
                           },
                           {
                              "text" : "feature",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/feature",
                              "info" : {
                                 "GET" : {
                                    "description" : "Check if feature for virtual machine is available.",
                                    "method" : "GET",
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {
                                          "nodes" : {
                                             "type" : "array",
                                             "items" : {
                                                "type" : "string"
                                             }
                                          },
                                          "hasFeature" : {
                                             "type" : "boolean"
                                          }
                                       },
                                       "type" : "object"
                                    },
                                    "name" : "vm_feature",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "snapname" : {
                                             "type" : "string",
                                             "description" : "The name of the snapshot.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "format" : "pve-configid"
                                          },
                                          "feature" : {
                                             "description" : "Feature to check.",
                                             "type" : "string",
                                             "enum" : [
                                                "snapshot",
                                                "clone",
                                                "copy"
                                             ]
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          }
                                       }
                                    }
                                 }
                              }
                           },
                           {
                              "path" : "/nodes/{node}/qemu/{vmid}/clone",
                              "text" : "clone",
                              "leaf" : 1,
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "description" : {
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "Description for the new VM."
                                          },
                                          "storage" : {
                                             "type" : "string",
                                             "requires" : "full",
                                             "description" : "Target storage for full clone.",
                                             "format" : "pve-storage-id",
                                             "optional" : 1
                                          },
                                          "name" : {
                                             "type" : "string",
                                             "description" : "Set a name for the new VM.",
                                             "optional" : 1,
                                             "format" : "dns-name"
                                          },
                                          "newid" : {
                                             "type" : "integer",
                                             "description" : "VMID for the clone.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1
                                          },
                                          "pool" : {
                                             "description" : "Add the new VM to the specified pool.",
                                             "type" : "string",
                                             "format" : "pve-poolid",
                                             "optional" : 1
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "target" : {
                                             "description" : "Target node. Only allowed if the original VM is on shared storage.",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-node"
                                          },
                                          "full" : {
                                             "description" : "Create a full copy of all disk. This is always done when you clone a normal VM. For VM templates, we try to create a linked clone by default.",
                                             "type" : "boolean",
                                             "default" : 0,
                                             "optional" : 1
                                          },
                                          "snapname" : {
                                             "optional" : 1,
                                             "format" : "pve-configid",
                                             "type" : "string",
                                             "maxLength" : 40,
                                             "description" : "The name of the snapshot."
                                          },
                                          "format" : {
                                             "enum" : [
                                                "raw",
                                                "qcow2",
                                                "vmdk"
                                             ],
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "Target format for file storage.",
                                             "requires" : "full"
                                          }
                                       }
                                    },
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "proxyto" : "node",
                                    "name" : "clone_vm",
                                    "permissions" : {
                                       "description" : "You need 'VM.Clone' permissions on /vms/{vmid}, and 'VM.Allocate' permissions on /vms/{newid} (or on the VM pool /pool/{pool}). You also need 'Datastore.AllocateSpace' on any used storage.",
                                       "check" : [
                                          "and",
                                          [
                                             "perm",
                                             "/vms/{vmid}",
                                             [
                                                "VM.Clone"
                                             ]
                                          ],
                                          [
                                             "or",
                                             [
                                                "perm",
                                                "/vms/{newid}",
                                                [
                                                   "VM.Allocate"
                                                ]
                                             ],
                                             [
                                                "perm",
                                                "/pool/{pool}",
                                                [
                                                   "VM.Allocate"
                                                ],
                                                "require_param",
                                                "pool"
                                             ]
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "method" : "POST",
                                    "description" : "Create a copy of virtual machine/template."
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "digest" : {
                                             "type" : "string",
                                             "maxLength" : 40,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "optional" : 1
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          },
                                          "storage" : {
                                             "format" : "pve-storage-id",
                                             "description" : "Target storage.",
                                             "type" : "string"
                                          },
                                          "disk" : {
                                             "enum" : [
                                                "ide0",
                                                "ide1",
                                                "ide2",
                                                "ide3",
                                                "scsi0",
                                                "scsi1",
                                                "scsi2",
                                                "scsi3",
                                                "scsi4",
                                                "scsi5",
                                                "scsi6",
                                                "scsi7",
                                                "scsi8",
                                                "scsi9",
                                                "scsi10",
                                                "scsi11",
                                                "scsi12",
                                                "scsi13",
                                                "virtio0",
                                                "virtio1",
                                                "virtio2",
                                                "virtio3",
                                                "virtio4",
                                                "virtio5",
                                                "virtio6",
                                                "virtio7",
                                                "virtio8",
                                                "virtio9",
                                                "virtio10",
                                                "virtio11",
                                                "virtio12",
                                                "virtio13",
                                                "virtio14",
                                                "virtio15",
                                                "sata0",
                                                "sata1",
                                                "sata2",
                                                "sata3",
                                                "sata4",
                                                "sata5"
                                             ],
                                             "type" : "string",
                                             "description" : "The disk you want to move."
                                          },
                                          "format" : {
                                             "optional" : 1,
                                             "enum" : [
                                                "raw",
                                                "qcow2",
                                                "vmdk"
                                             ],
                                             "type" : "string",
                                             "description" : "Target Format."
                                          },
                                          "delete" : {
                                             "description" : "Delete the original disk after successful copy. By default the original disk is kept as unused disk.",
                                             "type" : "boolean",
                                             "optional" : 1,
                                             "default" : 0
                                          }
                                       }
                                    },
                                    "protected" : 1,
                                    "permissions" : {
                                       "description" : "You need 'VM.Config.Disk' permissions on /vms/{vmid}, and 'Datastore.AllocateSpace' permissions on the storage.",
                                       "check" : [
                                          "and",
                                          [
                                             "perm",
                                             "/vms/{vmid}",
                                             [
                                                "VM.Config.Disk"
                                             ]
                                          ],
                                          [
                                             "perm",
                                             "/storage/{storage}",
                                             [
                                                "Datastore.AllocateSpace"
                                             ]
                                          ]
                                       ]
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string",
                                       "description" : "the task ID."
                                    },
                                    "name" : "move_vm_disk",
                                    "description" : "Move volume to different storage.",
                                    "method" : "POST"
                                 }
                              },
                              "text" : "move_disk",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/move_disk"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "target" : {
                                             "format" : "pve-node",
                                             "description" : "Target node.",
                                             "type" : "string"
                                          },
                                          "force" : {
                                             "description" : "Allow to migrate VMs which use local devices. Only root may use this option.",
                                             "type" : "boolean",
                                             "optional" : 1
                                          },
                                          "online" : {
                                             "type" : "boolean",
                                             "description" : "Use online/live migration.",
                                             "optional" : 1
                                          }
                                       }
                                    },
                                    "description" : "Migrate virtual machine. Creates a new migration task.",
                                    "method" : "POST",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Migrate"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "name" : "migrate_vm",
                                    "returns" : {
                                       "type" : "string",
                                       "description" : "the task ID."
                                    }
                                 }
                              },
                              "path" : "/nodes/{node}/qemu/{vmid}/migrate",
                              "text" : "migrate",
                              "leaf" : 1
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Execute Qemu monitor commands.",
                                    "method" : "POST",
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "proxyto" : "node",
                                    "name" : "monitor",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Monitor"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "parameters" : {
                                       "properties" : {
                                          "command" : {
                                             "type" : "string",
                                             "description" : "The monitor command."
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "text" : "monitor",
                              "path" : "/nodes/{node}/qemu/{vmid}/monitor"
                           },
                           {
                              "path" : "/nodes/{node}/qemu/{vmid}/resize",
                              "text" : "resize",
                              "leaf" : 1,
                              "info" : {
                                 "PUT" : {
                                    "parameters" : {
                                       "properties" : {
                                          "digest" : {
                                             "optional" : 1,
                                             "maxLength" : 40,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "size" : {
                                             "description" : "The new size. With the '+' sign the value is added to the actual size of the volume and without it, the value is taken as an absolute one. Shrinking disk size is not supported.",
                                             "type" : "string",
                                             "pattern" : "\\+?\\d+(\\.\\d+)?[KMGT]?"
                                          },
                                          "skiplock" : {
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "description" : "Ignore locks - only root is allowed to use this option."
                                          },
                                          "disk" : {
                                             "description" : "The disk you want to resize.",
                                             "type" : "string",
                                             "enum" : [
                                                "ide0",
                                                "ide1",
                                                "ide2",
                                                "ide3",
                                                "scsi0",
                                                "scsi1",
                                                "scsi2",
                                                "scsi3",
                                                "scsi4",
                                                "scsi5",
                                                "scsi6",
                                                "scsi7",
                                                "scsi8",
                                                "scsi9",
                                                "scsi10",
                                                "scsi11",
                                                "scsi12",
                                                "scsi13",
                                                "virtio0",
                                                "virtio1",
                                                "virtio2",
                                                "virtio3",
                                                "virtio4",
                                                "virtio5",
                                                "virtio6",
                                                "virtio7",
                                                "virtio8",
                                                "virtio9",
                                                "virtio10",
                                                "virtio11",
                                                "virtio12",
                                                "virtio13",
                                                "virtio14",
                                                "virtio15",
                                                "sata0",
                                                "sata1",
                                                "sata2",
                                                "sata3",
                                                "sata4",
                                                "sata5"
                                             ]
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "description" : "Extend volume size.",
                                    "method" : "PUT",
                                    "proxyto" : "node",
                                    "name" : "resize_vm",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk"
                                          ]
                                       ]
                                    },
                                    "protected" : 1
                                 }
                              }
                           },
                           {
                              "children" : [
                                 {
                                    "info" : {
                                       "DELETE" : {
                                          "parameters" : {
                                             "properties" : {
                                                "snapname" : {
                                                   "description" : "The name of the snapshot.",
                                                   "maxLength" : 40,
                                                   "type" : "string",
                                                   "format" : "pve-configid"
                                                },
                                                "force" : {
                                                   "description" : "For removal from config file, even if removing disk snapshots fails.",
                                                   "type" : "boolean",
                                                   "optional" : 1
                                                },
                                                "vmid" : {
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "type" : "string",
                                                   "format" : "pve-node"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "DELETE",
                                          "description" : "Delete a VM snapshot.",
                                          "name" : "delsnapshot",
                                          "returns" : {
                                             "type" : "string",
                                             "description" : "the task ID."
                                          },
                                          "proxyto" : "node",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Snapshot"
                                                ]
                                             ]
                                          },
                                          "protected" : 1
                                       },
                                       "GET" : {
                                          "permissions" : {
                                             "user" : "all"
                                          },
                                          "returns" : {
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {}
                                             },
                                             "type" : "array",
                                             "links" : [
                                                {
                                                   "rel" : "child",
                                                   "href" : "{cmd}"
                                                }
                                             ]
                                          },
                                          "name" : "snapshot_cmd_idx",
                                          "parameters" : {
                                             "properties" : {
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "snapname" : {
                                                   "format" : "pve-configid",
                                                   "type" : "string",
                                                   "maxLength" : 40,
                                                   "description" : "The name of the snapshot."
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "GET",
                                          "description" : ""
                                       }
                                    },
                                    "leaf" : 0,
                                    "text" : "{snapname}",
                                    "path" : "/nodes/{node}/qemu/{vmid}/snapshot/{snapname}",
                                    "children" : [
                                       {
                                          "text" : "config",
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/qemu/{vmid}/snapshot/{snapname}/config",
                                          "info" : {
                                             "GET" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "type" : "object"
                                                },
                                                "name" : "get_snapshot_config",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "vmid" : {
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid",
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM."
                                                      },
                                                      "snapname" : {
                                                         "type" : "string",
                                                         "maxLength" : 40,
                                                         "description" : "The name of the snapshot.",
                                                         "format" : "pve-configid"
                                                      }
                                                   }
                                                },
                                                "method" : "GET",
                                                "description" : "Get snapshot configuration"
                                             },
                                             "PUT" : {
                                                "name" : "update_snapshot_config",
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "protected" : 1,
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "description" : "Update snapshot metadata.",
                                                "method" : "PUT",
                                                "parameters" : {
                                                   "properties" : {
                                                      "description" : {
                                                         "optional" : 1,
                                                         "type" : "string",
                                                         "description" : "A textual description or comment."
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "snapname" : {
                                                         "type" : "string",
                                                         "description" : "The name of the snapshot.",
                                                         "maxLength" : 40,
                                                         "format" : "pve-configid"
                                                      }
                                                   },
                                                   "additionalProperties" : 0
                                                }
                                             }
                                          }
                                       },
                                       {
                                          "path" : "/nodes/{node}/qemu/{vmid}/snapshot/{snapname}/rollback",
                                          "text" : "rollback",
                                          "leaf" : 1,
                                          "info" : {
                                             "POST" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "type" : "string",
                                                   "description" : "the task ID."
                                                },
                                                "name" : "rollback",
                                                "method" : "POST",
                                                "description" : "Rollback VM state to specified snapshot.",
                                                "parameters" : {
                                                   "properties" : {
                                                      "snapname" : {
                                                         "format" : "pve-configid",
                                                         "type" : "string",
                                                         "maxLength" : 40,
                                                         "description" : "The name of the snapshot."
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "type" : "string",
                                                         "format" : "pve-node"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1
                                                      }
                                                   },
                                                   "additionalProperties" : 0
                                                }
                                             }
                                          }
                                       }
                                    ]
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "method" : "GET",
                                    "description" : "List all snapshots.",
                                    "proxyto" : "node",
                                    "name" : "snapshot_list",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "type" : "array",
                                       "links" : [
                                          {
                                             "href" : "{name}",
                                             "rel" : "child"
                                          }
                                       ]
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          }
                                       }
                                    }
                                 },
                                 "POST" : {
                                    "returns" : {
                                       "type" : "string",
                                       "description" : "the task ID."
                                    },
                                    "name" : "snapshot",
                                    "proxyto" : "node",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Snapshot"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "method" : "POST",
                                    "description" : "Snapshot a VM.",
                                    "parameters" : {
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "vmstate" : {
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "description" : "Save the vmstate"
                                          },
                                          "description" : {
                                             "type" : "string",
                                             "description" : "A textual description or comment.",
                                             "optional" : 1
                                          },
                                          "snapname" : {
                                             "description" : "The name of the snapshot.",
                                             "maxLength" : 40,
                                             "type" : "string",
                                             "format" : "pve-configid"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 }
                              },
                              "text" : "snapshot",
                              "leaf" : 0,
                              "path" : "/nodes/{node}/qemu/{vmid}/snapshot"
                           },
                           {
                              "leaf" : 1,
                              "text" : "template",
                              "path" : "/nodes/{node}/qemu/{vmid}/template",
                              "info" : {
                                 "POST" : {
                                    "protected" : 1,
                                    "permissions" : {
                                       "description" : "You need 'VM.Allocate' permissions on /vms/{vmid}",
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Allocate"
                                          ]
                                       ]
                                    },
                                    "name" : "template",
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "method" : "POST",
                                    "description" : "Create a Template.",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "format" : "pve-vmid",
                                             "minimum" : 1
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "disk" : {
                                             "type" : "string",
                                             "description" : "If you want to convert only 1 disk to base image.",
                                             "enum" : [
                                                "ide0",
                                                "ide1",
                                                "ide2",
                                                "ide3",
                                                "scsi0",
                                                "scsi1",
                                                "scsi2",
                                                "scsi3",
                                                "scsi4",
                                                "scsi5",
                                                "scsi6",
                                                "scsi7",
                                                "scsi8",
                                                "scsi9",
                                                "scsi10",
                                                "scsi11",
                                                "scsi12",
                                                "scsi13",
                                                "virtio0",
                                                "virtio1",
                                                "virtio2",
                                                "virtio3",
                                                "virtio4",
                                                "virtio5",
                                                "virtio6",
                                                "virtio7",
                                                "virtio8",
                                                "virtio9",
                                                "virtio10",
                                                "virtio11",
                                                "virtio12",
                                                "virtio13",
                                                "virtio14",
                                                "virtio15",
                                                "sata0",
                                                "sata1",
                                                "sata2",
                                                "sata3",
                                                "sata4",
                                                "sata5"
                                             ],
                                             "optional" : 1
                                          }
                                       }
                                    }
                                 }
                              }
                           }
                        ],
                        "path" : "/nodes/{node}/qemu/{vmid}",
                        "text" : "{vmid}",
                        "leaf" : 0,
                        "info" : {
                           "GET" : {
                              "permissions" : {
                                 "user" : "all"
                              },
                              "returns" : {
                                 "links" : [
                                    {
                                       "href" : "{subdir}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "subdir" : {
                                          "type" : "string"
                                       }
                                    }
                                 },
                                 "type" : "array"
                              },
                              "proxyto" : "node",
                              "name" : "vmdiridx",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    },
                                    "vmid" : {
                                       "format" : "pve-vmid",
                                       "minimum" : 1,
                                       "type" : "integer",
                                       "description" : "The (unique) ID of the VM."
                                    }
                                 }
                              },
                              "method" : "GET",
                              "description" : "Directory index"
                           },
                           "DELETE" : {
                              "parameters" : {
                                 "properties" : {
                                    "vmid" : {
                                       "type" : "integer",
                                       "description" : "The (unique) ID of the VM.",
                                       "format" : "pve-vmid",
                                       "minimum" : 1
                                    },
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    },
                                    "skiplock" : {
                                       "description" : "Ignore locks - only root is allowed to use this option.",
                                       "type" : "boolean",
                                       "optional" : 1
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "proxyto" : "node",
                              "name" : "destroy_vm",
                              "returns" : {
                                 "type" : "string"
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/vms/{vmid}",
                                    [
                                       "VM.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "method" : "DELETE",
                              "description" : "Destroy the vm (also delete all used/owned volumes)."
                           }
                        }
                     }
                  ]
               },
               {
                  "info" : {
                     "POST" : {
                        "name" : "create_vm",
                        "returns" : {
                           "type" : "string"
                        },
                        "proxyto" : "node",
                        "permissions" : {
                           "user" : "all",
                           "description" : "You need 'VM.Allocate' permissions on /vms/{vmid} or on the VM pool /pool/{pool}. For restore, it is enough if the user has 'VM.Backup' permission and the VM already exists. You also need 'Datastore.AllocateSpace' permissions on the storage."
                        },
                        "protected" : 1,
                        "description" : "Create or restore a container.",
                        "method" : "POST",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "swap" : {
                                 "default" : 512,
                                 "optional" : 1,
                                 "minimum" : 0,
                                 "type" : "integer",
                                 "description" : "Amount of SWAP for the VM in MB."
                              },
                              "template" : {
                                 "type" : "boolean",
                                 "description" : "Enable/disable Template.",
                                 "default" : 0,
                                 "optional" : 1
                              },
                              "onboot" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "type" : "boolean",
                                 "description" : "Specifies whether a VM will be started during system bootup."
                              },
                              "arch" : {
                                 "type" : "string",
                                 "description" : "OS architecture type.",
                                 "enum" : [
                                    "amd64",
                                    "i386"
                                 ],
                                 "optional" : 1,
                                 "default" : "amd64"
                              },
                              "node" : {
                                 "format" : "pve-node",
                                 "type" : "string",
                                 "description" : "The cluster node name."
                              },
                              "cpuunits" : {
                                 "description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0.",
                                 "type" : "integer",
                                 "default" : 1024,
                                 "optional" : 1,
                                 "maximum" : 500000,
                                 "minimum" : 0
                              },
                              "password" : {
                                 "optional" : 1,
                                 "minLength" : 5,
                                 "type" : "string",
                                 "description" : "Sets root password inside container."
                              },
                              "memory" : {
                                 "minimum" : 16,
                                 "default" : 512,
                                 "optional" : 1,
                                 "description" : "Amount of RAM for the VM in MB.",
                                 "type" : "integer"
                              },
                              "startup" : {
                                 "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] ",
                                 "format" : "pve-startup-order",
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped."
                              },
                              "ostype" : {
                                 "enum" : [
                                    "debian",
                                    "ubuntu",
                                    "centos",
                                    "archlinux"
                                 ],
                                 "optional" : 1,
                                 "description" : "OS type. Corresponds to lxc setup scripts in /usr/share/lxc/config/<ostype>.common.conf.",
                                 "type" : "string"
                              },
                              "cmode" : {
                                 "type" : "string",
                                 "description" : "Console mode. By default, the console command tries to open a connection to one of the available tty devices. By setting cmode to 'console' it tries to attach to /dev/console instead. If you set cmode to 'shell', it simply invokes a shell inside the container (no login).",
                                 "default" : "tty",
                                 "optional" : 1,
                                 "enum" : [
                                    "shell",
                                    "console",
                                    "tty"
                                 ]
                              },
                              "rootfs" : {
                                 "type" : "string",
                                 "description" : "Use volume as container root.",
                                 "format" : {
                                    "volume" : {
                                       "type" : "string",
                                       "default_key" : 1,
                                       "description" : "Volume, device or directory to mount into the container.",
                                       "format_description" : "volume"
                                    },
                                    "size" : {
                                       "type" : "disk-size",
                                       "format_description" : "DiskSize",
                                       "description" : "Volume size (read only value).",
                                       "optional" : 1
                                    },
                                    "backup" : {
                                       "optional" : 1,
                                       "type" : "boolean",
                                       "description" : "Whether to include the mountpoint in backups.",
                                       "format_description" : "[1|0]"
                                    }
                                 },
                                 "optional" : 1
                              },
                              "mp[n]" : {
                                 "optional" : 1,
                                 "format" : {
                                    "mp" : {
                                       "type" : "string",
                                       "format_description" : "Path",
                                       "description" : "Path to the mountpoint as seen from inside the container.",
                                       "optional" : 1
                                    },
                                    "volume" : {
                                       "description" : "Volume, device or directory to mount into the container.",
                                       "format_description" : "volume",
                                       "type" : "string",
                                       "default_key" : 1
                                    },
                                    "backup" : {
                                       "type" : "boolean",
                                       "description" : "Whether to include the mountpoint in backups.",
                                       "format_description" : "[1|0]",
                                       "optional" : 1
                                    },
                                    "size" : {
                                       "optional" : 1,
                                       "format_description" : "DiskSize",
                                       "description" : "Volume size (read only value).",
                                       "type" : "disk-size"
                                    }
                                 },
                                 "type" : "string",
                                 "description" : "Use volume as container mount point (experimental feature)."
                              },
                              "vmid" : {
                                 "type" : "integer",
                                 "description" : "The (unique) ID of the VM.",
                                 "minimum" : 1,
                                 "format" : "pve-vmid"
                              },
                              "searchdomain" : {
                                 "optional" : 1,
                                 "format" : "dns-name-list",
                                 "description" : "Sets DNS search domains for a container. Create will automatically use the setting from the host if you neither set searchdomain or nameserver.",
                                 "type" : "string"
                              },
                              "protection" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "description" : "Sets the protection flag of the container. This will prevent the remove operation. This will prevent the CT or CT's disk remove/update operation.",
                                 "type" : "boolean"
                              },
                              "lock" : {
                                 "enum" : [
                                    "migrate",
                                    "backup",
                                    "snapshot",
                                    "rollback"
                                 ],
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Lock/unlock the VM."
                              },
                              "pool" : {
                                 "description" : "Add the VM to the specified pool.",
                                 "type" : "string",
                                 "format" : "pve-poolid",
                                 "optional" : 1
                              },
                              "storage" : {
                                 "type" : "string",
                                 "description" : "Default Storage.",
                                 "format" : "pve-storage-id",
                                 "optional" : 1,
                                 "default" : "local"
                              },
                              "ostemplate" : {
                                 "type" : "string",
                                 "maxLength" : 255,
                                 "description" : "The OS template or backup file."
                              },
                              "tty" : {
                                 "minimum" : 0,
                                 "maximum" : 6,
                                 "default" : 2,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "description" : "Specify the number of tty available to the container"
                              },
                              "nameserver" : {
                                 "optional" : 1,
                                 "format" : "address-list",
                                 "type" : "string",
                                 "description" : "Sets DNS server IP address for a container. Create will automatically use the setting from the host if you neither set searchdomain or nameserver."
                              },
                              "hostname" : {
                                 "type" : "string",
                                 "description" : "Set a host name for the container.",
                                 "maxLength" : 255,
                                 "optional" : 1,
                                 "format" : "dns-name"
                              },
                              "unused[n]" : {
                                 "type" : "string",
                                 "description" : "Reference to unused volumes.",
                                 "format" : "pve-volume-id",
                                 "optional" : 1
                              },
                              "restore" : {
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Mark this as restore task."
                              },
                              "description" : {
                                 "optional" : 1,
                                 "description" : "Container description. Only used on the configuration web interface.",
                                 "type" : "string"
                              },
                              "cpulimit" : {
                                 "default" : 0,
                                 "optional" : 1,
                                 "maximum" : 128,
                                 "minimum" : 0,
                                 "type" : "number",
                                 "description" : "Limit of CPU usage. Note if the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit."
                              },
                              "force" : {
                                 "type" : "boolean",
                                 "description" : "Allow to overwrite existing container.",
                                 "optional" : 1
                              },
                              "net[n]" : {
                                 "optional" : 1,
                                 "format" : {
                                    "gw" : {
                                       "format_description" : "GatewayIPv4",
                                       "description" : "Default gateway for IPv4 traffic.",
                                       "type" : "string",
                                       "optional" : 1,
                                       "format" : "ipv4"
                                    },
                                    "name" : {
                                       "format_description" : "String",
                                       "description" : "Name of the network device as seen from inside the container. (lxc.network.name)",
                                       "type" : "string",
                                       "pattern" : "[-_.\\w\\d]+"
                                    },
                                    "mtu" : {
                                       "minimum" : 64,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "description" : "Maximum transfer unit of the interface. (lxc.network.mtu)",
                                       "format_description" : "Number"
                                    },
                                    "gw6" : {
                                       "format_description" : "GatewayIPv6",
                                       "description" : "Default gateway for IPv6 traffic.",
                                       "type" : "string",
                                       "optional" : 1,
                                       "format" : "ipv6"
                                    },
                                    "hwaddr" : {
                                       "optional" : 1,
                                       "format_description" : "MAC",
                                       "description" : "Bridge to attach the network device to. (lxc.network.hwaddr)",
                                       "type" : "string",
                                       "pattern" : "(?^i:(?:[a-f0-9]{2}:){5}[a-f0-9]{2})"
                                    },
                                    "type" : {
                                       "description" : "Network interface type.",
                                       "type" : "string",
                                       "optional" : 1,
                                       "enum" : [
                                          "veth"
                                       ]
                                    },
                                    "tag" : {
                                       "minimum" : "2",
                                       "optional" : 1,
                                       "maximum" : "4094",
                                       "description" : "VLAN tag foro this interface.",
                                       "format_description" : "VlanNo",
                                       "type" : "integer"
                                    },
                                    "ip6" : {
                                       "type" : "string",
                                       "description" : "IPv6 address in CIDR format.",
                                       "format_description" : "IPv6Format/CIDR",
                                       "format" : "pve-ipv6-config",
                                       "optional" : 1
                                    },
                                    "bridge" : {
                                       "description" : "Bridge to attach the network device to.",
                                       "format_description" : "vmbr<Number>",
                                       "pattern" : "[-_.\\w\\d]+",
                                       "type" : "string"
                                    },
                                    "firewall" : {
                                       "description" : "Controls whether this interface's firewall rules should be used.",
                                       "format_description" : "[1|0]",
                                       "type" : "boolean",
                                       "optional" : 1
                                    },
                                    "ip" : {
                                       "format" : "pve-ipv4-config",
                                       "optional" : 1,
                                       "description" : "IPv4 address in CIDR format.",
                                       "format_description" : "IPv4Format/CIDR",
                                       "type" : "string"
                                    }
                                 },
                                 "description" : "Specifies network interfaces for the container.",
                                 "type" : "string"
                              },
                              "console" : {
                                 "default" : 1,
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Attach a console device (/dev/console) to the container."
                              }
                           }
                        }
                     },
                     "GET" : {
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "type" : "array",
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{vmid}"
                              }
                           ]
                        },
                        "proxyto" : "node",
                        "name" : "vmlist",
                        "permissions" : {
                           "description" : "Only list CTs where you have VM.Audit permissons on /vms/<vmid>.",
                           "user" : "all"
                        },
                        "protected" : 1,
                        "method" : "GET",
                        "description" : "LXC container index (per node).",
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "format" : "pve-node",
                                 "description" : "The cluster node name.",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        }
                     }
                  },
                  "text" : "lxc",
                  "leaf" : 0,
                  "path" : "/nodes/{node}/lxc",
                  "children" : [
                     {
                        "path" : "/nodes/{node}/lxc/{vmid}",
                        "leaf" : 0,
                        "text" : "{vmid}",
                        "info" : {
                           "DELETE" : {
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "vmid" : {
                                       "minimum" : 1,
                                       "format" : "pve-vmid",
                                       "description" : "The (unique) ID of the VM.",
                                       "type" : "integer"
                                    },
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    }
                                 }
                              },
                              "description" : "Destroy the container (also delete all uses files).",
                              "method" : "DELETE",
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/vms/{vmid}",
                                    [
                                       "VM.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "string"
                              },
                              "proxyto" : "node",
                              "name" : "destroy_vm"
                           },
                           "GET" : {
                              "permissions" : {
                                 "user" : "all"
                              },
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "type" : "string",
                                       "description" : "The cluster node name."
                                    },
                                    "vmid" : {
                                       "format" : "pve-vmid",
                                       "minimum" : 1,
                                       "description" : "The (unique) ID of the VM.",
                                       "type" : "integer"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "returns" : {
                                 "links" : [
                                    {
                                       "rel" : "child",
                                       "href" : "{subdir}"
                                    }
                                 ],
                                 "type" : "array",
                                 "items" : {
                                    "properties" : {
                                       "subdir" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 }
                              },
                              "proxyto" : "node",
                              "name" : "vmdiridx",
                              "description" : "Directory index",
                              "method" : "GET"
                           }
                        },
                        "children" : [
                           {
                              "info" : {
                                 "PUT" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "nameserver" : {
                                             "description" : "Sets DNS server IP address for a container. Create will automatically use the setting from the host if you neither set searchdomain or nameserver.",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "address-list"
                                          },
                                          "tty" : {
                                             "default" : 2,
                                             "maximum" : 6,
                                             "optional" : 1,
                                             "minimum" : 0,
                                             "description" : "Specify the number of tty available to the container",
                                             "type" : "integer"
                                          },
                                          "hostname" : {
                                             "type" : "string",
                                             "maxLength" : 255,
                                             "description" : "Set a host name for the container.",
                                             "format" : "dns-name",
                                             "optional" : 1
                                          },
                                          "unused[n]" : {
                                             "type" : "string",
                                             "description" : "Reference to unused volumes.",
                                             "optional" : 1,
                                             "format" : "pve-volume-id"
                                          },
                                          "delete" : {
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "description" : "A list of settings you want to delete.",
                                             "type" : "string"
                                          },
                                          "cpulimit" : {
                                             "default" : 0,
                                             "optional" : 1,
                                             "maximum" : 128,
                                             "minimum" : 0,
                                             "type" : "number",
                                             "description" : "Limit of CPU usage. Note if the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit."
                                          },
                                          "net[n]" : {
                                             "type" : "string",
                                             "description" : "Specifies network interfaces for the container.",
                                             "optional" : 1,
                                             "format" : {
                                                "gw" : {
                                                   "type" : "string",
                                                   "description" : "Default gateway for IPv4 traffic.",
                                                   "format_description" : "GatewayIPv4",
                                                   "format" : "ipv4",
                                                   "optional" : 1
                                                },
                                                "name" : {
                                                   "pattern" : "[-_.\\w\\d]+",
                                                   "type" : "string",
                                                   "description" : "Name of the network device as seen from inside the container. (lxc.network.name)",
                                                   "format_description" : "String"
                                                },
                                                "mtu" : {
                                                   "type" : "integer",
                                                   "format_description" : "Number",
                                                   "description" : "Maximum transfer unit of the interface. (lxc.network.mtu)",
                                                   "optional" : 1,
                                                   "minimum" : 64
                                                },
                                                "gw6" : {
                                                   "type" : "string",
                                                   "format_description" : "GatewayIPv6",
                                                   "description" : "Default gateway for IPv6 traffic.",
                                                   "optional" : 1,
                                                   "format" : "ipv6"
                                                },
                                                "ip" : {
                                                   "format_description" : "IPv4Format/CIDR",
                                                   "description" : "IPv4 address in CIDR format.",
                                                   "type" : "string",
                                                   "format" : "pve-ipv4-config",
                                                   "optional" : 1
                                                },
                                                "tag" : {
                                                   "maximum" : "4094",
                                                   "optional" : 1,
                                                   "minimum" : "2",
                                                   "format_description" : "VlanNo",
                                                   "description" : "VLAN tag foro this interface.",
                                                   "type" : "integer"
                                                },
                                                "hwaddr" : {
                                                   "optional" : 1,
                                                   "type" : "string",
                                                   "pattern" : "(?^i:(?:[a-f0-9]{2}:){5}[a-f0-9]{2})",
                                                   "format_description" : "MAC",
                                                   "description" : "Bridge to attach the network device to. (lxc.network.hwaddr)"
                                                },
                                                "type" : {
                                                   "description" : "Network interface type.",
                                                   "type" : "string",
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "veth"
                                                   ]
                                                },
                                                "ip6" : {
                                                   "type" : "string",
                                                   "format_description" : "IPv6Format/CIDR",
                                                   "description" : "IPv6 address in CIDR format.",
                                                   "optional" : 1,
                                                   "format" : "pve-ipv6-config"
                                                },
                                                "bridge" : {
                                                   "type" : "string",
                                                   "pattern" : "[-_.\\w\\d]+",
                                                   "format_description" : "vmbr<Number>",
                                                   "description" : "Bridge to attach the network device to."
                                                },
                                                "firewall" : {
                                                   "format_description" : "[1|0]",
                                                   "description" : "Controls whether this interface's firewall rules should be used.",
                                                   "type" : "boolean",
                                                   "optional" : 1
                                                }
                                             }
                                          },
                                          "console" : {
                                             "description" : "Attach a console device (/dev/console) to the container.",
                                             "type" : "boolean",
                                             "default" : 1,
                                             "optional" : 1
                                          },
                                          "description" : {
                                             "type" : "string",
                                             "description" : "Container description. Only used on the configuration web interface.",
                                             "optional" : 1
                                          },
                                          "cpuunits" : {
                                             "minimum" : 0,
                                             "maximum" : 500000,
                                             "optional" : 1,
                                             "default" : 1024,
                                             "type" : "integer",
                                             "description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0."
                                          },
                                          "memory" : {
                                             "minimum" : 16,
                                             "default" : 512,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "description" : "Amount of RAM for the VM in MB."
                                          },
                                          "startup" : {
                                             "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] ",
                                             "optional" : 1,
                                             "format" : "pve-startup-order",
                                             "type" : "string",
                                             "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped."
                                          },
                                          "ostype" : {
                                             "description" : "OS type. Corresponds to lxc setup scripts in /usr/share/lxc/config/<ostype>.common.conf.",
                                             "type" : "string",
                                             "enum" : [
                                                "debian",
                                                "ubuntu",
                                                "centos",
                                                "archlinux"
                                             ],
                                             "optional" : 1
                                          },
                                          "swap" : {
                                             "minimum" : 0,
                                             "default" : 512,
                                             "optional" : 1,
                                             "description" : "Amount of SWAP for the VM in MB.",
                                             "type" : "integer"
                                          },
                                          "onboot" : {
                                             "default" : 0,
                                             "optional" : 1,
                                             "description" : "Specifies whether a VM will be started during system bootup.",
                                             "type" : "boolean"
                                          },
                                          "template" : {
                                             "type" : "boolean",
                                             "description" : "Enable/disable Template.",
                                             "default" : 0,
                                             "optional" : 1
                                          },
                                          "arch" : {
                                             "default" : "amd64",
                                             "optional" : 1,
                                             "enum" : [
                                                "amd64",
                                                "i386"
                                             ],
                                             "description" : "OS architecture type.",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "lock" : {
                                             "description" : "Lock/unlock the VM.",
                                             "type" : "string",
                                             "enum" : [
                                                "migrate",
                                                "backup",
                                                "snapshot",
                                                "rollback"
                                             ],
                                             "optional" : 1
                                          },
                                          "rootfs" : {
                                             "optional" : 1,
                                             "format" : {
                                                "size" : {
                                                   "description" : "Volume size (read only value).",
                                                   "format_description" : "DiskSize",
                                                   "type" : "disk-size",
                                                   "optional" : 1
                                                },
                                                "backup" : {
                                                   "optional" : 1,
                                                   "type" : "boolean",
                                                   "format_description" : "[1|0]",
                                                   "description" : "Whether to include the mountpoint in backups."
                                                },
                                                "volume" : {
                                                   "type" : "string",
                                                   "default_key" : 1,
                                                   "format_description" : "volume",
                                                   "description" : "Volume, device or directory to mount into the container."
                                                }
                                             },
                                             "type" : "string",
                                             "description" : "Use volume as container root."
                                          },
                                          "cmode" : {
                                             "enum" : [
                                                "shell",
                                                "console",
                                                "tty"
                                             ],
                                             "default" : "tty",
                                             "optional" : 1,
                                             "description" : "Console mode. By default, the console command tries to open a connection to one of the available tty devices. By setting cmode to 'console' it tries to attach to /dev/console instead. If you set cmode to 'shell', it simply invokes a shell inside the container (no login).",
                                             "type" : "string"
                                          },
                                          "digest" : {
                                             "type" : "string",
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1
                                          },
                                          "vmid" : {
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "mp[n]" : {
                                             "format" : {
                                                "volume" : {
                                                   "default_key" : 1,
                                                   "type" : "string",
                                                   "description" : "Volume, device or directory to mount into the container.",
                                                   "format_description" : "volume"
                                                },
                                                "size" : {
                                                   "type" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "description" : "Volume size (read only value).",
                                                   "optional" : 1
                                                },
                                                "backup" : {
                                                   "type" : "boolean",
                                                   "format_description" : "[1|0]",
                                                   "description" : "Whether to include the mountpoint in backups.",
                                                   "optional" : 1
                                                },
                                                "mp" : {
                                                   "optional" : 1,
                                                   "type" : "string",
                                                   "format_description" : "Path",
                                                   "description" : "Path to the mountpoint as seen from inside the container."
                                                }
                                             },
                                             "optional" : 1,
                                             "description" : "Use volume as container mount point (experimental feature).",
                                             "type" : "string"
                                          },
                                          "searchdomain" : {
                                             "description" : "Sets DNS search domains for a container. Create will automatically use the setting from the host if you neither set searchdomain or nameserver.",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "dns-name-list"
                                          },
                                          "protection" : {
                                             "default" : 0,
                                             "optional" : 1,
                                             "description" : "Sets the protection flag of the container. This will prevent the remove operation. This will prevent the CT or CT's disk remove/update operation.",
                                             "type" : "boolean"
                                          }
                                       }
                                    },
                                    "description" : "Set container options.",
                                    "method" : "PUT",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk",
                                             "VM.Config.CPU",
                                             "VM.Config.Memory",
                                             "VM.Config.Network",
                                             "VM.Config.Options"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "name" : "update_vm",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "proxyto" : "node"
                                 },
                                 "GET" : {
                                    "description" : "Get container configuration.",
                                    "method" : "GET",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "format" : "pve-vmid",
                                             "minimum" : 1
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          }
                                       }
                                    },
                                    "name" : "vm_config",
                                    "returns" : {
                                       "properties" : {
                                          "digest" : {
                                             "description" : "SHA1 digest of configuration file. This can be used to prevent concurrent modifications.",
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    },
                                    "proxyto" : "node",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    }
                                 }
                              },
                              "path" : "/nodes/{node}/lxc/{vmid}/config",
                              "leaf" : 0,
                              "text" : "config",
                              "children" : [
                                 {
                                    "text" : "{vmid}",
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/lxc/{vmid}/config/{vmid}",
                                    "children" : [
                                       {
                                          "info" : {
                                             "PUT" : {
                                                "parameters" : {
                                                   "properties" : {
                                                      "lock" : {
                                                         "enum" : [
                                                            "migrate",
                                                            "backup",
                                                            "snapshot",
                                                            "rollback"
                                                         ],
                                                         "optional" : 1,
                                                         "description" : "Lock/unlock the VM.",
                                                         "type" : "string"
                                                      },
                                                      "disk" : {
                                                         "description" : "The disk you want to resize.",
                                                         "type" : "string",
                                                         "enum" : [
                                                            "rootfs",
                                                            "mp0",
                                                            "mp1",
                                                            "mp2",
                                                            "mp3",
                                                            "mp4",
                                                            "mp5",
                                                            "mp6",
                                                            "mp7",
                                                            "mp8",
                                                            "mp9"
                                                         ]
                                                      },
                                                      "size" : {
                                                         "type" : "string",
                                                         "pattern" : "\\+?\\d+(\\.\\d+)?[KMGT]?",
                                                         "description" : "The new size. With the '+' sign the value is added to the actual size of the volume and without it, the value is taken as an absolute one. Shrinking disk size is not supported."
                                                      },
                                                      "cmode" : {
                                                         "description" : "Console mode. By default, the console command tries to open a connection to one of the available tty devices. By setting cmode to 'console' it tries to attach to /dev/console instead. If you set cmode to 'shell', it simply invokes a shell inside the container (no login).",
                                                         "type" : "string",
                                                         "default" : "tty",
                                                         "optional" : 1,
                                                         "enum" : [
                                                            "shell",
                                                            "console",
                                                            "tty"
                                                         ]
                                                      },
                                                      "rootfs" : {
                                                         "type" : "string",
                                                         "description" : "Use volume as container root.",
                                                         "format" : {
                                                            "volume" : {
                                                               "format_description" : "volume",
                                                               "description" : "Volume, device or directory to mount into the container.",
                                                               "default_key" : 1,
                                                               "type" : "string"
                                                            },
                                                            "size" : {
                                                               "optional" : 1,
                                                               "type" : "disk-size",
                                                               "format_description" : "DiskSize",
                                                               "description" : "Volume size (read only value)."
                                                            },
                                                            "backup" : {
                                                               "type" : "boolean",
                                                               "description" : "Whether to include the mountpoint in backups.",
                                                               "format_description" : "[1|0]",
                                                               "optional" : 1
                                                            }
                                                         },
                                                         "optional" : 1
                                                      },
                                                      "protection" : {
                                                         "type" : "boolean",
                                                         "description" : "Sets the protection flag of the container. This will prevent the remove operation. This will prevent the CT or CT's disk remove/update operation.",
                                                         "default" : 0,
                                                         "optional" : 1
                                                      },
                                                      "searchdomain" : {
                                                         "description" : "Sets DNS search domains for a container. Create will automatically use the setting from the host if you neither set searchdomain or nameserver.",
                                                         "type" : "string",
                                                         "optional" : 1,
                                                         "format" : "dns-name-list"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1
                                                      },
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "type" : "string",
                                                         "optional" : 1
                                                      },
                                                      "mp[n]" : {
                                                         "description" : "Use volume as container mount point (experimental feature).",
                                                         "type" : "string",
                                                         "format" : {
                                                            "backup" : {
                                                               "type" : "boolean",
                                                               "description" : "Whether to include the mountpoint in backups.",
                                                               "format_description" : "[1|0]",
                                                               "optional" : 1
                                                            },
                                                            "size" : {
                                                               "optional" : 1,
                                                               "type" : "disk-size",
                                                               "description" : "Volume size (read only value).",
                                                               "format_description" : "DiskSize"
                                                            },
                                                            "volume" : {
                                                               "default_key" : 1,
                                                               "type" : "string",
                                                               "format_description" : "volume",
                                                               "description" : "Volume, device or directory to mount into the container."
                                                            },
                                                            "mp" : {
                                                               "optional" : 1,
                                                               "format_description" : "Path",
                                                               "description" : "Path to the mountpoint as seen from inside the container.",
                                                               "type" : "string"
                                                            }
                                                         },
                                                         "optional" : 1
                                                      },
                                                      "memory" : {
                                                         "minimum" : 16,
                                                         "default" : 512,
                                                         "optional" : 1,
                                                         "description" : "Amount of RAM for the VM in MB.",
                                                         "type" : "integer"
                                                      },
                                                      "cpuunits" : {
                                                         "type" : "integer",
                                                         "description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "default" : 1024,
                                                         "maximum" : 500000
                                                      },
                                                      "ostype" : {
                                                         "enum" : [
                                                            "debian",
                                                            "ubuntu",
                                                            "centos",
                                                            "archlinux"
                                                         ],
                                                         "optional" : 1,
                                                         "type" : "string",
                                                         "description" : "OS type. Corresponds to lxc setup scripts in /usr/share/lxc/config/<ostype>.common.conf."
                                                      },
                                                      "startup" : {
                                                         "type" : "string",
                                                         "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped.",
                                                         "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] ",
                                                         "format" : "pve-startup-order",
                                                         "optional" : 1
                                                      },
                                                      "template" : {
                                                         "optional" : 1,
                                                         "default" : 0,
                                                         "type" : "boolean",
                                                         "description" : "Enable/disable Template."
                                                      },
                                                      "swap" : {
                                                         "description" : "Amount of SWAP for the VM in MB.",
                                                         "type" : "integer",
                                                         "minimum" : 0,
                                                         "default" : 512,
                                                         "optional" : 1
                                                      },
                                                      "onboot" : {
                                                         "default" : 0,
                                                         "optional" : 1,
                                                         "type" : "boolean",
                                                         "description" : "Specifies whether a VM will be started during system bootup."
                                                      },
                                                      "arch" : {
                                                         "type" : "string",
                                                         "description" : "OS architecture type.",
                                                         "default" : "amd64",
                                                         "optional" : 1,
                                                         "enum" : [
                                                            "amd64",
                                                            "i386"
                                                         ]
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "net[n]" : {
                                                         "format" : {
                                                            "gw" : {
                                                               "format" : "ipv4",
                                                               "optional" : 1,
                                                               "type" : "string",
                                                               "format_description" : "GatewayIPv4",
                                                               "description" : "Default gateway for IPv4 traffic."
                                                            },
                                                            "name" : {
                                                               "description" : "Name of the network device as seen from inside the container. (lxc.network.name)",
                                                               "format_description" : "String",
                                                               "pattern" : "[-_.\\w\\d]+",
                                                               "type" : "string"
                                                            },
                                                            "gw6" : {
                                                               "optional" : 1,
                                                               "format" : "ipv6",
                                                               "type" : "string",
                                                               "format_description" : "GatewayIPv6",
                                                               "description" : "Default gateway for IPv6 traffic."
                                                            },
                                                            "mtu" : {
                                                               "optional" : 1,
                                                               "minimum" : 64,
                                                               "format_description" : "Number",
                                                               "description" : "Maximum transfer unit of the interface. (lxc.network.mtu)",
                                                               "type" : "integer"
                                                            },
                                                            "hwaddr" : {
                                                               "optional" : 1,
                                                               "format_description" : "MAC",
                                                               "description" : "Bridge to attach the network device to. (lxc.network.hwaddr)",
                                                               "type" : "string",
                                                               "pattern" : "(?^i:(?:[a-f0-9]{2}:){5}[a-f0-9]{2})"
                                                            },
                                                            "tag" : {
                                                               "minimum" : "2",
                                                               "optional" : 1,
                                                               "maximum" : "4094",
                                                               "type" : "integer",
                                                               "description" : "VLAN tag foro this interface.",
                                                               "format_description" : "VlanNo"
                                                            },
                                                            "type" : {
                                                               "optional" : 1,
                                                               "enum" : [
                                                                  "veth"
                                                               ],
                                                               "type" : "string",
                                                               "description" : "Network interface type."
                                                            },
                                                            "firewall" : {
                                                               "optional" : 1,
                                                               "type" : "boolean",
                                                               "description" : "Controls whether this interface's firewall rules should be used.",
                                                               "format_description" : "[1|0]"
                                                            },
                                                            "ip6" : {
                                                               "format" : "pve-ipv6-config",
                                                               "optional" : 1,
                                                               "type" : "string",
                                                               "description" : "IPv6 address in CIDR format.",
                                                               "format_description" : "IPv6Format/CIDR"
                                                            },
                                                            "bridge" : {
                                                               "type" : "string",
                                                               "pattern" : "[-_.\\w\\d]+",
                                                               "format_description" : "vmbr<Number>",
                                                               "description" : "Bridge to attach the network device to."
                                                            },
                                                            "ip" : {
                                                               "format" : "pve-ipv4-config",
                                                               "optional" : 1,
                                                               "description" : "IPv4 address in CIDR format.",
                                                               "format_description" : "IPv4Format/CIDR",
                                                               "type" : "string"
                                                            }
                                                         },
                                                         "optional" : 1,
                                                         "description" : "Specifies network interfaces for the container.",
                                                         "type" : "string"
                                                      },
                                                      "cpulimit" : {
                                                         "type" : "number",
                                                         "description" : "Limit of CPU usage. Note if the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit.",
                                                         "optional" : 1,
                                                         "default" : 0,
                                                         "maximum" : 128,
                                                         "minimum" : 0
                                                      },
                                                      "console" : {
                                                         "description" : "Attach a console device (/dev/console) to the container.",
                                                         "type" : "boolean",
                                                         "optional" : 1,
                                                         "default" : 1
                                                      },
                                                      "description" : {
                                                         "optional" : 1,
                                                         "type" : "string",
                                                         "description" : "Container description. Only used on the configuration web interface."
                                                      },
                                                      "nameserver" : {
                                                         "type" : "string",
                                                         "description" : "Sets DNS server IP address for a container. Create will automatically use the setting from the host if you neither set searchdomain or nameserver.",
                                                         "optional" : 1,
                                                         "format" : "address-list"
                                                      },
                                                      "tty" : {
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "maximum" : 6,
                                                         "default" : 2,
                                                         "type" : "integer",
                                                         "description" : "Specify the number of tty available to the container"
                                                      },
                                                      "unused[n]" : {
                                                         "description" : "Reference to unused volumes.",
                                                         "type" : "string",
                                                         "optional" : 1,
                                                         "format" : "pve-volume-id"
                                                      },
                                                      "hostname" : {
                                                         "maxLength" : 255,
                                                         "description" : "Set a host name for the container.",
                                                         "type" : "string",
                                                         "optional" : 1,
                                                         "format" : "dns-name"
                                                      }
                                                   },
                                                   "additionalProperties" : 0
                                                },
                                                "description" : "Resize a container mountpoint.",
                                                "method" : "PUT",
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "resize_vm",
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Disk",
                                                         "VM.Config.CPU",
                                                         "VM.Config.Memory",
                                                         "VM.Config.Network",
                                                         "VM.Config.Options"
                                                      ],
                                                      "any",
                                                      1
                                                   ]
                                                },
                                                "protected" : 1
                                             }
                                          },
                                          "path" : "/nodes/{node}/lxc/{vmid}/config/{vmid}/resize",
                                          "text" : "resize",
                                          "leaf" : 1
                                       }
                                    ]
                                 }
                              ]
                           },
                           {
                              "children" : [
                                 {
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/current",
                                    "text" : "current",
                                    "leaf" : 1,
                                    "info" : {
                                       "GET" : {
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "object"
                                          },
                                          "name" : "vm_status",
                                          "description" : "Get virtual machine status.",
                                          "method" : "GET",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer"
                                                }
                                             }
                                          }
                                       }
                                    }
                                 },
                                 {
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/start",
                                    "leaf" : 1,
                                    "text" : "start",
                                    "info" : {
                                       "POST" : {
                                          "method" : "POST",
                                          "description" : "Start the container.",
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "proxyto" : "node",
                                          "name" : "vm_start",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer"
                                                }
                                             }
                                          }
                                       }
                                    }
                                 },
                                 {
                                    "leaf" : 1,
                                    "text" : "stop",
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/stop",
                                    "info" : {
                                       "POST" : {
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "proxyto" : "node",
                                          "name" : "vm_stop",
                                          "method" : "POST",
                                          "description" : "Stop the container.",
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid",
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM."
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          }
                                       }
                                    }
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Shutdown the container.",
                                          "method" : "POST",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "name" : "vm_shutdown",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "timeout" : {
                                                   "description" : "Wait maximal timeout seconds.",
                                                   "type" : "integer",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "default" : 60
                                                },
                                                "vmid" : {
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                },
                                                "forceStop" : {
                                                   "description" : "Make sure the Container stops.",
                                                   "type" : "boolean",
                                                   "default" : 0,
                                                   "optional" : 1
                                                }
                                             }
                                          }
                                       }
                                    },
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/shutdown",
                                    "leaf" : 1,
                                    "text" : "shutdown"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "properties" : {
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "POST",
                                          "description" : "Suspend the container.",
                                          "name" : "vm_suspend",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "proxyto" : "node",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1
                                       }
                                    },
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/suspend",
                                    "leaf" : 1,
                                    "text" : "suspend"
                                 },
                                 {
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/resume",
                                    "text" : "resume",
                                    "leaf" : 1,
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                }
                                             }
                                          },
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "proxyto" : "node",
                                          "name" : "vm_resume",
                                          "method" : "POST",
                                          "description" : "Resume the container."
                                       }
                                    }
                                 }
                              ],
                              "text" : "status",
                              "leaf" : 0,
                              "path" : "/nodes/{node}/lxc/{vmid}/status",
                              "info" : {
                                 "GET" : {
                                    "name" : "vmcmdidx",
                                    "returns" : {
                                       "links" : [
                                          {
                                             "rel" : "child",
                                             "href" : "{subdir}"
                                          }
                                       ],
                                       "type" : "array",
                                       "items" : {
                                          "type" : "object",
                                          "properties" : {
                                             "subdir" : {
                                                "type" : "string"
                                             }
                                          }
                                       }
                                    },
                                    "proxyto" : "node",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "user" : "all"
                                    },
                                    "method" : "GET",
                                    "description" : "Directory index"
                                 }
                              }
                           },
                           {
                              "children" : [
                                 {
                                    "children" : [
                                       {
                                          "info" : {
                                             "POST" : {
                                                "method" : "POST",
                                                "description" : "Rollback LXC state to specified snapshot.",
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "string",
                                                   "description" : "the task ID."
                                                },
                                                "name" : "rollback",
                                                "proxyto" : "node",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "vmid" : {
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid"
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "snapname" : {
                                                         "maxLength" : 40,
                                                         "description" : "The name of the snapshot.",
                                                         "type" : "string",
                                                         "format" : "pve-configid"
                                                      }
                                                   }
                                                }
                                             }
                                          },
                                          "path" : "/nodes/{node}/lxc/{vmid}/snapshot/{snapname}/rollback",
                                          "text" : "rollback",
                                          "leaf" : 1
                                       },
                                       {
                                          "info" : {
                                             "GET" : {
                                                "description" : "Get snapshot configuration",
                                                "method" : "GET",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "vmid" : {
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid",
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM."
                                                      },
                                                      "snapname" : {
                                                         "type" : "string",
                                                         "description" : "The name of the snapshot.",
                                                         "maxLength" : 40,
                                                         "format" : "pve-configid"
                                                      }
                                                   }
                                                },
                                                "proxyto" : "node",
                                                "name" : "get_snapshot_config",
                                                "returns" : {
                                                   "type" : "object"
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                }
                                             },
                                             "PUT" : {
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "update_snapshot_config",
                                                "proxyto" : "node",
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "method" : "PUT",
                                                "description" : "Update snapshot metadata.",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "snapname" : {
                                                         "type" : "string",
                                                         "description" : "The name of the snapshot.",
                                                         "maxLength" : 40,
                                                         "format" : "pve-configid"
                                                      },
                                                      "description" : {
                                                         "optional" : 1,
                                                         "description" : "A textual description or comment.",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "vmid" : {
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1
                                                      }
                                                   }
                                                }
                                             }
                                          },
                                          "path" : "/nodes/{node}/lxc/{vmid}/snapshot/{snapname}/config",
                                          "leaf" : 1,
                                          "text" : "config"
                                       }
                                    ],
                                    "info" : {
                                       "GET" : {
                                          "method" : "GET",
                                          "description" : "",
                                          "returns" : {
                                             "links" : [
                                                {
                                                   "rel" : "child",
                                                   "href" : "{cmd}"
                                                }
                                             ],
                                             "type" : "array",
                                             "items" : {
                                                "properties" : {},
                                                "type" : "object"
                                             }
                                          },
                                          "name" : "snapshot_cmd_idx",
                                          "parameters" : {
                                             "properties" : {
                                                "snapname" : {
                                                   "maxLength" : 40,
                                                   "description" : "The name of the snapshot.",
                                                   "type" : "string",
                                                   "format" : "pve-configid"
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "permissions" : {
                                             "user" : "all"
                                          }
                                       },
                                       "DELETE" : {
                                          "parameters" : {
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "type" : "string",
                                                   "format" : "pve-node"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                },
                                                "snapname" : {
                                                   "format" : "pve-configid",
                                                   "description" : "The name of the snapshot.",
                                                   "maxLength" : 40,
                                                   "type" : "string"
                                                },
                                                "force" : {
                                                   "optional" : 1,
                                                   "description" : "For removal from config file, even if removing disk snapshots fails.",
                                                   "type" : "boolean"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "DELETE",
                                          "description" : "Delete a LXC snapshot.",
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Snapshot"
                                                ]
                                             ]
                                          },
                                          "proxyto" : "node",
                                          "name" : "delsnapshot",
                                          "returns" : {
                                             "description" : "the task ID.",
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "path" : "/nodes/{node}/lxc/{vmid}/snapshot/{snapname}",
                                    "leaf" : 0,
                                    "text" : "{snapname}"
                                 }
                              ],
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "properties" : {
                                          "description" : {
                                             "type" : "string",
                                             "description" : "A textual description or comment.",
                                             "optional" : 1
                                          },
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "snapname" : {
                                             "description" : "The name of the snapshot.",
                                             "maxLength" : 40,
                                             "type" : "string",
                                             "format" : "pve-configid"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "method" : "POST",
                                    "description" : "Snapshot a container.",
                                    "name" : "snapshot",
                                    "returns" : {
                                       "type" : "string",
                                       "description" : "the task ID."
                                    },
                                    "proxyto" : "node",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Snapshot"
                                          ]
                                       ]
                                    }
                                 },
                                 "GET" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          }
                                       }
                                    },
                                    "description" : "List all snapshots.",
                                    "method" : "GET",
                                    "name" : "list",
                                    "returns" : {
                                       "links" : [
                                          {
                                             "href" : "{name}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "type" : "array",
                                       "items" : {
                                          "type" : "object",
                                          "properties" : {}
                                       }
                                    },
                                    "proxyto" : "node",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    }
                                 }
                              },
                              "path" : "/nodes/{node}/lxc/{vmid}/snapshot",
                              "text" : "snapshot",
                              "leaf" : 0
                           },
                           {
                              "children" : [
                                 {
                                    "leaf" : 0,
                                    "text" : "rules",
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/rules",
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "properties" : {
                                                "enable" : {
                                                   "type" : "integer",
                                                   "minimum" : 0,
                                                   "optional" : 1
                                                },
                                                "digest" : {
                                                   "maxLength" : 40,
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "type" : "string",
                                                   "optional" : 1
                                                },
                                                "vmid" : {
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "proto" : {
                                                   "optional" : 1,
                                                   "format" : "pve-fw-protocol-spec",
                                                   "type" : "string"
                                                },
                                                "dest" : {
                                                   "type" : "string",
                                                   "format" : "pve-fw-addr-spec",
                                                   "optional" : 1
                                                },
                                                "iface" : {
                                                   "optional" : 1,
                                                   "format" : "pve-iface",
                                                   "minLength" : 2,
                                                   "description" : "Network interface name.",
                                                   "maxLength" : 20,
                                                   "type" : "string"
                                                },
                                                "macro" : {
                                                   "optional" : 1,
                                                   "maxLength" : 128,
                                                   "type" : "string"
                                                },
                                                "dport" : {
                                                   "format" : "pve-fw-port-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "action" : {
                                                   "maxLength" : 20,
                                                   "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                                   "type" : "string",
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "optional" : 0,
                                                   "minLength" : 2
                                                },
                                                "source" : {
                                                   "format" : "pve-fw-addr-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "type" : {
                                                   "type" : "string",
                                                   "optional" : 0,
                                                   "enum" : [
                                                      "in",
                                                      "out",
                                                      "group"
                                                   ]
                                                },
                                                "pos" : {
                                                   "type" : "integer",
                                                   "description" : "Update rule at position <pos>.",
                                                   "optional" : 1,
                                                   "minimum" : 0
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "comment" : {
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "sport" : {
                                                   "type" : "string",
                                                   "optional" : 1,
                                                   "format" : "pve-fw-port-spec"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "POST",
                                          "description" : "Create new rule.",
                                          "name" : "create_rule",
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "proxyto" : null,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1
                                       },
                                       "GET" : {
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "type" : "array",
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {
                                                   "pos" : {
                                                      "type" : "integer"
                                                   }
                                                }
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{pos}",
                                                   "rel" : "child"
                                                }
                                             ]
                                          },
                                          "name" : "get_rules",
                                          "proxyto" : null,
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "GET",
                                          "description" : "List rules."
                                       }
                                    },
                                    "children" : [
                                       {
                                          "text" : "{pos}",
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/lxc/{vmid}/firewall/rules/{pos}",
                                          "info" : {
                                             "DELETE" : {
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "digest" : {
                                                         "type" : "string",
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1
                                                      },
                                                      "vmid" : {
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer"
                                                      },
                                                      "pos" : {
                                                         "type" : "integer",
                                                         "description" : "Update rule at position <pos>.",
                                                         "minimum" : 0,
                                                         "optional" : 1
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "description" : "The cluster node name.",
                                                         "type" : "string"
                                                      }
                                                   }
                                                },
                                                "description" : "Delete rule.",
                                                "method" : "DELETE",
                                                "protected" : 1,
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "proxyto" : null,
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "delete_rule"
                                             },
                                             "PUT" : {
                                                "name" : "update_rule",
                                                "proxyto" : null,
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "protected" : 1,
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "description" : "Modify rule data.",
                                                "method" : "PUT",
                                                "parameters" : {
                                                   "properties" : {
                                                      "comment" : {
                                                         "type" : "string",
                                                         "optional" : 1
                                                      },
                                                      "sport" : {
                                                         "type" : "string",
                                                         "format" : "pve-fw-port-spec",
                                                         "optional" : 1
                                                      },
                                                      "source" : {
                                                         "type" : "string",
                                                         "format" : "pve-fw-addr-spec",
                                                         "optional" : 1
                                                      },
                                                      "pos" : {
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "description" : "Update rule at position <pos>.",
                                                         "type" : "integer"
                                                      },
                                                      "dport" : {
                                                         "format" : "pve-fw-port-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "action" : {
                                                         "optional" : 1,
                                                         "minLength" : 2,
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "maxLength" : 20,
                                                         "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name."
                                                      },
                                                      "iface" : {
                                                         "type" : "string",
                                                         "maxLength" : 20,
                                                         "description" : "Network interface name.",
                                                         "optional" : 1,
                                                         "format" : "pve-iface",
                                                         "minLength" : 2
                                                      },
                                                      "dest" : {
                                                         "optional" : 1,
                                                         "format" : "pve-fw-addr-spec",
                                                         "type" : "string"
                                                      },
                                                      "proto" : {
                                                         "type" : "string",
                                                         "optional" : 1,
                                                         "format" : "pve-fw-protocol-spec"
                                                      },
                                                      "delete" : {
                                                         "type" : "string",
                                                         "description" : "A list of settings you want to delete.",
                                                         "format" : "pve-configid-list",
                                                         "optional" : 1
                                                      },
                                                      "enable" : {
                                                         "type" : "integer",
                                                         "minimum" : 0,
                                                         "optional" : 1
                                                      },
                                                      "moveto" : {
                                                         "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                                         "type" : "integer",
                                                         "minimum" : 0,
                                                         "optional" : 1
                                                      },
                                                      "type" : {
                                                         "optional" : 1,
                                                         "enum" : [
                                                            "in",
                                                            "out",
                                                            "group"
                                                         ],
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "macro" : {
                                                         "optional" : 1,
                                                         "type" : "string",
                                                         "maxLength" : 128
                                                      },
                                                      "vmid" : {
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid",
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM."
                                                      },
                                                      "digest" : {
                                                         "type" : "string",
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1
                                                      }
                                                   },
                                                   "additionalProperties" : 0
                                                }
                                             },
                                             "GET" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "name" : "get_rule",
                                                "returns" : {
                                                   "type" : "object",
                                                   "properties" : {
                                                      "pos" : {
                                                         "type" : "integer"
                                                      }
                                                   }
                                                },
                                                "proxyto" : null,
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "pos" : {
                                                         "description" : "Update rule at position <pos>.",
                                                         "type" : "integer",
                                                         "minimum" : 0,
                                                         "optional" : 1
                                                      },
                                                      "vmid" : {
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid"
                                                      }
                                                   }
                                                },
                                                "method" : "GET",
                                                "description" : "Get single rule data."
                                             }
                                          }
                                       }
                                    ]
                                 },
                                 {
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/aliases",
                                    "leaf" : 0,
                                    "text" : "aliases",
                                    "info" : {
                                       "POST" : {
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "name" : "create_alias",
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "name" : {
                                                   "minLength" : 2,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string",
                                                   "description" : "Alias name.",
                                                   "maxLength" : 64
                                                },
                                                "comment" : {
                                                   "type" : "string",
                                                   "optional" : 1
                                                },
                                                "cidr" : {
                                                   "format" : "IPorCIDR",
                                                   "type" : "string",
                                                   "description" : "Network/IP specification in CIDR format."
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                },
                                                "vmid" : {
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid",
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM."
                                                }
                                             }
                                          },
                                          "method" : "POST",
                                          "description" : "Create IP or Network Alias."
                                       },
                                       "GET" : {
                                          "method" : "GET",
                                          "description" : "List aliases",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "name" : "get_aliases",
                                          "returns" : {
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {
                                                   "cidr" : {
                                                      "type" : "string"
                                                   },
                                                   "digest" : {
                                                      "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                      "maxLength" : 40,
                                                      "type" : "string",
                                                      "optional" : 0
                                                   },
                                                   "name" : {
                                                      "type" : "string"
                                                   },
                                                   "comment" : {
                                                      "type" : "string",
                                                      "optional" : 1
                                                   }
                                                }
                                             },
                                             "type" : "array",
                                             "links" : [
                                                {
                                                   "rel" : "child",
                                                   "href" : "{name}"
                                                }
                                             ]
                                          },
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "type" : "string",
                                                   "format" : "pve-node"
                                                }
                                             }
                                          }
                                       }
                                    },
                                    "children" : [
                                       {
                                          "leaf" : 1,
                                          "text" : "{name}",
                                          "path" : "/nodes/{node}/lxc/{vmid}/firewall/aliases/{name}",
                                          "info" : {
                                             "PUT" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "cidr" : {
                                                         "type" : "string",
                                                         "description" : "Network/IP specification in CIDR format.",
                                                         "format" : "IPorCIDR"
                                                      },
                                                      "vmid" : {
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM."
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "type" : "string",
                                                         "format" : "pve-node"
                                                      },
                                                      "digest" : {
                                                         "optional" : 1,
                                                         "type" : "string",
                                                         "maxLength" : 40,
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications."
                                                      },
                                                      "name" : {
                                                         "minLength" : 2,
                                                         "maxLength" : 64,
                                                         "description" : "Alias name.",
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+"
                                                      },
                                                      "comment" : {
                                                         "type" : "string",
                                                         "optional" : 1
                                                      },
                                                      "rename" : {
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string",
                                                         "description" : "Rename an existing alias.",
                                                         "maxLength" : 64,
                                                         "optional" : 1,
                                                         "minLength" : 2
                                                      }
                                                   }
                                                },
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "update_alias",
                                                "description" : "Update IP or Network alias.",
                                                "method" : "PUT"
                                             },
                                             "GET" : {
                                                "method" : "GET",
                                                "description" : "Read alias.",
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "returns" : {
                                                   "type" : "object"
                                                },
                                                "name" : "read_alias",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "vmid" : {
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "type" : "string",
                                                         "format" : "pve-node"
                                                      },
                                                      "name" : {
                                                         "description" : "Alias name.",
                                                         "maxLength" : 64,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string",
                                                         "minLength" : 2
                                                      }
                                                   }
                                                }
                                             },
                                             "DELETE" : {
                                                "method" : "DELETE",
                                                "description" : "Remove IP or Network alias.",
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "remove_alias",
                                                "parameters" : {
                                                   "properties" : {
                                                      "name" : {
                                                         "minLength" : 2,
                                                         "maxLength" : 64,
                                                         "description" : "Alias name.",
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+"
                                                      },
                                                      "vmid" : {
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "type" : "integer"
                                                      },
                                                      "digest" : {
                                                         "optional" : 1,
                                                         "maxLength" : 40,
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      }
                                                   },
                                                   "additionalProperties" : 0
                                                }
                                             }
                                          }
                                       }
                                    ]
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "method" : "POST",
                                          "description" : "Create new IPSet",
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "name" : "create_ipset",
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "digest" : {
                                                   "maxLength" : 40,
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "type" : "string",
                                                   "optional" : 1
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "comment" : {
                                                   "type" : "string",
                                                   "optional" : 1
                                                },
                                                "rename" : {
                                                   "type" : "string",
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "maxLength" : 64,
                                                   "description" : "Rename an existing IPSet. You can set 'rename' to the same value as 'name' to update the 'comment' of an existing IPSet.",
                                                   "optional" : 1,
                                                   "minLength" : 2
                                                },
                                                "name" : {
                                                   "type" : "string",
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "maxLength" : 64,
                                                   "description" : "IP set name.",
                                                   "minLength" : 2
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "protected" : 1,
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          }
                                       },
                                       "GET" : {
                                          "method" : "GET",
                                          "description" : "List IPSets",
                                          "name" : "ipset_index",
                                          "returns" : {
                                             "type" : "array",
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {
                                                   "name" : {
                                                      "type" : "string",
                                                      "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                      "maxLength" : 64,
                                                      "description" : "IP set name.",
                                                      "minLength" : 2
                                                   },
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "digest" : {
                                                      "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                      "maxLength" : 40,
                                                      "type" : "string",
                                                      "optional" : 0
                                                   }
                                                }
                                             },
                                             "links" : [
                                                {
                                                   "rel" : "child",
                                                   "href" : "{name}"
                                                }
                                             ]
                                          },
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          }
                                       }
                                    },
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/ipset",
                                    "leaf" : 0,
                                    "text" : "ipset",
                                    "children" : [
                                       {
                                          "info" : {
                                             "POST" : {
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "create_ip",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "vmid" : {
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1
                                                      },
                                                      "nomatch" : {
                                                         "type" : "boolean",
                                                         "optional" : 1
                                                      },
                                                      "node" : {
                                                         "type" : "string",
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node"
                                                      },
                                                      "cidr" : {
                                                         "format" : "IPorCIDRorAlias",
                                                         "type" : "string",
                                                         "description" : "Network/IP specification in CIDR format."
                                                      },
                                                      "comment" : {
                                                         "type" : "string",
                                                         "optional" : 1
                                                      },
                                                      "name" : {
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string",
                                                         "description" : "IP set name.",
                                                         "maxLength" : 64
                                                      }
                                                   }
                                                },
                                                "protected" : 1,
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "method" : "POST",
                                                "description" : "Add IP or Network to IPSet."
                                             },
                                             "DELETE" : {
                                                "method" : "DELETE",
                                                "description" : "Delete IPSet",
                                                "returns" : {
                                                   "type" : "null"
                                                },
                                                "name" : "delete_ipset",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "vmid" : {
                                                         "minimum" : 1,
                                                         "format" : "pve-vmid",
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM."
                                                      },
                                                      "node" : {
                                                         "type" : "string",
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node"
                                                      },
                                                      "name" : {
                                                         "minLength" : 2,
                                                         "maxLength" : 64,
                                                         "description" : "IP set name.",
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1
                                             },
                                             "GET" : {
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "vmid" : {
                                                         "type" : "integer",
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1
                                                      },
                                                      "node" : {
                                                         "format" : "pve-node",
                                                         "type" : "string",
                                                         "description" : "The cluster node name."
                                                      },
                                                      "name" : {
                                                         "minLength" : 2,
                                                         "type" : "string",
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "maxLength" : 64,
                                                         "description" : "IP set name."
                                                      }
                                                   }
                                                },
                                                "name" : "get_ipset",
                                                "returns" : {
                                                   "links" : [
                                                      {
                                                         "rel" : "child",
                                                         "href" : "{cidr}"
                                                      }
                                                   ],
                                                   "type" : "array",
                                                   "items" : {
                                                      "properties" : {
                                                         "cidr" : {
                                                            "type" : "string"
                                                         },
                                                         "nomatch" : {
                                                            "type" : "boolean",
                                                            "optional" : 1
                                                         },
                                                         "digest" : {
                                                            "optional" : 0,
                                                            "type" : "string",
                                                            "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                            "maxLength" : 40
                                                         },
                                                         "comment" : {
                                                            "type" : "string",
                                                            "optional" : 1
                                                         }
                                                      },
                                                      "type" : "object"
                                                   }
                                                },
                                                "description" : "List IPSet content",
                                                "method" : "GET"
                                             }
                                          },
                                          "text" : "{name}",
                                          "leaf" : 0,
                                          "path" : "/nodes/{node}/lxc/{vmid}/firewall/ipset/{name}",
                                          "children" : [
                                             {
                                                "info" : {
                                                   "DELETE" : {
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Config.Network"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "returns" : {
                                                         "type" : "null"
                                                      },
                                                      "name" : "remove_ip",
                                                      "parameters" : {
                                                         "properties" : {
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "type" : "integer",
                                                               "minimum" : 1,
                                                               "format" : "pve-vmid"
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "type" : "string",
                                                               "format" : "pve-node"
                                                            },
                                                            "digest" : {
                                                               "optional" : 1,
                                                               "maxLength" : 40,
                                                               "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                               "type" : "string"
                                                            },
                                                            "cidr" : {
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string",
                                                               "description" : "Network/IP specification in CIDR format."
                                                            },
                                                            "name" : {
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string",
                                                               "minLength" : 2
                                                            }
                                                         },
                                                         "additionalProperties" : 0
                                                      },
                                                      "method" : "DELETE",
                                                      "description" : "Remove IP or Network from IPSet."
                                                   },
                                                   "PUT" : {
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Config.Network"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "name" : "update_ip",
                                                      "returns" : {
                                                         "type" : "null"
                                                      },
                                                      "parameters" : {
                                                         "properties" : {
                                                            "name" : {
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string",
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2
                                                            },
                                                            "comment" : {
                                                               "optional" : 1,
                                                               "type" : "string"
                                                            },
                                                            "cidr" : {
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string",
                                                               "description" : "Network/IP specification in CIDR format."
                                                            },
                                                            "digest" : {
                                                               "optional" : 1,
                                                               "type" : "string",
                                                               "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                               "maxLength" : 40
                                                            },
                                                            "nomatch" : {
                                                               "type" : "boolean",
                                                               "optional" : 1
                                                            },
                                                            "vmid" : {
                                                               "minimum" : 1,
                                                               "format" : "pve-vmid",
                                                               "type" : "integer",
                                                               "description" : "The (unique) ID of the VM."
                                                            },
                                                            "node" : {
                                                               "type" : "string",
                                                               "description" : "The cluster node name.",
                                                               "format" : "pve-node"
                                                            }
                                                         },
                                                         "additionalProperties" : 0
                                                      },
                                                      "method" : "PUT",
                                                      "description" : "Update IP or Network settings"
                                                   },
                                                   "GET" : {
                                                      "description" : "Read IP or Network settings from IPSet.",
                                                      "method" : "GET",
                                                      "protected" : 1,
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Audit"
                                                            ]
                                                         ]
                                                      },
                                                      "parameters" : {
                                                         "properties" : {
                                                            "name" : {
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string",
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "type" : "string",
                                                               "format" : "pve-node"
                                                            },
                                                            "vmid" : {
                                                               "format" : "pve-vmid",
                                                               "minimum" : 1,
                                                               "type" : "integer",
                                                               "description" : "The (unique) ID of the VM."
                                                            },
                                                            "cidr" : {
                                                               "format" : "IPorCIDRorAlias",
                                                               "description" : "Network/IP specification in CIDR format.",
                                                               "type" : "string"
                                                            }
                                                         },
                                                         "additionalProperties" : 0
                                                      },
                                                      "returns" : {
                                                         "type" : "object"
                                                      },
                                                      "name" : "read_ip"
                                                   }
                                                },
                                                "text" : "{cidr}",
                                                "leaf" : 1,
                                                "path" : "/nodes/{node}/lxc/{vmid}/firewall/ipset/{name}/{cidr}"
                                             }
                                          ]
                                       }
                                    ]
                                 },
                                 {
                                    "info" : {
                                       "PUT" : {
                                          "method" : "PUT",
                                          "description" : "Set Firewall options.",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "proxyto" : "node",
                                          "name" : "set_options",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "policy_out" : {
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "type" : "string",
                                                   "description" : "Output policy."
                                                },
                                                "delete" : {
                                                   "format" : "pve-configid-list",
                                                   "optional" : 1,
                                                   "description" : "A list of settings you want to delete.",
                                                   "type" : "string"
                                                },
                                                "policy_in" : {
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "description" : "Input policy.",
                                                   "type" : "string"
                                                },
                                                "dhcp" : {
                                                   "optional" : 1,
                                                   "description" : "Enable DHCP.",
                                                   "type" : "boolean"
                                                },
                                                "log_level_in" : {
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "type" : "string",
                                                   "description" : "Log level for incoming traffic."
                                                },
                                                "enable" : {
                                                   "optional" : 1,
                                                   "type" : "boolean",
                                                   "description" : "Enable host firewall rules."
                                                },
                                                "digest" : {
                                                   "optional" : 1,
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid",
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM."
                                                },
                                                "log_level_out" : {
                                                   "type" : "string",
                                                   "description" : "Log level for outgoing traffic.",
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ]
                                                },
                                                "macfilter" : {
                                                   "type" : "boolean",
                                                   "description" : "Enable/disable MAC address filter.",
                                                   "optional" : 1
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                }
                                             }
                                          }
                                       },
                                       "GET" : {
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "properties" : {
                                                "dhcp" : {
                                                   "optional" : 1,
                                                   "type" : "boolean",
                                                   "description" : "Enable DHCP."
                                                },
                                                "policy_in" : {
                                                   "optional" : 1,
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "description" : "Input policy.",
                                                   "type" : "string"
                                                },
                                                "policy_out" : {
                                                   "description" : "Output policy.",
                                                   "type" : "string",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1
                                                },
                                                "macfilter" : {
                                                   "optional" : 1,
                                                   "description" : "Enable/disable MAC address filter.",
                                                   "type" : "boolean"
                                                },
                                                "log_level_out" : {
                                                   "type" : "string",
                                                   "description" : "Log level for outgoing traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1
                                                },
                                                "log_level_in" : {
                                                   "type" : "string",
                                                   "description" : "Log level for incoming traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1
                                                },
                                                "enable" : {
                                                   "type" : "boolean",
                                                   "description" : "Enable host firewall rules.",
                                                   "optional" : 1
                                                }
                                             },
                                             "type" : "object"
                                          },
                                          "proxyto" : "node",
                                          "name" : "get_options",
                                          "parameters" : {
                                             "properties" : {
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                },
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "GET",
                                          "description" : "Get VM firewall options."
                                       }
                                    },
                                    "leaf" : 1,
                                    "text" : "options",
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/options"
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "parameters" : {
                                             "properties" : {
                                                "limit" : {
                                                   "type" : "integer",
                                                   "minimum" : 0,
                                                   "optional" : 1
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "type" : "string",
                                                   "format" : "pve-node"
                                                },
                                                "start" : {
                                                   "type" : "integer",
                                                   "minimum" : 0,
                                                   "optional" : 1
                                                },
                                                "vmid" : {
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "description" : "The (unique) ID of the VM."
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "GET",
                                          "description" : "Read firewall log",
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Console"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "returns" : {
                                             "type" : "array",
                                             "items" : {
                                                "properties" : {
                                                   "n" : {
                                                      "type" : "integer",
                                                      "description" : "Line number"
                                                   },
                                                   "t" : {
                                                      "description" : "Line text",
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             }
                                          },
                                          "name" : "log",
                                          "proxyto" : "node"
                                       }
                                    },
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/log",
                                    "text" : "log",
                                    "leaf" : 1
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "type" : {
                                                   "type" : "string",
                                                   "description" : "Only list references of specified type.",
                                                   "enum" : [
                                                      "alias",
                                                      "ipset"
                                                   ],
                                                   "optional" : 1
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "type" : "integer",
                                                   "minimum" : 1,
                                                   "format" : "pve-vmid"
                                                }
                                             }
                                          },
                                          "returns" : {
                                             "items" : {
                                                "type" : "object",
                                                "properties" : {
                                                   "name" : {
                                                      "type" : "string"
                                                   },
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "type" : {
                                                      "enum" : [
                                                         "alias",
                                                         "ipset"
                                                      ],
                                                      "type" : "string"
                                                   }
                                                }
                                             },
                                             "type" : "array"
                                          },
                                          "name" : "refs",
                                          "description" : "Lists possible IPSet/Alias reference which are allowed in source/dest properties.",
                                          "method" : "GET"
                                       }
                                    },
                                    "text" : "refs",
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/refs"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "description" : "Directory index.",
                                    "method" : "GET",
                                    "permissions" : {
                                       "user" : "all"
                                    },
                                    "parameters" : {
                                       "properties" : {
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "name" : "index",
                                    "returns" : {
                                       "type" : "array",
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "links" : [
                                          {
                                             "rel" : "child",
                                             "href" : "{name}"
                                          }
                                       ]
                                    }
                                 }
                              },
                              "path" : "/nodes/{node}/lxc/{vmid}/firewall",
                              "leaf" : 0,
                              "text" : "firewall"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read VM RRD statistics (returns PNG)",
                                    "method" : "GET",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "parameters" : {
                                       "properties" : {
                                          "timeframe" : {
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string",
                                             "description" : "Specify the time frame you are interested in."
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "cf" : {
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "The RRD consolidation function"
                                          },
                                          "ds" : {
                                             "description" : "The list of datasources you want to display.",
                                             "type" : "string",
                                             "format" : "pve-configid-list"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "returns" : {
                                       "properties" : {
                                          "filename" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    },
                                    "name" : "rrd"
                                 }
                              },
                              "leaf" : 1,
                              "text" : "rrd",
                              "path" : "/nodes/{node}/lxc/{vmid}/rrd"
                           },
                           {
                              "path" : "/nodes/{node}/lxc/{vmid}/rrddata",
                              "leaf" : 1,
                              "text" : "rrddata",
                              "info" : {
                                 "GET" : {
                                    "parameters" : {
                                       "properties" : {
                                          "timeframe" : {
                                             "description" : "Specify the time frame you are interested in.",
                                             "type" : "string",
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ]
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "cf" : {
                                             "optional" : 1,
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "description" : "The RRD consolidation function",
                                             "type" : "string"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "returns" : {
                                       "items" : {
                                          "type" : "object",
                                          "properties" : {}
                                       },
                                       "type" : "array"
                                    },
                                    "name" : "rrddata",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "description" : "Read VM RRD statistics",
                                    "method" : "GET"
                                 }
                              }
                           },
                           {
                              "path" : "/nodes/{node}/lxc/{vmid}/vncproxy",
                              "leaf" : 1,
                              "text" : "vncproxy",
                              "info" : {
                                 "POST" : {
                                    "description" : "Creates a TCP VNC proxy connections.",
                                    "method" : "POST",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "websocket" : {
                                             "optional" : 1,
                                             "description" : "use websocket instead of standard VNC.",
                                             "type" : "boolean"
                                          }
                                       }
                                    },
                                    "returns" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "port" : {
                                             "type" : "integer"
                                          },
                                          "cert" : {
                                             "type" : "string"
                                          },
                                          "user" : {
                                             "type" : "string"
                                          },
                                          "upid" : {
                                             "type" : "string"
                                          },
                                          "ticket" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "name" : "vncproxy"
                                 }
                              }
                           },
                           {
                              "leaf" : 1,
                              "text" : "vncwebsocket",
                              "path" : "/nodes/{node}/lxc/{vmid}/vncwebsocket",
                              "info" : {
                                 "GET" : {
                                    "returns" : {
                                       "properties" : {
                                          "port" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    },
                                    "name" : "vncwebsocket",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "format" : "pve-vmid",
                                             "minimum" : 1
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "port" : {
                                             "type" : "integer",
                                             "description" : "Port number returned by previous vncproxy call.",
                                             "minimum" : 5900,
                                             "maximum" : 5999
                                          },
                                          "vncticket" : {
                                             "maxLength" : 512,
                                             "description" : "Ticket from previous call to vncproxy.",
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "description" : "You also need to pass a valid ticket (vncticket).",
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "method" : "GET",
                                    "description" : "Opens a weksocket for VNC traffic."
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Returns a SPICE configuration to connect to the CT.",
                                    "method" : "POST",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "returns" : {
                                       "properties" : {
                                          "tls-port" : {
                                             "type" : "integer"
                                          },
                                          "proxy" : {
                                             "type" : "string"
                                          },
                                          "type" : {
                                             "type" : "string"
                                          },
                                          "host" : {
                                             "type" : "string"
                                          },
                                          "password" : {
                                             "type" : "string"
                                          }
                                       },
                                       "description" : "Returned values can be directly passed to the 'remote-viewer' application.",
                                       "additionalProperties" : 1
                                    },
                                    "name" : "spiceproxy",
                                    "proxyto" : "node",
                                    "parameters" : {
                                       "properties" : {
                                          "proxy" : {
                                             "optional" : 1,
                                             "format" : "address",
                                             "type" : "string",
                                             "description" : "SPICE proxy server. This can be used by the client to specify the proxy server. All nodes in a cluster runs 'spiceproxy', so it is up to the client to choose one. By default, we return the node where the VM is currently running. As resonable setting is to use same node you use to connect to the API (This is window.location.hostname for the JS GUI)."
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM.",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 }
                              },
                              "path" : "/nodes/{node}/lxc/{vmid}/spiceproxy",
                              "text" : "spiceproxy",
                              "leaf" : 1
                           },
                           {
                              "text" : "migrate",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/migrate",
                              "info" : {
                                 "POST" : {
                                    "returns" : {
                                       "description" : "the task ID.",
                                       "type" : "string"
                                    },
                                    "name" : "migrate_vm",
                                    "proxyto" : "node",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Migrate"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "description" : "Migrate the container to another node. Creates a new migration task.",
                                    "method" : "POST",
                                    "parameters" : {
                                       "properties" : {
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "type" : "integer",
                                             "description" : "The (unique) ID of the VM."
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          },
                                          "target" : {
                                             "format" : "pve-node",
                                             "description" : "Target node.",
                                             "type" : "string"
                                          },
                                          "online" : {
                                             "optional" : 1,
                                             "description" : "Use online/live migration.",
                                             "type" : "boolean"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "parameters" : {
                                       "properties" : {
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "feature" : {
                                             "description" : "Feature to check.",
                                             "type" : "string",
                                             "enum" : [
                                                "snapshot"
                                             ]
                                          },
                                          "snapname" : {
                                             "format" : "pve-configid",
                                             "optional" : 1,
                                             "description" : "The name of the snapshot.",
                                             "maxLength" : 40,
                                             "type" : "string"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "method" : "GET",
                                    "description" : "Check if feature for virtual machine is available.",
                                    "name" : "vm_feature",
                                    "returns" : {
                                       "type" : "object",
                                       "properties" : {
                                          "hasFeature" : {
                                             "type" : "boolean"
                                          }
                                       }
                                    },
                                    "proxyto" : "node",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    }
                                 }
                              },
                              "path" : "/nodes/{node}/lxc/{vmid}/feature",
                              "leaf" : 1,
                              "text" : "feature"
                           },
                           {
                              "path" : "/nodes/{node}/lxc/{vmid}/template",
                              "text" : "template",
                              "leaf" : 1,
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "properties" : {
                                          "vmid" : {
                                             "minimum" : 1,
                                             "format" : "pve-vmid",
                                             "description" : "The (unique) ID of the VM.",
                                             "type" : "integer"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Allocate"
                                          ]
                                       ],
                                       "description" : "You need 'VM.Allocate' permissions on /vms/{vmid}"
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "name" : "template",
                                    "description" : "Create a Template.",
                                    "method" : "POST"
                                 }
                              }
                           }
                        ]
                     }
                  ]
               },
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "children" : [
                                 {
                                    "info" : {
                                       "POST" : {
                                          "parameters" : {
                                             "properties" : {
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "osdid" : {
                                                   "description" : "OSD ID",
                                                   "type" : "integer"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "name" : "in",
                                          "protected" : 1,
                                          "description" : "ceph osd in",
                                          "method" : "POST"
                                       }
                                    },
                                    "path" : "/nodes/{node}/ceph/osd/{osdid}/in",
                                    "text" : "in",
                                    "leaf" : 1
                                 },
                                 {
                                    "path" : "/nodes/{node}/ceph/osd/{osdid}/out",
                                    "text" : "out",
                                    "leaf" : 1,
                                    "info" : {
                                       "POST" : {
                                          "description" : "ceph osd out",
                                          "method" : "POST",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "description" : "The cluster node name.",
                                                   "type" : "string"
                                                },
                                                "osdid" : {
                                                   "type" : "integer",
                                                   "description" : "OSD ID"
                                                }
                                             }
                                          },
                                          "name" : "out",
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "protected" : 1
                                       }
                                    }
                                 }
                              ],
                              "text" : "{osdid}",
                              "leaf" : 0,
                              "path" : "/nodes/{node}/ceph/osd/{osdid}",
                              "info" : {
                                 "DELETE" : {
                                    "parameters" : {
                                       "properties" : {
                                          "osdid" : {
                                             "description" : "OSD ID",
                                             "type" : "integer"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "cleanup" : {
                                             "type" : "boolean",
                                             "description" : "If set, we remove partition table entries.",
                                             "optional" : 1,
                                             "default" : 0
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "proxyto" : "node",
                                    "name" : "destroyosd",
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "protected" : 1,
                                    "description" : "Destroy OSD",
                                    "method" : "DELETE"
                                 }
                              }
                           }
                        ],
                        "path" : "/nodes/{node}/ceph/osd",
                        "leaf" : 0,
                        "text" : "osd",
                        "info" : {
                           "GET" : {
                              "proxyto" : "node",
                              "name" : "index",
                              "returns" : {
                                 "type" : "object"
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "type" : "string",
                                       "description" : "The cluster node name."
                                    }
                                 }
                              },
                              "protected" : 1,
                              "method" : "GET",
                              "description" : "Get Ceph osd list/tree."
                           },
                           "POST" : {
                              "method" : "POST",
                              "description" : "Create OSD",
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              },
                              "name" : "createosd",
                              "parameters" : {
                                 "properties" : {
                                    "journal_dev" : {
                                       "description" : "Block device name for journal.",
                                       "type" : "string",
                                       "optional" : 1
                                    },
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    },
                                    "dev" : {
                                       "description" : "Block device name.",
                                       "type" : "string"
                                    },
                                    "fstype" : {
                                       "optional" : 1,
                                       "default" : "xfs",
                                       "enum" : [
                                          "xfs",
                                          "ext4",
                                          "btrfs"
                                       ],
                                       "type" : "string",
                                       "description" : "File system type."
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           }
                        }
                     },
                     {
                        "leaf" : 1,
                        "text" : "disks",
                        "path" : "/nodes/{node}/ceph/disks",
                        "info" : {
                           "GET" : {
                              "method" : "GET",
                              "description" : "List local disks.",
                              "protected" : 1,
                              "proxyto" : "node",
                              "name" : "disks",
                              "returns" : {
                                 "type" : "array",
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "dev" : {
                                          "type" : "string"
                                       },
                                       "serial" : {
                                          "type" : "string",
                                          "optional" : 1
                                       },
                                       "size" : {
                                          "type" : "integer"
                                       },
                                       "gpt" : {
                                          "type" : "boolean"
                                       },
                                       "used" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "model" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "vendor" : {
                                          "type" : "string",
                                          "optional" : 1
                                       },
                                       "osdid" : {
                                          "type" : "integer"
                                       }
                                    }
                                 }
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "type" : "string",
                                       "description" : "The cluster node name."
                                    },
                                    "type" : {
                                       "type" : "string",
                                       "description" : "Only list specific types of disks.",
                                       "optional" : 1,
                                       "enum" : [
                                          "unused",
                                          "journal_disks"
                                       ]
                                    }
                                 }
                              }
                           }
                        }
                     },
                     {
                        "path" : "/nodes/{node}/ceph/config",
                        "leaf" : 1,
                        "text" : "config",
                        "info" : {
                           "GET" : {
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 }
                              },
                              "returns" : {
                                 "type" : "string"
                              },
                              "name" : "config",
                              "description" : "Get Ceph configuration.",
                              "method" : "GET"
                           }
                        }
                     },
                     {
                        "children" : [
                           {
                              "text" : "{monid}",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/ceph/mon/{monid}",
                              "info" : {
                                 "DELETE" : {
                                    "protected" : 1,
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "monid" : {
                                             "description" : "Monitor ID",
                                             "type" : "integer"
                                          }
                                       }
                                    },
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "proxyto" : "node",
                                    "name" : "destroymon",
                                    "description" : "Destroy Ceph monitor.",
                                    "method" : "DELETE"
                                 }
                              }
                           }
                        ],
                        "text" : "mon",
                        "leaf" : 0,
                        "path" : "/nodes/{node}/ceph/mon",
                        "info" : {
                           "POST" : {
                              "description" : "Create Ceph Monitor",
                              "method" : "POST",
                              "protected" : 1,
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "name" : "createmon",
                              "returns" : {
                                 "type" : "string"
                              },
                              "proxyto" : "node"
                           },
                           "GET" : {
                              "name" : "listmon",
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "addr" : {
                                          "type" : "string"
                                       },
                                       "name" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array",
                                 "links" : [
                                    {
                                       "href" : "{name}",
                                       "rel" : "child"
                                    }
                                 ]
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "protected" : 1,
                              "method" : "GET",
                              "description" : "Get Ceph monitor list."
                           }
                        }
                     },
                     {
                        "text" : "init",
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/init",
                        "info" : {
                           "POST" : {
                              "method" : "POST",
                              "description" : "Create initial ceph default configuration and setup symlinks.",
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              },
                              "name" : "init",
                              "proxyto" : "node",
                              "parameters" : {
                                 "properties" : {
                                    "pg_bits" : {
                                       "type" : "integer",
                                       "description" : "Placement group bits, used to specify the default number of placement groups (Note: 'osd pool default pg num' does not work for deafult pools)",
                                       "minimum" : 6,
                                       "maximum" : 14,
                                       "default" : 6,
                                       "optional" : 1
                                    },
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    },
                                    "network" : {
                                       "optional" : 1,
                                       "format" : "CIDR",
                                       "type" : "string",
                                       "description" : "Use specific network for all ceph related traffic",
                                       "maxLength" : 128
                                    },
                                    "size" : {
                                       "optional" : 1,
                                       "maximum" : 3,
                                       "default" : 2,
                                       "minimum" : 1,
                                       "type" : "integer",
                                       "description" : "Number of replicas per object"
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           }
                        }
                     },
                     {
                        "path" : "/nodes/{node}/ceph/stop",
                        "leaf" : 1,
                        "text" : "stop",
                        "info" : {
                           "POST" : {
                              "description" : "Stop ceph services.",
                              "method" : "POST",
                              "protected" : 1,
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "service" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "pattern" : "(mon|mds|osd)\\.[A-Za-z0-9]{1,32}",
                                       "description" : "Ceph service name."
                                    },
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "returns" : {
                                 "type" : "string"
                              },
                              "proxyto" : "node",
                              "name" : "stop"
                           }
                        }
                     },
                     {
                        "leaf" : 1,
                        "text" : "start",
                        "path" : "/nodes/{node}/ceph/start",
                        "info" : {
                           "POST" : {
                              "description" : "Start ceph services.",
                              "method" : "POST",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "type" : "string",
                                       "description" : "The cluster node name."
                                    },
                                    "service" : {
                                       "description" : "Ceph service name.",
                                       "type" : "string",
                                       "pattern" : "(mon|mds|osd)\\.[A-Za-z0-9]{1,32}",
                                       "optional" : 1
                                    }
                                 }
                              },
                              "name" : "start",
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              },
                              "protected" : 1
                           }
                        }
                     },
                     {
                        "text" : "status",
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/status",
                        "info" : {
                           "GET" : {
                              "description" : "Get ceph status.",
                              "method" : "GET",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 }
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "object"
                              },
                              "name" : "status",
                              "protected" : 1
                           }
                        }
                     },
                     {
                        "info" : {
                           "POST" : {
                              "method" : "POST",
                              "description" : "Create POOL",
                              "protected" : 1,
                              "name" : "createpool",
                              "returns" : {
                                 "type" : "null"
                              },
                              "proxyto" : "node",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "type" : "string",
                                       "description" : "The cluster node name."
                                    },
                                    "pg_num" : {
                                       "type" : "integer",
                                       "description" : "Number of placement groups.",
                                       "maximum" : 32768,
                                       "optional" : 1,
                                       "default" : 64,
                                       "minimum" : 8
                                    },
                                    "size" : {
                                       "description" : "Number of replicas per object",
                                       "type" : "integer",
                                       "minimum" : 1,
                                       "optional" : 1,
                                       "maximum" : 3,
                                       "default" : 2
                                    },
                                    "name" : {
                                       "type" : "string",
                                       "description" : "The name of the pool. It must be unique."
                                    },
                                    "min_size" : {
                                       "type" : "integer",
                                       "description" : "Minimum number of replicas per object",
                                       "default" : 1,
                                       "maximum" : 3,
                                       "optional" : 1,
                                       "minimum" : 1
                                    },
                                    "crush_ruleset" : {
                                       "type" : "integer",
                                       "description" : "The ruleset to use for mapping object placement in the cluster.",
                                       "default" : 0,
                                       "optional" : 1,
                                       "maximum" : 32768,
                                       "minimum" : 0
                                    }
                                 }
                              }
                           },
                           "GET" : {
                              "description" : "List all pools.",
                              "method" : "GET",
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "name" : "lspools",
                              "returns" : {
                                 "links" : [
                                    {
                                       "href" : "{pool_name}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "pool_name" : {
                                          "type" : "string"
                                       },
                                       "pool" : {
                                          "type" : "integer"
                                       },
                                       "size" : {
                                          "type" : "integer"
                                       }
                                    }
                                 },
                                 "type" : "array"
                              },
                              "proxyto" : "node",
                              "protected" : 1
                           }
                        },
                        "leaf" : 0,
                        "text" : "pools",
                        "path" : "/nodes/{node}/ceph/pools",
                        "children" : [
                           {
                              "info" : {
                                 "DELETE" : {
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "name" : "destroypool",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "name" : {
                                             "type" : "string",
                                             "description" : "The name of the pool. It must be unique."
                                          }
                                       }
                                    },
                                    "method" : "DELETE",
                                    "description" : "Destroy pool"
                                 }
                              },
                              "path" : "/nodes/{node}/ceph/pools/{name}",
                              "text" : "{name}",
                              "leaf" : 1
                           }
                        ]
                     },
                     {
                        "text" : "crush",
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/crush",
                        "info" : {
                           "GET" : {
                              "name" : "crush",
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "protected" : 1,
                              "method" : "GET",
                              "description" : "Get OSD crush map"
                           }
                        }
                     },
                     {
                        "info" : {
                           "GET" : {
                              "parameters" : {
                                 "properties" : {
                                    "limit" : {
                                       "optional" : 1,
                                       "minimum" : 0,
                                       "type" : "integer"
                                    },
                                    "start" : {
                                       "optional" : 1,
                                       "minimum" : 0,
                                       "type" : "integer"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "method" : "GET",
                              "description" : "Read ceph log",
                              "returns" : {
                                 "type" : "array",
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "n" : {
                                          "description" : "Line number",
                                          "type" : "integer"
                                       },
                                       "t" : {
                                          "type" : "string",
                                          "description" : "Line text"
                                       }
                                    }
                                 }
                              },
                              "name" : "log",
                              "proxyto" : "node",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Syslog"
                                    ]
                                 ]
                              }
                           }
                        },
                        "path" : "/nodes/{node}/ceph/log",
                        "leaf" : 1,
                        "text" : "log"
                     }
                  ],
                  "leaf" : 0,
                  "text" : "ceph",
                  "path" : "/nodes/{node}/ceph",
                  "info" : {
                     "GET" : {
                        "permissions" : {
                           "user" : "all"
                        },
                        "name" : "index",
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "type" : "array",
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{name}"
                              }
                           ]
                        },
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "method" : "GET",
                        "description" : "Directory index."
                     }
                  }
               },
               {
                  "leaf" : 1,
                  "text" : "vzdump",
                  "path" : "/nodes/{node}/vzdump",
                  "info" : {
                     "POST" : {
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "size" : {
                                 "optional" : 1,
                                 "minimum" : 500,
                                 "type" : "integer",
                                 "description" : "LVM snapshot size in MB."
                              },
                              "maxfiles" : {
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "description" : "Maximal number of backup files per VM."
                              },
                              "storage" : {
                                 "optional" : 1,
                                 "format" : "pve-storage-id",
                                 "type" : "string",
                                 "description" : "Store resulting file to this storage."
                              },
                              "quiet" : {
                                 "default" : 0,
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Be quiet."
                              },
                              "dumpdir" : {
                                 "description" : "Store resulting files to specified directory.",
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "mailnotification" : {
                                 "description" : "Specify when to send an email",
                                 "type" : "string",
                                 "enum" : [
                                    "always",
                                    "failure"
                                 ],
                                 "default" : "always",
                                 "optional" : 1
                              },
                              "compress" : {
                                 "default" : "lzo",
                                 "optional" : 1,
                                 "enum" : [
                                    "0",
                                    "1",
                                    "gzip",
                                    "lzo"
                                 ],
                                 "description" : "Compress dump file.",
                                 "type" : "string"
                              },
                              "vmid" : {
                                 "format" : "pve-vmid-list",
                                 "optional" : 1,
                                 "description" : "The ID of the VM you want to backup.",
                                 "type" : "string"
                              },
                              "pigz" : {
                                 "type" : "integer",
                                 "description" : "Uses pigz instead of gzip when N>0. N=1 uses half of cores, N>1 uses N as thread count.",
                                 "default" : 0,
                                 "optional" : 1
                              },
                              "all" : {
                                 "type" : "boolean",
                                 "description" : "Backup all known VMs on this host.",
                                 "default" : 0,
                                 "optional" : 1
                              },
                              "script" : {
                                 "optional" : 1,
                                 "description" : "Use specified hook script.",
                                 "type" : "string"
                              },
                              "exclude" : {
                                 "description" : "exclude specified VMs (assumes --all)",
                                 "type" : "string",
                                 "optional" : 1,
                                 "format" : "pve-vmid-list"
                              },
                              "lockwait" : {
                                 "optional" : 1,
                                 "minimum" : 0,
                                 "description" : "Maximal time to wait for the global lock (minutes).",
                                 "type" : "integer"
                              },
                              "stopwait" : {
                                 "type" : "integer",
                                 "description" : "Maximal time to wait until a VM is stopped (minutes).",
                                 "optional" : 1,
                                 "minimum" : 0
                              },
                              "stdexcludes" : {
                                 "description" : "Exclude temorary files and logs.",
                                 "type" : "boolean",
                                 "default" : 1,
                                 "optional" : 1
                              },
                              "stop" : {
                                 "description" : "Stop runnig backup jobs on this host.",
                                 "type" : "boolean",
                                 "optional" : 1,
                                 "default" : 0
                              },
                              "remove" : {
                                 "type" : "boolean",
                                 "description" : "Remove old backup files if there are more than 'maxfiles' backup files.",
                                 "optional" : 1,
                                 "default" : 1
                              },
                              "tmpdir" : {
                                 "type" : "string",
                                 "description" : "Store temporary files to specified directory.",
                                 "optional" : 1
                              },
                              "node" : {
                                 "type" : "string",
                                 "description" : "Only run if executed on this node.",
                                 "optional" : 1,
                                 "format" : "pve-node"
                              },
                              "stdout" : {
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Write tar to stdout, not to a file."
                              },
                              "mailto" : {
                                 "description" : "",
                                 "type" : "string",
                                 "format" : "string-list",
                                 "optional" : 1
                              },
                              "exclude-path" : {
                                 "type" : "string",
                                 "description" : "exclude certain files/directories (shell globs).",
                                 "optional" : 1,
                                 "format" : "string-alist"
                              },
                              "ionice" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "maximum" : 8,
                                 "type" : "integer",
                                 "description" : "Set CFQ ionice priority."
                              },
                              "mode" : {
                                 "description" : "Backup mode.",
                                 "type" : "string",
                                 "default" : "stop",
                                 "optional" : 1,
                                 "enum" : [
                                    "snapshot",
                                    "suspend",
                                    "stop"
                                 ]
                              },
                              "bwlimit" : {
                                 "type" : "integer",
                                 "description" : "Limit I/O bandwidth (KBytes per second).",
                                 "minimum" : 0,
                                 "optional" : 1
                              }
                           }
                        },
                        "description" : "Create backup.",
                        "method" : "POST",
                        "returns" : {
                           "type" : "string"
                        },
                        "name" : "vzdump",
                        "proxyto" : "node",
                        "permissions" : {
                           "user" : "all",
                           "description" : "The user needs 'VM.Backup' permissions on any VM, and 'Datastore.AllocateSpace' on the backup storage."
                        },
                        "protected" : 1
                     }
                  }
               },
               {
                  "path" : "/nodes/{node}/services",
                  "text" : "services",
                  "leaf" : 0,
                  "info" : {
                     "GET" : {
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "type" : "array",
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{service}"
                              }
                           ]
                        },
                        "proxyto" : "node",
                        "name" : "index",
                        "method" : "GET",
                        "description" : "Service list.",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "format" : "pve-node",
                                 "type" : "string",
                                 "description" : "The cluster node name."
                              }
                           }
                        }
                     }
                  },
                  "children" : [
                     {
                        "children" : [
                           {
                              "path" : "/nodes/{node}/services/{service}/state",
                              "leaf" : 1,
                              "text" : "state",
                              "info" : {
                                 "GET" : {
                                    "returns" : {
                                       "type" : "object",
                                       "properties" : {}
                                    },
                                    "proxyto" : "node",
                                    "name" : "service_state",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Audit"
                                          ]
                                       ]
                                    },
                                    "description" : "Read service properties",
                                    "method" : "GET",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "service" : {
                                             "type" : "string",
                                             "description" : "Service ID",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned"
                                             ]
                                          }
                                       }
                                    }
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "service" : {
                                             "description" : "Service ID",
                                             "type" : "string",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned"
                                             ]
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          }
                                       }
                                    },
                                    "description" : "Start service.",
                                    "method" : "POST",
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "name" : "service_start",
                                    "proxyto" : "node",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "text" : "start",
                              "path" : "/nodes/{node}/services/{service}/start"
                           },
                           {
                              "path" : "/nodes/{node}/services/{service}/stop",
                              "text" : "stop",
                              "leaf" : 1,
                              "info" : {
                                 "POST" : {
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "name" : "service_stop",
                                    "proxyto" : "node",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "description" : "Stop service.",
                                    "method" : "POST",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "service" : {
                                             "description" : "Service ID",
                                             "type" : "string",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned"
                                             ]
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          }
                                       }
                                    }
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "name" : "service_restart",
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "proxyto" : "node",
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "description" : "Restart service.",
                                    "method" : "POST",
                                    "parameters" : {
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "service" : {
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned"
                                             ],
                                             "type" : "string",
                                             "description" : "Service ID"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 }
                              },
                              "path" : "/nodes/{node}/services/{service}/restart",
                              "leaf" : 1,
                              "text" : "restart"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          },
                                          "service" : {
                                             "type" : "string",
                                             "description" : "Service ID",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned"
                                             ]
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "name" : "service_reload",
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "description" : "Reload service.",
                                    "method" : "POST"
                                 }
                              },
                              "path" : "/nodes/{node}/services/{service}/reload",
                              "text" : "reload",
                              "leaf" : 1
                           }
                        ],
                        "info" : {
                           "GET" : {
                              "description" : "Directory index",
                              "method" : "GET",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "service" : {
                                       "enum" : [
                                          "pveproxy",
                                          "pvedaemon",
                                          "spiceproxy",
                                          "pvestatd",
                                          "pve-cluster",
                                          "corosync",
                                          "pve-firewall",
                                          "pvefw-logger",
                                          "pve-ha-crm",
                                          "pve-ha-lrm",
                                          "sshd",
                                          "syslog",
                                          "cron",
                                          "postfix",
                                          "ksmtuned"
                                       ],
                                       "type" : "string",
                                       "description" : "Service ID"
                                    },
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    }
                                 }
                              },
                              "name" : "srvcmdidx",
                              "returns" : {
                                 "type" : "array",
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "subdir" : {
                                          "type" : "string"
                                       }
                                    }
                                 },
                                 "links" : [
                                    {
                                       "href" : "{subdir}",
                                       "rel" : "child"
                                    }
                                 ]
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              }
                           }
                        },
                        "text" : "{service}",
                        "leaf" : 0,
                        "path" : "/nodes/{node}/services/{service}"
                     }
                  ]
               },
               {
                  "path" : "/nodes/{node}/subscription",
                  "leaf" : 1,
                  "text" : "subscription",
                  "info" : {
                     "GET" : {
                        "permissions" : {
                           "user" : "all"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "format" : "pve-node",
                                 "description" : "The cluster node name.",
                                 "type" : "string"
                              }
                           }
                        },
                        "returns" : {
                           "type" : "object"
                        },
                        "name" : "get",
                        "proxyto" : "node",
                        "description" : "Read subscription info.",
                        "method" : "GET"
                     },
                     "PUT" : {
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              },
                              "key" : {
                                 "description" : "Proxmox VE subscription key",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "name" : "set",
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        },
                        "protected" : 1,
                        "description" : "Set subscription key.",
                        "method" : "PUT"
                     },
                     "POST" : {
                        "protected" : 1,
                        "proxyto" : "node",
                        "name" : "update",
                        "returns" : {
                           "type" : "null"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "force" : {
                                 "default" : 0,
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Always connect to server, even if we have up to date info inside local cache."
                              },
                              "node" : {
                                 "format" : "pve-node",
                                 "description" : "The cluster node name.",
                                 "type" : "string"
                              }
                           }
                        },
                        "method" : "POST",
                        "description" : "Update subscription info."
                     }
                  }
               },
               {
                  "info" : {
                     "GET" : {
                        "method" : "GET",
                        "description" : "List available networks",
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {
                           "items" : {
                              "type" : "object",
                              "properties" : {}
                           },
                           "type" : "array",
                           "links" : [
                              {
                                 "href" : "{iface}",
                                 "rel" : "child"
                              }
                           ]
                        },
                        "name" : "index",
                        "proxyto" : "node",
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              },
                              "type" : {
                                 "enum" : [
                                    "bridge",
                                    "bond",
                                    "eth",
                                    "alias",
                                    "vlan",
                                    "OVSBridge",
                                    "OVSBond",
                                    "OVSPort",
                                    "OVSIntPort",
                                    "any_bridge"
                                 ],
                                 "optional" : 1,
                                 "description" : "Only list specific interface types.",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        }
                     },
                     "POST" : {
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "ovs_ports" : {
                                 "type" : "string",
                                 "description" : "Specify the iterfaces you want to add to your bridge.",
                                 "optional" : 1,
                                 "format" : "pve-iface-list"
                              },
                              "slaves" : {
                                 "format" : "pve-iface-list",
                                 "optional" : 1,
                                 "description" : "Specify the interfaces used by the bonding device.",
                                 "type" : "string"
                              },
                              "gateway" : {
                                 "optional" : 1,
                                 "format" : "ipv4",
                                 "type" : "string",
                                 "description" : "Default gateway address."
                              },
                              "ovs_tag" : {
                                 "minimum" : 1,
                                 "maximum" : 4094,
                                 "optional" : 1,
                                 "description" : "Specify a VLan tag (used by OVSPort, OVSIntPort, OVSBond)",
                                 "type" : "integer"
                              },
                              "comments" : {
                                 "description" : "Comments",
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "iface" : {
                                 "minLength" : 2,
                                 "format" : "pve-iface",
                                 "type" : "string",
                                 "maxLength" : 20,
                                 "description" : "Network interface name."
                              },
                              "bond_xmit_hash_policy" : {
                                 "type" : "string",
                                 "description" : "Selects the transmit hash policy to use for slave selection in balance-xor and 802.3ad modes.",
                                 "enum" : [
                                    "layer2",
                                    "layer2+3",
                                    "layer3+4"
                                 ],
                                 "optional" : 1
                              },
                              "ovs_options" : {
                                 "optional" : 1,
                                 "description" : "OVS interface options.",
                                 "maxLength" : 1024,
                                 "type" : "string"
                              },
                              "netmask" : {
                                 "requires" : "address",
                                 "description" : "Network mask.",
                                 "type" : "string",
                                 "format" : "ipv4mask",
                                 "optional" : 1
                              },
                              "bridge_vlan_aware" : {
                                 "optional" : 1,
                                 "description" : "Enable bridge vlan support.",
                                 "type" : "boolean"
                              },
                              "bridge_ports" : {
                                 "type" : "string",
                                 "description" : "Specify the iterfaces you want to add to your bridge.",
                                 "optional" : 1,
                                 "format" : "pve-iface-list"
                              },
                              "autostart" : {
                                 "optional" : 1,
                                 "description" : "Automatically start interface on boot.",
                                 "type" : "boolean"
                              },
                              "ovs_bonds" : {
                                 "description" : "Specify the interfaces used by the bonding device.",
                                 "type" : "string",
                                 "optional" : 1,
                                 "format" : "pve-iface-list"
                              },
                              "address" : {
                                 "requires" : "netmask",
                                 "description" : "IP address.",
                                 "type" : "string",
                                 "format" : "ipv4",
                                 "optional" : 1
                              },
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              },
                              "type" : {
                                 "type" : "string",
                                 "description" : "Network interface type",
                                 "enum" : [
                                    "bridge",
                                    "bond",
                                    "eth",
                                    "alias",
                                    "vlan",
                                    "OVSBridge",
                                    "OVSBond",
                                    "OVSPort",
                                    "OVSIntPort",
                                    "unknown"
                                 ]
                              },
                              "bond_mode" : {
                                 "optional" : 1,
                                 "enum" : [
                                    "balance-rr",
                                    "active-backup",
                                    "balance-xor",
                                    "broadcast",
                                    "802.3ad",
                                    "balance-tlb",
                                    "balance-alb",
                                    "balance-slb",
                                    "lacp-balance-slb",
                                    "lacp-balance-tcp"
                                 ],
                                 "description" : "Bonding mode.",
                                 "type" : "string"
                              },
                              "ovs_bridge" : {
                                 "type" : "string",
                                 "description" : "The OVS bridge associated with a OVS port. This is required when you create an OVS port.",
                                 "format" : "pve-iface",
                                 "optional" : 1
                              }
                           }
                        },
                        "method" : "POST",
                        "description" : "Create network device configuration",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        },
                        "name" : "create_network",
                        "proxyto" : "node"
                     },
                     "DELETE" : {
                        "method" : "DELETE",
                        "description" : "Revert network configuration changes.",
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        },
                        "name" : "revert_network_changes",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              }
                           }
                        }
                     }
                  },
                  "path" : "/nodes/{node}/network",
                  "text" : "network",
                  "leaf" : 0,
                  "children" : [
                     {
                        "info" : {
                           "DELETE" : {
                              "description" : "Delete network device configuration",
                              "method" : "DELETE",
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "name" : "delete_network",
                              "returns" : {
                                 "type" : "null"
                              },
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    },
                                    "iface" : {
                                       "minLength" : 2,
                                       "format" : "pve-iface",
                                       "description" : "Network interface name.",
                                       "maxLength" : 20,
                                       "type" : "string"
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           },
                           "GET" : {
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "parameters" : {
                                 "properties" : {
                                    "iface" : {
                                       "type" : "string",
                                       "maxLength" : 20,
                                       "description" : "Network interface name.",
                                       "format" : "pve-iface",
                                       "minLength" : 2
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "properties" : {
                                    "type" : {
                                       "type" : "string"
                                    },
                                    "method" : {
                                       "type" : "string"
                                    }
                                 },
                                 "type" : "object"
                              },
                              "name" : "network_config",
                              "description" : "Read network device configuration",
                              "method" : "GET"
                           },
                           "PUT" : {
                              "method" : "PUT",
                              "description" : "Update network device configuration",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "returns" : {
                                 "type" : "null"
                              },
                              "proxyto" : "node",
                              "name" : "update_network",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "gateway" : {
                                       "format" : "ipv4",
                                       "optional" : 1,
                                       "type" : "string",
                                       "description" : "Default gateway address."
                                    },
                                    "delete" : {
                                       "description" : "A list of settings you want to delete.",
                                       "type" : "string",
                                       "format" : "pve-configid-list",
                                       "optional" : 1
                                    },
                                    "comments" : {
                                       "description" : "Comments",
                                       "type" : "string",
                                       "optional" : 1
                                    },
                                    "ovs_tag" : {
                                       "type" : "integer",
                                       "description" : "Specify a VLan tag (used by OVSPort, OVSIntPort, OVSBond)",
                                       "maximum" : 4094,
                                       "optional" : 1,
                                       "minimum" : 1
                                    },
                                    "iface" : {
                                       "description" : "Network interface name.",
                                       "maxLength" : 20,
                                       "type" : "string",
                                       "minLength" : 2,
                                       "format" : "pve-iface"
                                    },
                                    "ovs_ports" : {
                                       "optional" : 1,
                                       "format" : "pve-iface-list",
                                       "type" : "string",
                                       "description" : "Specify the iterfaces you want to add to your bridge."
                                    },
                                    "slaves" : {
                                       "optional" : 1,
                                       "format" : "pve-iface-list",
                                       "type" : "string",
                                       "description" : "Specify the interfaces used by the bonding device."
                                    },
                                    "ovs_options" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "description" : "OVS interface options.",
                                       "maxLength" : 1024
                                    },
                                    "netmask" : {
                                       "optional" : 1,
                                       "format" : "ipv4mask",
                                       "requires" : "address",
                                       "description" : "Network mask.",
                                       "type" : "string"
                                    },
                                    "bridge_ports" : {
                                       "optional" : 1,
                                       "format" : "pve-iface-list",
                                       "type" : "string",
                                       "description" : "Specify the iterfaces you want to add to your bridge."
                                    },
                                    "bridge_vlan_aware" : {
                                       "optional" : 1,
                                       "type" : "boolean",
                                       "description" : "Enable bridge vlan support."
                                    },
                                    "bond_xmit_hash_policy" : {
                                       "description" : "Selects the transmit hash policy to use for slave selection in balance-xor and 802.3ad modes.",
                                       "type" : "string",
                                       "optional" : 1,
                                       "enum" : [
                                          "layer2",
                                          "layer2+3",
                                          "layer3+4"
                                       ]
                                    },
                                    "ovs_bonds" : {
                                       "description" : "Specify the interfaces used by the bonding device.",
                                       "type" : "string",
                                       "format" : "pve-iface-list",
                                       "optional" : 1
                                    },
                                    "address" : {
                                       "type" : "string",
                                       "requires" : "netmask",
                                       "description" : "IP address.",
                                       "optional" : 1,
                                       "format" : "ipv4"
                                    },
                                    "autostart" : {
                                       "optional" : 1,
                                       "description" : "Automatically start interface on boot.",
                                       "type" : "boolean"
                                    },
                                    "bond_mode" : {
                                       "type" : "string",
                                       "description" : "Bonding mode.",
                                       "optional" : 1,
                                       "enum" : [
                                          "balance-rr",
                                          "active-backup",
                                          "balance-xor",
                                          "broadcast",
                                          "802.3ad",
                                          "balance-tlb",
                                          "balance-alb",
                                          "balance-slb",
                                          "lacp-balance-slb",
                                          "lacp-balance-tcp"
                                       ]
                                    },
                                    "ovs_bridge" : {
                                       "format" : "pve-iface",
                                       "optional" : 1,
                                       "description" : "The OVS bridge associated with a OVS port. This is required when you create an OVS port.",
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "type" : "string",
                                       "description" : "Network interface type",
                                       "enum" : [
                                          "bridge",
                                          "bond",
                                          "eth",
                                          "alias",
                                          "vlan",
                                          "OVSBridge",
                                          "OVSBond",
                                          "OVSPort",
                                          "OVSIntPort",
                                          "unknown"
                                       ]
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 }
                              }
                           }
                        },
                        "path" : "/nodes/{node}/network/{iface}",
                        "text" : "{iface}",
                        "leaf" : 1
                     }
                  ]
               },
               {
                  "info" : {
                     "GET" : {
                        "name" : "node_tasks",
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "array",
                           "items" : {
                              "properties" : {
                                 "upid" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{upid}",
                                 "rel" : "child"
                              }
                           ]
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "errors" : {
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "vmid" : {
                                 "type" : "integer",
                                 "description" : "Only list tasks for this VM.",
                                 "format" : "pve-vmid",
                                 "optional" : 1,
                                 "minimum" : 1
                              },
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              },
                              "start" : {
                                 "type" : "integer",
                                 "minimum" : 0,
                                 "optional" : 1
                              },
                              "limit" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer"
                              },
                              "userfilter" : {
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "description" : "List task associated with the current user, or all task the user has 'Sys.Audit' permissions on /nodes/<node> (the <node> the task runs on).",
                           "user" : "all"
                        },
                        "method" : "GET",
                        "description" : "Read task list for one node (finished tasks)."
                     }
                  },
                  "text" : "tasks",
                  "leaf" : 0,
                  "path" : "/nodes/{node}/tasks",
                  "children" : [
                     {
                        "children" : [
                           {
                              "path" : "/nodes/{node}/tasks/{upid}/log",
                              "text" : "log",
                              "leaf" : 1,
                              "info" : {
                                 "GET" : {
                                    "parameters" : {
                                       "properties" : {
                                          "limit" : {
                                             "type" : "integer",
                                             "optional" : 1,
                                             "minimum" : 0
                                          },
                                          "upid" : {
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "start" : {
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "description" : "Read task log.",
                                    "method" : "GET",
                                    "protected" : 1,
                                    "permissions" : {
                                       "user" : "all",
                                       "description" : "The user needs 'Sys.Audit' permissions on '/nodes/<node>' if the task does not belong to him."
                                    },
                                    "proxyto" : "node",
                                    "name" : "read_task_log",
                                    "returns" : {
                                       "type" : "array",
                                       "items" : {
                                          "properties" : {
                                             "n" : {
                                                "type" : "integer",
                                                "description" : "Line number"
                                             },
                                             "t" : {
                                                "description" : "Line text",
                                                "type" : "string"
                                             }
                                          },
                                          "type" : "object"
                                       }
                                    }
                                 }
                              }
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "parameters" : {
                                       "properties" : {
                                          "upid" : {
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "object",
                                       "properties" : {
                                          "pid" : {
                                             "type" : "integer"
                                          },
                                          "status" : {
                                             "type" : "string",
                                             "enum" : [
                                                "running",
                                                "stopped"
                                             ]
                                          }
                                       }
                                    },
                                    "name" : "read_task_status",
                                    "permissions" : {
                                       "user" : "all",
                                       "description" : "The user needs 'Sys.Audit' permissions on '/nodes/<node>' if the task does not belong to him."
                                    },
                                    "protected" : 1,
                                    "description" : "Read task status.",
                                    "method" : "GET"
                                 }
                              },
                              "text" : "status",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/tasks/{upid}/status"
                           }
                        ],
                        "path" : "/nodes/{node}/tasks/{upid}",
                        "text" : "{upid}",
                        "leaf" : 0,
                        "info" : {
                           "GET" : {
                              "permissions" : {
                                 "user" : "all"
                              },
                              "name" : "upid_index",
                              "returns" : {
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {}
                                 },
                                 "type" : "array",
                                 "links" : [
                                    {
                                       "href" : "{name}",
                                       "rel" : "child"
                                    }
                                 ]
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    },
                                    "upid" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "method" : "GET",
                              "description" : ""
                           },
                           "DELETE" : {
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    },
                                    "upid" : {
                                       "type" : "string"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "method" : "DELETE",
                              "description" : "Stop a task.",
                              "name" : "stop_task",
                              "returns" : {
                                 "type" : "null"
                              },
                              "proxyto" : "node",
                              "permissions" : {
                                 "description" : "The user needs 'Sys.Modify' permissions on '/nodes/<node>' if the task does not belong to him.",
                                 "user" : "all"
                              },
                              "protected" : 1
                           }
                        }
                     }
                  ]
               },
               {
                  "leaf" : 0,
                  "text" : "scan",
                  "path" : "/nodes/{node}/scan",
                  "info" : {
                     "GET" : {
                        "description" : "Index of available scan methods",
                        "method" : "GET",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              }
                           }
                        },
                        "name" : "index",
                        "returns" : {
                           "links" : [
                              {
                                 "href" : "{method}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array",
                           "items" : {
                              "properties" : {
                                 "method" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        }
                     }
                  },
                  "children" : [
                     {
                        "path" : "/nodes/{node}/scan/zfs",
                        "leaf" : 1,
                        "text" : "zfs",
                        "info" : {
                           "GET" : {
                              "description" : "Scan zfs pool list on local node.",
                              "method" : "GET",
                              "returns" : {
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "pool" : {
                                          "type" : "string"
                                       }
                                    }
                                 },
                                 "type" : "array"
                              },
                              "proxyto" : "node",
                              "name" : "zfsscan",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    }
                                 }
                              }
                           }
                        }
                     },
                     {
                        "path" : "/nodes/{node}/scan/nfs",
                        "text" : "nfs",
                        "leaf" : 1,
                        "info" : {
                           "GET" : {
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    },
                                    "server" : {
                                       "type" : "string",
                                       "format" : "pve-storage-server"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "array",
                                 "items" : {
                                    "properties" : {
                                       "options" : {
                                          "type" : "string"
                                       },
                                       "path" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 }
                              },
                              "name" : "nfsscan",
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "description" : "Scan remote NFS server.",
                              "method" : "GET"
                           }
                        }
                     },
                     {
                        "info" : {
                           "GET" : {
                              "method" : "GET",
                              "description" : "Scan remote GlusterFS server.",
                              "returns" : {
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "volname" : {
                                          "type" : "string"
                                       }
                                    }
                                 },
                                 "type" : "array"
                              },
                              "proxyto" : "node",
                              "name" : "glusterfsscan",
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    },
                                    "server" : {
                                       "type" : "string",
                                       "format" : "pve-storage-server"
                                    }
                                 }
                              }
                           }
                        },
                        "path" : "/nodes/{node}/scan/glusterfs",
                        "text" : "glusterfs",
                        "leaf" : 1
                     },
                     {
                        "path" : "/nodes/{node}/scan/iscsi",
                        "text" : "iscsi",
                        "leaf" : 1,
                        "info" : {
                           "GET" : {
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "name" : "iscsiscan",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "target" : {
                                          "type" : "string"
                                       },
                                       "portal" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              },
                              "proxyto" : "node",
                              "method" : "GET",
                              "description" : "Scan remote iSCSI server.",
                              "parameters" : {
                                 "properties" : {
                                    "portal" : {
                                       "type" : "string",
                                       "format" : "pve-storage-portal-dns"
                                    },
                                    "node" : {
                                       "format" : "pve-node",
                                       "type" : "string",
                                       "description" : "The cluster node name."
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           }
                        }
                     },
                     {
                        "info" : {
                           "GET" : {
                              "proxyto" : "node",
                              "name" : "lvmscan",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "vg" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              },
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "method" : "GET",
                              "description" : "List local LVM volume groups.",
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           }
                        },
                        "text" : "lvm",
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/lvm"
                     },
                     {
                        "text" : "usb",
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/usb",
                        "info" : {
                           "GET" : {
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "busnum" : {
                                          "type" : "integer"
                                       },
                                       "vendid" : {
                                          "type" : "string"
                                       },
                                       "speed" : {
                                          "type" : "string"
                                       },
                                       "product" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "prodid" : {
                                          "type" : "string"
                                       },
                                       "port" : {
                                          "type" : "integer"
                                       },
                                       "level" : {
                                          "type" : "integer"
                                       },
                                       "usbpath" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "manufacturer" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "class" : {
                                          "type" : "integer"
                                       },
                                       "devnum" : {
                                          "type" : "integer"
                                       },
                                       "serial" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              },
                              "name" : "usbscan",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "method" : "GET",
                              "description" : "List local USB devices.",
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "description" : "The cluster node name.",
                                       "type" : "string"
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           }
                        }
                     }
                  ]
               },
               {
                  "info" : {
                     "GET" : {
                        "parameters" : {
                           "properties" : {
                              "target" : {
                                 "optional" : 1,
                                 "format" : "pve-node",
                                 "description" : "If target is different to 'node', we only lists shared storages which content is accessible on this 'node' and the specified 'target' node.",
                                 "type" : "string"
                              },
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              },
                              "content" : {
                                 "format" : "pve-storage-content-list",
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Only list stores which support this content type."
                              },
                              "enabled" : {
                                 "optional" : 1,
                                 "default" : 0,
                                 "description" : "Only list stores which are enabled (not disabled in config).",
                                 "type" : "boolean"
                              },
                              "storage" : {
                                 "optional" : 1,
                                 "format" : "pve-storage-id",
                                 "description" : "Only list status for  specified storage",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "protected" : 1,
                        "permissions" : {
                           "user" : "all",
                           "description" : "Only list entries where you have 'Datastore.Audit' or 'Datastore.AllocateSpace' permissions on '/storage/<storage>'"
                        },
                        "proxyto" : "node",
                        "name" : "index",
                        "returns" : {
                           "links" : [
                              {
                                 "rel" : "child",
                                 "href" : "{storage}"
                              }
                           ],
                           "type" : "array",
                           "items" : {
                              "type" : "object",
                              "properties" : {
                                 "storage" : {
                                    "type" : "string"
                                 }
                              }
                           }
                        },
                        "description" : "Get status for all datastores.",
                        "method" : "GET"
                     }
                  },
                  "path" : "/nodes/{node}/storage",
                  "leaf" : 0,
                  "text" : "storage",
                  "children" : [
                     {
                        "info" : {
                           "GET" : {
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "storage" : {
                                       "format" : "pve-storage-id",
                                       "description" : "The storage identifier.",
                                       "type" : "string"
                                    },
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    }
                                 }
                              },
                              "returns" : {
                                 "links" : [
                                    {
                                       "href" : "{subdir}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array",
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "subdir" : {
                                          "type" : "string"
                                       }
                                    }
                                 }
                              },
                              "name" : "diridx",
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage/{storage}",
                                    [
                                       "Datastore.Audit",
                                       "Datastore.AllocateSpace"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "description" : "",
                              "method" : "GET"
                           }
                        },
                        "text" : "{storage}",
                        "leaf" : 0,
                        "path" : "/nodes/{node}/storage/{storage}",
                        "children" : [
                           {
                              "info" : {
                                 "GET" : {
                                    "parameters" : {
                                       "properties" : {
                                          "vmid" : {
                                             "description" : "Only list images for this VM",
                                             "type" : "integer",
                                             "format" : "pve-vmid",
                                             "optional" : 1,
                                             "minimum" : 1
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "type" : "string",
                                             "description" : "The storage identifier.",
                                             "format" : "pve-storage-id"
                                          },
                                          "content" : {
                                             "description" : "Only list content of this type.",
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-storage-content"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "type" : "object",
                                          "properties" : {
                                             "volid" : {
                                                "type" : "string"
                                             }
                                          }
                                       },
                                       "type" : "array",
                                       "links" : [
                                          {
                                             "rel" : "child",
                                             "href" : "{volid}"
                                          }
                                       ]
                                    },
                                    "name" : "index",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.Audit",
                                             "Datastore.AllocateSpace"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "method" : "GET",
                                    "description" : "List storage content."
                                 },
                                 "POST" : {
                                    "description" : "Allocate disk images.",
                                    "method" : "POST",
                                    "proxyto" : "node",
                                    "name" : "create",
                                    "returns" : {
                                       "description" : "Volume identifier",
                                       "type" : "string"
                                    },
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.AllocateSpace"
                                          ]
                                       ]
                                    },
                                    "parameters" : {
                                       "properties" : {
                                          "format" : {
                                             "enum" : [
                                                "raw",
                                                "qcow2",
                                                "subvol"
                                             ],
                                             "optional" : 1,
                                             "type" : "string",
                                             "requires" : "size"
                                          },
                                          "storage" : {
                                             "type" : "string",
                                             "description" : "The storage identifier.",
                                             "format" : "pve-storage-id"
                                          },
                                          "size" : {
                                             "type" : "string",
                                             "pattern" : "\\d+[MG]?",
                                             "description" : "Size in kilobyte (1024 bytes). Optional suffixes 'M' (megabyte, 1024K) and 'G' (gigabyte, 1024M)"
                                          },
                                          "filename" : {
                                             "type" : "string",
                                             "description" : "The name of the file to create."
                                          },
                                          "vmid" : {
                                             "type" : "integer",
                                             "description" : "Specify owner VM",
                                             "minimum" : 1,
                                             "format" : "pve-vmid"
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 }
                              },
                              "text" : "content",
                              "leaf" : 0,
                              "path" : "/nodes/{node}/storage/{storage}/content",
                              "children" : [
                                 {
                                    "info" : {
                                       "GET" : {
                                          "parameters" : {
                                             "properties" : {
                                                "storage" : {
                                                   "type" : "string",
                                                   "description" : "The storage identifier.",
                                                   "optional" : 1,
                                                   "format" : "pve-storage-id"
                                                },
                                                "volume" : {
                                                   "description" : "Volume identifier",
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "type" : "string",
                                                   "format" : "pve-node"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "method" : "GET",
                                          "description" : "Get volume attributes",
                                          "name" : "info",
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "object"
                                          },
                                          "protected" : 1,
                                          "permissions" : {
                                             "user" : "all",
                                             "description" : "You need read access for the volume."
                                          }
                                       },
                                       "DELETE" : {
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "type" : "string",
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node"
                                                },
                                                "volume" : {
                                                   "description" : "Volume identifier",
                                                   "type" : "string"
                                                },
                                                "storage" : {
                                                   "description" : "The storage identifier.",
                                                   "type" : "string",
                                                   "optional" : 1,
                                                   "format" : "pve-storage-id"
                                                }
                                             }
                                          },
                                          "returns" : {
                                             "type" : "null"
                                          },
                                          "name" : "delete",
                                          "proxyto" : "node",
                                          "protected" : 1,
                                          "permissions" : {
                                             "description" : "You need 'Datastore.Allocate' privilege on the storage (or 'Datastore.AllocateSpace' for backup volumes if you have VM.Backup privilege on the VM).",
                                             "user" : "all"
                                          },
                                          "description" : "Delete volume",
                                          "method" : "DELETE"
                                       },
                                       "POST" : {
                                          "description" : "Copy a volume. This is experimental code - do not use.",
                                          "method" : "POST",
                                          "parameters" : {
                                             "properties" : {
                                                "target" : {
                                                   "type" : "string",
                                                   "description" : "Target volume identifier"
                                                },
                                                "target_node" : {
                                                   "type" : "string",
                                                   "description" : "Target node. Default is local node.",
                                                   "format" : "pve-node",
                                                   "optional" : 1
                                                },
                                                "node" : {
                                                   "format" : "pve-node",
                                                   "type" : "string",
                                                   "description" : "The cluster node name."
                                                },
                                                "volume" : {
                                                   "type" : "string",
                                                   "description" : "Source volume identifier"
                                                },
                                                "storage" : {
                                                   "description" : "The storage identifier.",
                                                   "type" : "string",
                                                   "optional" : 1,
                                                   "format" : "pve-storage-id"
                                                }
                                             },
                                             "additionalProperties" : 0
                                          },
                                          "name" : "copy",
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          },
                                          "protected" : 1
                                       }
                                    },
                                    "path" : "/nodes/{node}/storage/{storage}/content/{volume}",
                                    "leaf" : 1,
                                    "text" : "{volume}"
                                 }
                              ]
                           },
                           {
                              "text" : "status",
                              "leaf" : 1,
                              "path" : "/nodes/{node}/storage/{storage}/status",
                              "info" : {
                                 "GET" : {
                                    "protected" : 1,
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.Audit",
                                             "Datastore.AllocateSpace"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "name" : "read_status",
                                    "returns" : {
                                       "type" : "object",
                                       "properties" : {}
                                    },
                                    "proxyto" : "node",
                                    "method" : "GET",
                                    "description" : "Read storage status.",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          },
                                          "storage" : {
                                             "format" : "pve-storage-id",
                                             "description" : "The storage identifier.",
                                             "type" : "string"
                                          }
                                       }
                                    }
                                 }
                              }
                           },
                           {
                              "path" : "/nodes/{node}/storage/{storage}/rrd",
                              "leaf" : 1,
                              "text" : "rrd",
                              "info" : {
                                 "GET" : {
                                    "parameters" : {
                                       "properties" : {
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "timeframe" : {
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string",
                                             "description" : "Specify the time frame you are interested in."
                                          },
                                          "storage" : {
                                             "description" : "The storage identifier.",
                                             "type" : "string",
                                             "format" : "pve-storage-id"
                                          },
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "type" : "string",
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1
                                          },
                                          "ds" : {
                                             "format" : "pve-configid-list",
                                             "description" : "The list of datasources you want to display.",
                                             "type" : "string"
                                          }
                                       },
                                       "additionalProperties" : 0
                                    },
                                    "name" : "rrd",
                                    "returns" : {
                                       "properties" : {
                                          "filename" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    },
                                    "proxyto" : "node",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.Audit",
                                             "Datastore.AllocateSpace"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "description" : "Read storage RRD statistics (returns PNG).",
                                    "method" : "GET"
                                 }
                              }
                           },
                           {
                              "path" : "/nodes/{node}/storage/{storage}/rrddata",
                              "leaf" : 1,
                              "text" : "rrddata",
                              "info" : {
                                 "GET" : {
                                    "proxyto" : "node",
                                    "name" : "rrddata",
                                    "returns" : {
                                       "items" : {
                                          "type" : "object",
                                          "properties" : {}
                                       },
                                       "type" : "array"
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.Audit",
                                             "Datastore.AllocateSpace"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "method" : "GET",
                                    "description" : "Read storage RRD statistics.",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "timeframe" : {
                                             "type" : "string",
                                             "description" : "Specify the time frame you are interested in.",
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ]
                                          },
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          },
                                          "cf" : {
                                             "type" : "string",
                                             "description" : "The RRD consolidation function",
                                             "optional" : 1,
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ]
                                          },
                                          "storage" : {
                                             "description" : "The storage identifier.",
                                             "type" : "string",
                                             "format" : "pve-storage-id"
                                          }
                                       }
                                    }
                                 }
                              }
                           },
                           {
                              "path" : "/nodes/{node}/storage/{storage}/upload",
                              "leaf" : 1,
                              "text" : "upload",
                              "info" : {
                                 "POST" : {
                                    "method" : "POST",
                                    "description" : "Upload templates and ISO images.",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.AllocateTemplate"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "name" : "upload",
                                    "returns" : {
                                       "type" : "string"
                                    },
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "storage" : {
                                             "format" : "pve-storage-id",
                                             "description" : "The storage identifier.",
                                             "type" : "string"
                                          },
                                          "content" : {
                                             "type" : "string",
                                             "description" : "Content type.",
                                             "format" : "pve-storage-content"
                                          },
                                          "tmpfilename" : {
                                             "description" : "The source file name. This parameter is usually set by the REST handler. You can only overwrite it when connecting to the trustet port on localhost.",
                                             "type" : "string",
                                             "optional" : 1
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "description" : "The cluster node name.",
                                             "type" : "string"
                                          },
                                          "filename" : {
                                             "type" : "string",
                                             "description" : "The name of the file to create."
                                          }
                                       }
                                    }
                                 }
                              }
                           }
                        ]
                     }
                  ]
               },
               {
                  "children" : [
                     {
                        "text" : "update",
                        "leaf" : 1,
                        "path" : "/nodes/{node}/apt/update",
                        "info" : {
                           "GET" : {
                              "returns" : {
                                 "type" : "array",
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {}
                                 }
                              },
                              "name" : "list_updates",
                              "proxyto" : "node",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "description" : "List available updates.",
                              "method" : "GET",
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           },
                           "POST" : {
                              "method" : "POST",
                              "description" : "This is used to resynchronize the package index files from their sources (apt-get update).",
                              "returns" : {
                                 "type" : "string"
                              },
                              "proxyto" : "node",
                              "name" : "update_database",
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "parameters" : {
                                 "properties" : {
                                    "quiet" : {
                                       "description" : "Only produces output suitable for logging, omitting progress indicators.",
                                       "type" : "boolean",
                                       "optional" : 1,
                                       "default" : 0
                                    },
                                    "notify" : {
                                       "optional" : 1,
                                       "default" : 0,
                                       "type" : "boolean",
                                       "description" : "Send notification mail about new packages (to email address specified for user 'root@pam')."
                                    },
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           }
                        }
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get package changelogs.",
                              "method" : "GET",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "name" : {
                                       "description" : "Package name.",
                                       "type" : "string"
                                    },
                                    "version" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "description" : "Package version."
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 }
                              },
                              "returns" : {
                                 "type" : "string"
                              },
                              "name" : "changelog",
                              "proxyto" : "node",
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              }
                           }
                        },
                        "leaf" : 1,
                        "text" : "changelog",
                        "path" : "/nodes/{node}/apt/changelog"
                     },
                     {
                        "path" : "/nodes/{node}/apt/versions",
                        "text" : "versions",
                        "leaf" : 1,
                        "info" : {
                           "GET" : {
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "array",
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {}
                                 }
                              },
                              "name" : "versions",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "method" : "GET",
                              "description" : "Get package information for important Proxmox packages."
                           }
                        }
                     }
                  ],
                  "leaf" : 0,
                  "text" : "apt",
                  "path" : "/nodes/{node}/apt",
                  "info" : {
                     "GET" : {
                        "method" : "GET",
                        "description" : "Directory index for apt (Advanced Package Tool).",
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {
                           "links" : [
                              {
                                 "href" : "{id}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array",
                           "items" : {
                              "properties" : {
                                 "id" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           }
                        },
                        "name" : "index",
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "format" : "pve-node",
                                 "description" : "The cluster node name.",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        }
                     }
                  }
               },
               {
                  "text" : "firewall",
                  "leaf" : 0,
                  "path" : "/nodes/{node}/firewall",
                  "info" : {
                     "GET" : {
                        "description" : "Directory index.",
                        "method" : "GET",
                        "permissions" : {
                           "user" : "all"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              }
                           }
                        },
                        "name" : "index",
                        "returns" : {
                           "links" : [
                              {
                                 "href" : "{name}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array",
                           "items" : {
                              "type" : "object",
                              "properties" : {}
                           }
                        }
                     }
                  },
                  "children" : [
                     {
                        "info" : {
                           "GET" : {
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "proxyto" : "node",
                              "name" : "get_rules",
                              "returns" : {
                                 "type" : "array",
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "pos" : {
                                          "type" : "integer"
                                       }
                                    }
                                 },
                                 "links" : [
                                    {
                                       "rel" : "child",
                                       "href" : "{pos}"
                                    }
                                 ]
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "format" : "pve-node",
                                       "type" : "string",
                                       "description" : "The cluster node name."
                                    }
                                 }
                              },
                              "method" : "GET",
                              "description" : "List rules."
                           },
                           "POST" : {
                              "description" : "Create new rule.",
                              "method" : "POST",
                              "name" : "create_rule",
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "parameters" : {
                                 "properties" : {
                                    "dest" : {
                                       "type" : "string",
                                       "optional" : 1,
                                       "format" : "pve-fw-addr-spec"
                                    },
                                    "proto" : {
                                       "format" : "pve-fw-protocol-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "macro" : {
                                       "optional" : 1,
                                       "maxLength" : 128,
                                       "type" : "string"
                                    },
                                    "iface" : {
                                       "type" : "string",
                                       "description" : "Network interface name.",
                                       "maxLength" : 20,
                                       "optional" : 1,
                                       "minLength" : 2,
                                       "format" : "pve-iface"
                                    },
                                    "enable" : {
                                       "type" : "integer",
                                       "minimum" : 0,
                                       "optional" : 1
                                    },
                                    "digest" : {
                                       "type" : "string",
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1
                                    },
                                    "sport" : {
                                       "optional" : 1,
                                       "format" : "pve-fw-port-spec",
                                       "type" : "string"
                                    },
                                    "comment" : {
                                       "type" : "string",
                                       "optional" : 1
                                    },
                                    "action" : {
                                       "minLength" : 2,
                                       "optional" : 0,
                                       "maxLength" : 20,
                                       "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                       "type" : "string",
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+"
                                    },
                                    "dport" : {
                                       "optional" : 1,
                                       "format" : "pve-fw-port-spec",
                                       "type" : "string"
                                    },
                                    "source" : {
                                       "optional" : 1,
                                       "format" : "pve-fw-addr-spec",
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "type" : "string",
                                       "enum" : [
                                          "in",
                                          "out",
                                          "group"
                                       ],
                                       "optional" : 0
                                    },
                                    "pos" : {
                                       "type" : "integer",
                                       "description" : "Update rule at position <pos>.",
                                       "optional" : 1,
                                       "minimum" : 0
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           }
                        },
                        "path" : "/nodes/{node}/firewall/rules",
                        "text" : "rules",
                        "leaf" : 0,
                        "children" : [
                           {
                              "leaf" : 1,
                              "text" : "{pos}",
                              "path" : "/nodes/{node}/firewall/rules/{pos}",
                              "info" : {
                                 "PUT" : {
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "delete" : {
                                             "description" : "A list of settings you want to delete.",
                                             "type" : "string",
                                             "format" : "pve-configid-list",
                                             "optional" : 1
                                          },
                                          "proto" : {
                                             "format" : "pve-fw-protocol-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "dest" : {
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-fw-addr-spec"
                                          },
                                          "iface" : {
                                             "minLength" : 2,
                                             "format" : "pve-iface",
                                             "optional" : 1,
                                             "type" : "string",
                                             "description" : "Network interface name.",
                                             "maxLength" : 20
                                          },
                                          "enable" : {
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer"
                                          },
                                          "sport" : {
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-fw-port-spec"
                                          },
                                          "comment" : {
                                             "type" : "string",
                                             "optional" : 1
                                          },
                                          "action" : {
                                             "optional" : 1,
                                             "minLength" : 2,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string",
                                             "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                             "maxLength" : 20
                                          },
                                          "dport" : {
                                             "optional" : 1,
                                             "format" : "pve-fw-port-spec",
                                             "type" : "string"
                                          },
                                          "pos" : {
                                             "optional" : 1,
                                             "minimum" : 0,
                                             "type" : "integer",
                                             "description" : "Update rule at position <pos>."
                                          },
                                          "source" : {
                                             "type" : "string",
                                             "optional" : 1,
                                             "format" : "pve-fw-addr-spec"
                                          },
                                          "macro" : {
                                             "type" : "string",
                                             "maxLength" : 128,
                                             "optional" : 1
                                          },
                                          "digest" : {
                                             "optional" : 1,
                                             "maxLength" : 40,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "type" : "string"
                                          },
                                          "moveto" : {
                                             "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                             "type" : "integer",
                                             "minimum" : 0,
                                             "optional" : 1
                                          },
                                          "type" : {
                                             "enum" : [
                                                "in",
                                                "out",
                                                "group"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "format" : "pve-node",
                                             "type" : "string",
                                             "description" : "The cluster node name."
                                          }
                                       }
                                    },
                                    "description" : "Modify rule data.",
                                    "method" : "PUT",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "proxyto" : "node",
                                    "name" : "update_rule",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1
                                 },
                                 "GET" : {
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Audit"
                                          ]
                                       ]
                                    },
                                    "returns" : {
                                       "type" : "object",
                                       "properties" : {
                                          "pos" : {
                                             "type" : "integer"
                                          }
                                       }
                                    },
                                    "name" : "get_rule",
                                    "proxyto" : "node",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "type" : "integer",
                                             "optional" : 1,
                                             "minimum" : 0
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "type" : "string",
                                             "format" : "pve-node"
                                          }
                                       }
                                    },
                                    "method" : "GET",
                                    "description" : "Get single rule data."
                                 },
                                 "DELETE" : {
                                    "description" : "Delete rule.",
                                    "method" : "DELETE",
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    },
                                    "name" : "delete_rule",
                                    "parameters" : {
                                       "properties" : {
                                          "node" : {
                                             "type" : "string",
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node"
                                          },
                                          "digest" : {
                                             "optional" : 1,
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "type" : "string"
                                          },
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "type" : "integer",
                                             "optional" : 1,
                                             "minimum" : 0
                                          }
                                       },
                                       "additionalProperties" : 0
                                    }
                                 }
                              }
                           }
                        ]
                     },
                     {
                        "path" : "/nodes/{node}/firewall/options",
                        "text" : "options",
                        "leaf" : 1,
                        "info" : {
                           "PUT" : {
                              "description" : "Set Firewall options.",
                              "method" : "PUT",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "name" : "set_options",
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              },
                              "parameters" : {
                                 "properties" : {
                                    "log_level_in" : {
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "description" : "Log level for incoming traffic.",
                                       "type" : "string"
                                    },
                                    "enable" : {
                                       "optional" : 1,
                                       "type" : "boolean",
                                       "description" : "Enable host firewall rules."
                                    },
                                    "nosmurfs" : {
                                       "optional" : 1,
                                       "type" : "boolean",
                                       "description" : "Enable SMURFS filter."
                                    },
                                    "log_level_out" : {
                                       "type" : "string",
                                       "description" : "Log level for outgoing traffic.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1
                                    },
                                    "digest" : {
                                       "optional" : 1,
                                       "type" : "string",
                                       "maxLength" : 40,
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications."
                                    },
                                    "tcp_flags_log_level" : {
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "description" : "Log level for illegal tcp flags filter.",
                                       "type" : "string"
                                    },
                                    "tcpflags" : {
                                       "type" : "boolean",
                                       "description" : "Filter illegal combinations of TCP flags.",
                                       "optional" : 1
                                    },
                                    "delete" : {
                                       "type" : "string",
                                       "description" : "A list of settings you want to delete.",
                                       "optional" : 1,
                                       "format" : "pve-configid-list"
                                    },
                                    "nf_conntrack_tcp_timeout_established" : {
                                       "description" : "Conntrack established timeout.",
                                       "type" : "integer",
                                       "minimum" : 7875,
                                       "optional" : 1
                                    },
                                    "smurf_log_level" : {
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string",
                                       "description" : "Log level for SMURFS filter."
                                    },
                                    "node" : {
                                       "type" : "string",
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node"
                                    },
                                    "nf_conntrack_max" : {
                                       "type" : "integer",
                                       "description" : "Maximum number of tracked connections.",
                                       "optional" : 1,
                                       "minimum" : 32768
                                    }
                                 },
                                 "additionalProperties" : 0
                              }
                           },
                           "GET" : {
                              "method" : "GET",
                              "description" : "Get host firewall options.",
                              "returns" : {
                                 "properties" : {
                                    "nf_conntrack_max" : {
                                       "type" : "integer",
                                       "description" : "Maximum number of tracked connections.",
                                       "minimum" : 32768,
                                       "optional" : 1
                                    },
                                    "smurf_log_level" : {
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "description" : "Log level for SMURFS filter.",
                                       "type" : "string"
                                    },
                                    "log_level_out" : {
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string",
                                       "description" : "Log level for outgoing traffic."
                                    },
                                    "tcp_flags_log_level" : {
                                       "type" : "string",
                                       "description" : "Log level for illegal tcp flags filter.",
                                       "optional" : 1,
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ]
                                    },
                                    "nosmurfs" : {
                                       "optional" : 1,
                                       "description" : "Enable SMURFS filter.",
                                       "type" : "boolean"
                                    },
                                    "log_level_in" : {
                                       "type" : "string",
                                       "description" : "Log level for incoming traffic.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1
                                    },
                                    "enable" : {
                                       "description" : "Enable host firewall rules.",
                                       "type" : "boolean",
                                       "optional" : 1
                                    },
                                    "nf_conntrack_tcp_timeout_established" : {
                                       "optional" : 1,
                                       "minimum" : 7875,
                                       "description" : "Conntrack established timeout.",
                                       "type" : "integer"
                                    },
                                    "tcpflags" : {
                                       "description" : "Filter illegal combinations of TCP flags.",
                                       "type" : "boolean",
                                       "optional" : 1
                                    }
                                 },
                                 "type" : "object"
                              },
                              "proxyto" : "node",
                              "name" : "get_options",
                              "parameters" : {
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    }
                                 },
                                 "additionalProperties" : 0
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              }
                           }
                        }
                     },
                     {
                        "info" : {
                           "GET" : {
                              "method" : "GET",
                              "description" : "Read firewall log",
                              "protected" : 1,
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Syslog"
                                    ]
                                 ]
                              },
                              "proxyto" : "node",
                              "name" : "log",
                              "returns" : {
                                 "items" : {
                                    "type" : "object",
                                    "properties" : {
                                       "n" : {
                                          "description" : "Line number",
                                          "type" : "integer"
                                       },
                                       "t" : {
                                          "type" : "string",
                                          "description" : "Line text"
                                       }
                                    }
                                 },
                                 "type" : "array"
                              },
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "type" : "string",
                                       "format" : "pve-node"
                                    },
                                    "start" : {
                                       "type" : "integer",
                                       "optional" : 1,
                                       "minimum" : 0
                                    },
                                    "limit" : {
                                       "type" : "integer",
                                       "minimum" : 0,
                                       "optional" : 1
                                    }
                                 }
                              }
                           }
                        },
                        "leaf" : 1,
                        "text" : "log",
                        "path" : "/nodes/{node}/firewall/log"
                     }
                  ]
               },
               {
                  "info" : {
                     "GET" : {
                        "method" : "GET",
                        "description" : "API version details",
                        "proxyto" : "node",
                        "name" : "version",
                        "returns" : {
                           "type" : "object",
                           "properties" : {
                              "repoid" : {
                                 "type" : "string"
                              },
                              "version" : {
                                 "type" : "string"
                              },
                              "release" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        }
                     }
                  },
                  "leaf" : 1,
                  "text" : "version",
                  "path" : "/nodes/{node}/version"
               },
               {
                  "info" : {
                     "GET" : {
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "object",
                           "properties" : {}
                        },
                        "name" : "status",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              }
                           }
                        },
                        "method" : "GET",
                        "description" : "Read node status"
                     },
                     "POST" : {
                        "returns" : {
                           "type" : "null"
                        },
                        "name" : "node_cmd",
                        "proxyto" : "node",
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.PowerMgmt"
                              ]
                           ]
                        },
                        "method" : "POST",
                        "description" : "Reboot or shutdown a node.",
                        "parameters" : {
                           "properties" : {
                              "command" : {
                                 "enum" : [
                                    "reboot",
                                    "shutdown"
                                 ],
                                 "description" : "Specify the command.",
                                 "type" : "string"
                              },
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              }
                           },
                           "additionalProperties" : 0
                        }
                     }
                  },
                  "leaf" : 1,
                  "text" : "status",
                  "path" : "/nodes/{node}/status"
               },
               {
                  "path" : "/nodes/{node}/netstat",
                  "leaf" : 1,
                  "text" : "netstat",
                  "info" : {
                     "GET" : {
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              }
                           }
                        },
                        "returns" : {
                           "type" : "array",
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           }
                        },
                        "name" : "netstat",
                        "proxyto" : "node",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "description" : "Read tap/vm network device interface counters",
                        "method" : "GET"
                     }
                  }
               },
               {
                  "info" : {
                     "POST" : {
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "properties" : {},
                           "type" : "array"
                        },
                        "name" : "execute",
                        "proxyto" : "node",
                        "method" : "POST",
                        "description" : "Execute multiple commands in order.",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              },
                              "commands" : {
                                 "type" : "string",
                                 "description" : "JSON encoded array of commands."
                              }
                           }
                        }
                     }
                  },
                  "path" : "/nodes/{node}/execute",
                  "leaf" : 1,
                  "text" : "execute"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read node RRD statistics (returns PNG)",
                        "method" : "GET",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "timeframe" : {
                                 "enum" : [
                                    "hour",
                                    "day",
                                    "week",
                                    "month",
                                    "year"
                                 ],
                                 "type" : "string",
                                 "description" : "Specify the time frame you are interested in."
                              },
                              "node" : {
                                 "format" : "pve-node",
                                 "type" : "string",
                                 "description" : "The cluster node name."
                              },
                              "cf" : {
                                 "type" : "string",
                                 "description" : "The RRD consolidation function",
                                 "enum" : [
                                    "AVERAGE",
                                    "MAX"
                                 ],
                                 "optional" : 1
                              },
                              "ds" : {
                                 "format" : "pve-configid-list",
                                 "type" : "string",
                                 "description" : "The list of datasources you want to display."
                              }
                           }
                        },
                        "name" : "rrd",
                        "returns" : {
                           "properties" : {
                              "filename" : {
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "protected" : 1
                     }
                  },
                  "leaf" : 1,
                  "text" : "rrd",
                  "path" : "/nodes/{node}/rrd"
               },
               {
                  "info" : {
                     "GET" : {
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "name" : "rrddata",
                        "returns" : {
                           "type" : "array",
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           }
                        },
                        "parameters" : {
                           "properties" : {
                              "timeframe" : {
                                 "type" : "string",
                                 "description" : "Specify the time frame you are interested in.",
                                 "enum" : [
                                    "hour",
                                    "day",
                                    "week",
                                    "month",
                                    "year"
                                 ]
                              },
                              "node" : {
                                 "format" : "pve-node",
                                 "description" : "The cluster node name.",
                                 "type" : "string"
                              },
                              "cf" : {
                                 "type" : "string",
                                 "description" : "The RRD consolidation function",
                                 "optional" : 1,
                                 "enum" : [
                                    "AVERAGE",
                                    "MAX"
                                 ]
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "method" : "GET",
                        "description" : "Read node RRD statistics"
                     }
                  },
                  "leaf" : 1,
                  "text" : "rrddata",
                  "path" : "/nodes/{node}/rrddata"
               },
               {
                  "text" : "syslog",
                  "leaf" : 1,
                  "path" : "/nodes/{node}/syslog",
                  "info" : {
                     "GET" : {
                        "description" : "Read system log",
                        "method" : "GET",
                        "name" : "syslog",
                        "returns" : {
                           "type" : "array",
                           "items" : {
                              "properties" : {
                                 "n" : {
                                    "type" : "integer",
                                    "description" : "Line number"
                                 },
                                 "t" : {
                                    "description" : "Line text",
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           }
                        },
                        "proxyto" : "node",
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Syslog"
                              ]
                           ]
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "limit" : {
                                 "type" : "integer",
                                 "optional" : 1,
                                 "minimum" : 0
                              },
                              "start" : {
                                 "type" : "integer",
                                 "minimum" : 0,
                                 "optional" : 1
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              }
                           }
                        }
                     }
                  }
               },
               {
                  "info" : {
                     "POST" : {
                        "method" : "POST",
                        "description" : "Creates a VNC Shell proxy.",
                        "returns" : {
                           "properties" : {
                              "cert" : {
                                 "type" : "string"
                              },
                              "user" : {
                                 "type" : "string"
                              },
                              "port" : {
                                 "type" : "integer"
                              },
                              "upid" : {
                                 "type" : "string"
                              },
                              "ticket" : {
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "name" : "vncshell",
                        "parameters" : {
                           "properties" : {
                              "upgrade" : {
                                 "default" : 0,
                                 "optional" : 1,
                                 "description" : "Run 'apt-get dist-upgrade' instead of normal shell.",
                                 "type" : "boolean"
                              },
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              },
                              "websocket" : {
                                 "optional" : 1,
                                 "description" : "use websocket instead of standard vnc.",
                                 "type" : "boolean"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "protected" : 1,
                        "permissions" : {
                           "description" : "Restricted to users on realm 'pam'",
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Console"
                              ]
                           ]
                        }
                     }
                  },
                  "leaf" : 1,
                  "text" : "vncshell",
                  "path" : "/nodes/{node}/vncshell"
               },
               {
                  "path" : "/nodes/{node}/vncwebsocket",
                  "text" : "vncwebsocket",
                  "leaf" : 1,
                  "info" : {
                     "GET" : {
                        "description" : "Opens a weksocket for VNC traffic.",
                        "method" : "GET",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "vncticket" : {
                                 "type" : "string",
                                 "description" : "Ticket from previous call to vncproxy.",
                                 "maxLength" : 512
                              },
                              "port" : {
                                 "minimum" : 5900,
                                 "maximum" : 5999,
                                 "type" : "integer",
                                 "description" : "Port number returned by previous vncproxy call."
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              }
                           }
                        },
                        "returns" : {
                           "type" : "object",
                           "properties" : {
                              "port" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "name" : "vncwebsocket",
                        "permissions" : {
                           "description" : "Restricted to users on realm 'pam'. You also need to pass a valid ticket (vncticket).",
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Console"
                              ]
                           ]
                        }
                     }
                  }
               },
               {
                  "path" : "/nodes/{node}/spiceshell",
                  "leaf" : 1,
                  "text" : "spiceshell",
                  "info" : {
                     "POST" : {
                        "description" : "Creates a SPICE shell.",
                        "method" : "POST",
                        "protected" : 1,
                        "permissions" : {
                           "description" : "Restricted to users on realm 'pam'",
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Console"
                              ]
                           ]
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "properties" : {
                              "tls-port" : {
                                 "type" : "integer"
                              },
                              "host" : {
                                 "type" : "string"
                              },
                              "type" : {
                                 "type" : "string"
                              },
                              "proxy" : {
                                 "type" : "string"
                              },
                              "password" : {
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 1,
                           "description" : "Returned values can be directly passed to the 'remote-viewer' application."
                        },
                        "name" : "spiceshell",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              },
                              "upgrade" : {
                                 "default" : 0,
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Run 'apt-get dist-upgrade' instead of normal shell."
                              },
                              "proxy" : {
                                 "description" : "SPICE proxy server. This can be used by the client to specify the proxy server. All nodes in a cluster runs 'spiceproxy', so it is up to the client to choose one. By default, we return the node where the VM is currently running. As resonable setting is to use same node you use to connect to the API (This is window.location.hostname for the JS GUI).",
                                 "type" : "string",
                                 "optional" : 1,
                                 "format" : "address"
                              }
                           }
                        }
                     }
                  }
               },
               {
                  "path" : "/nodes/{node}/dns",
                  "leaf" : 1,
                  "text" : "dns",
                  "info" : {
                     "PUT" : {
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              },
                              "search" : {
                                 "description" : "Search domain for host-name lookup.",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "name" : "update_dns",
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "description" : "Write DNS settings.",
                        "method" : "PUT"
                     },
                     "GET" : {
                        "method" : "GET",
                        "description" : "Read DNS settings.",
                        "proxyto" : "node",
                        "name" : "dns",
                        "returns" : {
                           "properties" : {
                              "dns3" : {
                                 "type" : "string",
                                 "description" : "Third name server IP address.",
                                 "optional" : 1
                              },
                              "dns1" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "First name server IP address."
                              },
                              "search" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Search domain for host-name lookup."
                              },
                              "dns2" : {
                                 "description" : "Second name server IP address.",
                                 "type" : "string",
                                 "optional" : 1
                              }
                           },
                           "type" : "object",
                           "additionalProperties" : 0
                        },
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "type" : "string",
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        }
                     }
                  }
               },
               {
                  "path" : "/nodes/{node}/time",
                  "leaf" : 1,
                  "text" : "time",
                  "info" : {
                     "PUT" : {
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "timezone" : {
                                 "type" : "string",
                                 "description" : "Time zone. The file '/usr/share/zoneinfo/zone.tab' contains the list of valid names."
                              },
                              "node" : {
                                 "format" : "pve-node",
                                 "description" : "The cluster node name.",
                                 "type" : "string"
                              }
                           }
                        },
                        "method" : "PUT",
                        "description" : "Set time zone.",
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        },
                        "name" : "set_timezone",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1
                     },
                     "GET" : {
                        "description" : "Read server time and time zone settings.",
                        "method" : "GET",
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "format" : "pve-node",
                                 "description" : "The cluster node name.",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "returns" : {
                           "type" : "object",
                           "additionalProperties" : 0,
                           "properties" : {
                              "time" : {
                                 "type" : "integer",
                                 "description" : "Seconds since 1970-01-01 00:00:00 UTC.",
                                 "minimum" : 1297163644
                              },
                              "localtime" : {
                                 "minimum" : 1297163644,
                                 "type" : "integer",
                                 "description" : "Seconds since 1970-01-01 00:00:00 (local time)"
                              },
                              "timezone" : {
                                 "description" : "Time zone",
                                 "type" : "string"
                              }
                           }
                        },
                        "name" : "time",
                        "proxyto" : "node",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        }
                     }
                  }
               },
               {
                  "info" : {
                     "GET" : {
                        "method" : "GET",
                        "description" : "Get list of appliances.",
                        "permissions" : {
                           "user" : "all"
                        },
                        "name" : "aplinfo",
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "type" : "object",
                              "properties" : {}
                           },
                           "type" : "array"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "format" : "pve-node",
                                 "type" : "string",
                                 "description" : "The cluster node name."
                              }
                           }
                        }
                     },
                     "POST" : {
                        "method" : "POST",
                        "description" : "Download appliance templates.",
                        "name" : "apl_download",
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/storage/{storage}",
                              [
                                 "Datastore.AllocateTemplate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "parameters" : {
                           "properties" : {
                              "storage" : {
                                 "type" : "string",
                                 "description" : "The storage identifier.",
                                 "format" : "pve-storage-id"
                              },
                              "node" : {
                                 "format" : "pve-node",
                                 "description" : "The cluster node name.",
                                 "type" : "string"
                              },
                              "template" : {
                                 "type" : "string",
                                 "maxLength" : 255
                              }
                           },
                           "additionalProperties" : 0
                        }
                     }
                  },
                  "leaf" : 1,
                  "text" : "aplinfo",
                  "path" : "/nodes/{node}/aplinfo"
               },
               {
                  "info" : {
                     "POST" : {
                        "method" : "POST",
                        "description" : "Start all VMs and containers (when onboot=1).",
                        "returns" : {
                           "type" : "string"
                        },
                        "proxyto" : "node",
                        "name" : "startall",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "format" : "pve-node",
                                 "type" : "string",
                                 "description" : "The cluster node name."
                              },
                              "force" : {
                                 "optional" : 1,
                                 "description" : "force if onboot=0.",
                                 "type" : "boolean"
                              }
                           }
                        },
                        "protected" : 1
                     }
                  },
                  "path" : "/nodes/{node}/startall",
                  "text" : "startall",
                  "leaf" : 1
               },
               {
                  "text" : "stopall",
                  "leaf" : 1,
                  "path" : "/nodes/{node}/stopall",
                  "info" : {
                     "POST" : {
                        "description" : "Stop all VMs and Containers.",
                        "method" : "POST",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "type" : "string",
                                 "format" : "pve-node"
                              }
                           }
                        },
                        "name" : "stopall",
                        "returns" : {
                           "type" : "string"
                        },
                        "proxyto" : "node",
                        "protected" : 1
                     }
                  }
               },
               {
                  "info" : {
                     "POST" : {
                        "parameters" : {
                           "properties" : {
                              "node" : {
                                 "format" : "pve-node",
                                 "type" : "string",
                                 "description" : "The cluster node name."
                              },
                              "target" : {
                                 "format" : "pve-node",
                                 "type" : "string",
                                 "description" : "Target node."
                              },
                              "maxworkers" : {
                                 "type" : "integer",
                                 "description" : "Max parralel migration job.",
                                 "minimum" : 1
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "name" : "migrateall",
                        "returns" : {
                           "type" : "string"
                        },
                        "proxyto" : "node",
                        "protected" : 1,
                        "description" : "Migrate all VMs and Containers.",
                        "method" : "POST"
                     }
                  },
                  "text" : "migrateall",
                  "leaf" : 1,
                  "path" : "/nodes/{node}/migrateall"
               }
            ],
            "path" : "/nodes/{node}",
            "text" : "{node}",
            "leaf" : 0,
            "info" : {
               "GET" : {
                  "description" : "Node index.",
                  "method" : "GET",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "node" : {
                           "description" : "The cluster node name.",
                           "type" : "string",
                           "format" : "pve-node"
                        }
                     }
                  },
                  "name" : "index",
                  "returns" : {
                     "type" : "array",
                     "items" : {
                        "properties" : {},
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{name}",
                           "rel" : "child"
                        }
                     ]
                  },
                  "permissions" : {
                     "user" : "all"
                  }
               }
            }
         }
      ]
   },
   {
      "children" : [
         {
            "info" : {
               "GET" : {
                  "description" : "Read storage configuration.",
                  "method" : "GET",
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/storage/{storage}",
                        [
                           "Datastore.Allocate"
                        ]
                     ]
                  },
                  "parameters" : {
                     "properties" : {
                        "storage" : {
                           "description" : "The storage identifier.",
                           "type" : "string",
                           "format" : "pve-storage-id"
                        }
                     },
                     "additionalProperties" : 0
                  },
                  "returns" : {},
                  "name" : "read"
               },
               "PUT" : {
                  "protected" : 1,
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/storage",
                        [
                           "Datastore.Allocate"
                        ]
                     ]
                  },
                  "parameters" : {
                     "properties" : {
                        "saferemove_throughput" : {
                           "optional" : 1,
                           "description" : "Wipe throughput (cstream -t parameter value).",
                           "type" : "string"
                        },
                        "disable" : {
                           "optional" : 1,
                           "description" : "Flag to disable the storage.",
                           "type" : "boolean"
                        },
                        "options" : {
                           "description" : "NFS mount options (see 'man nfs')",
                           "type" : "string",
                           "optional" : 1,
                           "format" : "pve-storage-options"
                        },
                        "nowritecache" : {
                           "type" : "boolean",
                           "description" : "disable write caching on the target",
                           "optional" : 1
                        },
                        "server" : {
                           "optional" : 1,
                           "format" : "pve-storage-server",
                           "description" : "Server IP or DNS name.",
                           "type" : "string"
                        },
                        "delete" : {
                           "type" : "string",
                           "description" : "A list of settings you want to delete.",
                           "maxLength" : 4096,
                           "optional" : 1,
                           "format" : "pve-configid-list"
                        },
                        "blocksize" : {
                           "type" : "string",
                           "description" : "block size",
                           "optional" : 1
                        },
                        "format" : {
                           "format" : "pve-storage-format",
                           "optional" : 1,
                           "type" : "string",
                           "description" : "Default Image format."
                        },
                        "shared" : {
                           "description" : "Mark storage as shared.",
                           "type" : "boolean",
                           "optional" : 1
                        },
                        "content" : {
                           "type" : "string",
                           "description" : "Allowed content types. Note: value 'rootdir' is used for Containers, and value 'images' for KVM-Qemu VM's.\n",
                           "format" : "pve-storage-content-list",
                           "optional" : 1
                        },
                        "transport" : {
                           "enum" : [
                              "tcp",
                              "rdma",
                              "unix"
                           ],
                           "optional" : 1,
                           "type" : "string",
                           "description" : "Gluster transport: tcp or rdma"
                        },
                        "username" : {
                           "optional" : 1,
                           "type" : "string",
                           "description" : "RBD Id."
                        },
                        "sparse" : {
                           "optional" : 1,
                           "description" : "use sparse volumes",
                           "type" : "boolean"
                        },
                        "comstar_hg" : {
                           "type" : "string",
                           "description" : "host group for comstar views",
                           "optional" : 1
                        },
                        "redundancy" : {
                           "optional" : 1,
                           "maximum" : 16,
                           "default" : 2,
                           "minimum" : 1,
                           "description" : "The redundancy count specifies the number of nodes to which the resource should be deployed. It must be at least 1 and at most the number of nodes in the cluster.",
                           "type" : "integer"
                        },
                        "pool" : {
                           "optional" : 1,
                           "type" : "string",
                           "description" : "Pool."
                        },
                        "maxfiles" : {
                           "minimum" : 0,
                           "optional" : 1,
                           "description" : "Maximal number of backup files per VM. Use '0' for unlimted.",
                           "type" : "integer"
                        },
                        "comstar_tg" : {
                           "description" : "target group for comstar views",
                           "type" : "string",
                           "optional" : 1
                        },
                        "storage" : {
                           "format" : "pve-storage-id",
                           "description" : "The storage identifier.",
                           "type" : "string"
                        },
                        "nodes" : {
                           "optional" : 1,
                           "format" : "pve-node-list",
                           "type" : "string",
                           "description" : "List of cluster node names."
                        },
                        "saferemove" : {
                           "optional" : 1,
                           "description" : "Zero-out data when removing LVs.",
                           "type" : "boolean"
                        },
                        "krbd" : {
                           "optional" : 1,
                           "description" : "Access rbd through krbd kernel module.",
                           "type" : "boolean"
                        },
                        "digest" : {
                           "type" : "string",
                           "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                           "maxLength" : 40,
                           "optional" : 1
                        }
                     },
                     "additionalProperties" : 0,
                     "type" : "object"
                  },
                  "returns" : {
                     "type" : "null"
                  },
                  "name" : "update",
                  "description" : "Update storage configuration.",
                  "method" : "PUT"
               },
               "DELETE" : {
                  "name" : "delete",
                  "returns" : {
                     "type" : "null"
                  },
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "storage" : {
                           "format" : "pve-storage-id",
                           "type" : "string",
                           "description" : "The storage identifier."
                        }
                     }
                  },
                  "protected" : 1,
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/storage",
                        [
                           "Datastore.Allocate"
                        ]
                     ]
                  },
                  "method" : "DELETE",
                  "description" : "Delete storage configuration."
               }
            },
            "leaf" : 1,
            "text" : "{storage}",
            "path" : "/storage/{storage}"
         }
      ],
      "info" : {
         "POST" : {
            "protected" : 1,
            "permissions" : {
               "check" : [
                  "perm",
                  "/storage",
                  [
                     "Datastore.Allocate"
                  ]
               ]
            },
            "parameters" : {
               "additionalProperties" : 0,
               "type" : "object",
               "properties" : {
                  "maxfiles" : {
                     "minimum" : 0,
                     "optional" : 1,
                     "description" : "Maximal number of backup files per VM. Use '0' for unlimted.",
                     "type" : "integer"
                  },
                  "authsupported" : {
                     "optional" : 1,
                     "type" : "string",
                     "description" : "Authsupported."
                  },
                  "krbd" : {
                     "description" : "Access rbd through krbd kernel module.",
                     "type" : "boolean",
                     "optional" : 1
                  },
                  "portal" : {
                     "type" : "string",
                     "description" : "iSCSI portal (IP or DNS name with optional port).",
                     "optional" : 1,
                     "format" : "pve-storage-portal-dns"
                  },
                  "monhost" : {
                     "optional" : 1,
                     "description" : "Monitors daemon ips.",
                     "type" : "string"
                  },
                  "volume" : {
                     "type" : "string",
                     "description" : "Glusterfs Volume.",
                     "optional" : 1
                  },
                  "transport" : {
                     "enum" : [
                        "tcp",
                        "rdma",
                        "unix"
                     ],
                     "optional" : 1,
                     "type" : "string",
                     "description" : "Gluster transport: tcp or rdma"
                  },
                  "path" : {
                     "format" : "pve-storage-path",
                     "optional" : 1,
                     "description" : "File system path.",
                     "type" : "string"
                  },
                  "comstar_hg" : {
                     "type" : "string",
                     "description" : "host group for comstar views",
                     "optional" : 1
                  },
                  "base" : {
                     "optional" : 1,
                     "format" : "pve-volume-id",
                     "type" : "string",
                     "description" : "Base volume. This volume is automatically activated."
                  },
                  "sparse" : {
                     "optional" : 1,
                     "description" : "use sparse volumes",
                     "type" : "boolean"
                  },
                  "redundancy" : {
                     "maximum" : 16,
                     "optional" : 1,
                     "default" : 2,
                     "minimum" : 1,
                     "description" : "The redundancy count specifies the number of nodes to which the resource should be deployed. It must be at least 1 and at most the number of nodes in the cluster.",
                     "type" : "integer"
                  },
                  "server" : {
                     "optional" : 1,
                     "format" : "pve-storage-server",
                     "description" : "Server IP or DNS name.",
                     "type" : "string"
                  },
                  "blocksize" : {
                     "type" : "string",
                     "description" : "block size",
                     "optional" : 1
                  },
                  "nowritecache" : {
                     "description" : "disable write caching on the target",
                     "type" : "boolean",
                     "optional" : 1
                  },
                  "pool" : {
                     "optional" : 1,
                     "description" : "Pool.",
                     "type" : "string"
                  },
                  "comstar_tg" : {
                     "type" : "string",
                     "description" : "target group for comstar views",
                     "optional" : 1
                  },
                  "storage" : {
                     "format" : "pve-storage-id",
                     "description" : "The storage identifier.",
                     "type" : "string"
                  },
                  "saferemove" : {
                     "optional" : 1,
                     "description" : "Zero-out data when removing LVs.",
                     "type" : "boolean"
                  },
                  "nodes" : {
                     "optional" : 1,
                     "format" : "pve-node-list",
                     "description" : "List of cluster node names.",
                     "type" : "string"
                  },
                  "shared" : {
                     "optional" : 1,
                     "description" : "Mark storage as shared.",
                     "type" : "boolean"
                  },
                  "content" : {
                     "format" : "pve-storage-content-list",
                     "optional" : 1,
                     "description" : "Allowed content types. Note: value 'rootdir' is used for Containers, and value 'images' for KVM-Qemu VM's.\n",
                     "type" : "string"
                  },
                  "format" : {
                     "format" : "pve-storage-format",
                     "optional" : 1,
                     "description" : "Default Image format.",
                     "type" : "string"
                  },
                  "username" : {
                     "type" : "string",
                     "description" : "RBD Id.",
                     "optional" : 1
                  },
                  "iscsiprovider" : {
                     "optional" : 1,
                     "description" : "iscsi provider",
                     "type" : "string"
                  },
                  "type" : {
                     "enum" : [
                        "glusterfs",
                        "rbd",
                        "dir",
                        "iscsidirect",
                        "zfspool",
                        "sheepdog",
                        "iscsi",
                        "nfs",
                        "drbd",
                        "lvm",
                        "zfs"
                     ],
                     "type" : "string",
                     "description" : "Storage type."
                  },
                  "export" : {
                     "optional" : 1,
                     "format" : "pve-storage-path",
                     "type" : "string",
                     "description" : "NFS export path."
                  },
                  "saferemove_throughput" : {
                     "description" : "Wipe throughput (cstream -t parameter value).",
                     "type" : "string",
                     "optional" : 1
                  },
                  "disable" : {
                     "description" : "Flag to disable the storage.",
                     "type" : "boolean",
                     "optional" : 1
                  },
                  "options" : {
                     "type" : "string",
                     "description" : "NFS mount options (see 'man nfs')",
                     "optional" : 1,
                     "format" : "pve-storage-options"
                  },
                  "target" : {
                     "optional" : 1,
                     "description" : "iSCSI target.",
                     "type" : "string"
                  },
                  "vgname" : {
                     "description" : "Volume group name.",
                     "type" : "string",
                     "optional" : 1,
                     "format" : "pve-storage-vgname"
                  }
               }
            },
            "returns" : {
               "type" : "null"
            },
            "name" : "create",
            "description" : "Create a new storage.",
            "method" : "POST"
         },
         "GET" : {
            "description" : "Storage index.",
            "method" : "GET",
            "permissions" : {
               "description" : "Only list entries where you have 'Datastore.Audit' or 'Datastore.AllocateSpace' permissions on '/storage/<storage>'",
               "user" : "all"
            },
            "parameters" : {
               "properties" : {
                  "type" : {
                     "type" : "string",
                     "description" : "Only list storage of specific type",
                     "optional" : 1,
                     "enum" : [
                        "glusterfs",
                        "rbd",
                        "dir",
                        "iscsidirect",
                        "zfspool",
                        "sheepdog",
                        "iscsi",
                        "nfs",
                        "drbd",
                        "lvm",
                        "zfs"
                     ]
                  }
               },
               "additionalProperties" : 0
            },
            "returns" : {
               "links" : [
                  {
                     "href" : "{storage}",
                     "rel" : "child"
                  }
               ],
               "type" : "array",
               "items" : {
                  "properties" : {
                     "storage" : {
                        "type" : "string"
                     }
                  },
                  "type" : "object"
               }
            },
            "name" : "index"
         }
      },
      "text" : "storage",
      "leaf" : 0,
      "path" : "/storage"
   },
   {
      "info" : {
         "GET" : {
            "returns" : {
               "links" : [
                  {
                     "rel" : "child",
                     "href" : "{subdir}"
                  }
               ],
               "items" : {
                  "properties" : {
                     "subdir" : {
                        "type" : "string"
                     }
                  },
                  "type" : "object"
               },
               "type" : "array"
            },
            "name" : "index",
            "parameters" : {
               "additionalProperties" : 0
            },
            "permissions" : {
               "user" : "all"
            },
            "method" : "GET",
            "description" : "Directory index."
         }
      },
      "path" : "/access",
      "leaf" : 0,
      "text" : "access",
      "children" : [
         {
            "children" : [
               {
                  "info" : {
                     "PUT" : {
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "userid-group",
                              [
                                 "User.Modify"
                              ],
                              "groups_param",
                              1
                           ]
                        },
                        "name" : "update_user",
                        "returns" : {
                           "type" : "null"
                        },
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "lastname" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "email" : {
                                 "type" : "string",
                                 "optional" : 1,
                                 "format" : "email-opt"
                              },
                              "expire" : {
                                 "type" : "integer",
                                 "description" : "Account expiration date (seconds since epoch). '0' means no expiration date.",
                                 "minimum" : 0,
                                 "optional" : 1
                              },
                              "append" : {
                                 "requires" : "groups",
                                 "type" : "boolean",
                                 "optional" : 1
                              },
                              "keys" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Keys for two factor auth (yubico)."
                              },
                              "userid" : {
                                 "type" : "string",
                                 "maxLength" : 64,
                                 "description" : "User ID",
                                 "format" : "pve-userid"
                              },
                              "groups" : {
                                 "type" : "string",
                                 "format" : "pve-groupid-list",
                                 "optional" : 1
                              },
                              "firstname" : {
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "enable" : {
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Enable/disable the account."
                              }
                           }
                        },
                        "method" : "PUT",
                        "description" : "Update user configuration."
                     },
                     "GET" : {
                        "permissions" : {
                           "check" : [
                              "userid-group",
                              [
                                 "User.Modify",
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "parameters" : {
                           "properties" : {
                              "userid" : {
                                 "type" : "string",
                                 "description" : "User ID",
                                 "maxLength" : 64,
                                 "format" : "pve-userid"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "returns" : {
                           "properties" : {
                              "keys" : {
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "enable" : {
                                 "type" : "boolean"
                              },
                              "firstname" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "groups" : {
                                 "type" : "array"
                              },
                              "comment" : {
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "lastname" : {
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "expire" : {
                                 "optional" : 1,
                                 "type" : "integer"
                              },
                              "email" : {
                                 "type" : "string",
                                 "optional" : 1
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "name" : "read_user",
                        "description" : "Get user configuration.",
                        "method" : "GET"
                     },
                     "DELETE" : {
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "userid" : {
                                 "type" : "string",
                                 "maxLength" : 64,
                                 "description" : "User ID",
                                 "format" : "pve-userid"
                              }
                           }
                        },
                        "returns" : {
                           "type" : "null"
                        },
                        "name" : "delete_user",
                        "permissions" : {
                           "check" : [
                              "and",
                              [
                                 "userid-param",
                                 "Realm.AllocateUser"
                              ],
                              [
                                 "userid-group",
                                 [
                                    "User.Modify"
                                 ]
                              ]
                           ]
                        },
                        "protected" : 1,
                        "description" : "Delete user.",
                        "method" : "DELETE"
                     }
                  },
                  "leaf" : 1,
                  "text" : "{userid}",
                  "path" : "/access/users/{userid}"
               }
            ],
            "text" : "users",
            "leaf" : 0,
            "path" : "/access/users",
            "info" : {
               "GET" : {
                  "method" : "GET",
                  "description" : "User index.",
                  "permissions" : {
                     "description" : "The returned list is restricted to users where you have 'User.Modify' or 'Sys.Audit' permissions on '/access/groups' or on a group the user belongs too. But it always includes the current (authenticated) user.",
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "type" : "object",
                        "properties" : {
                           "userid" : {
                              "type" : "string"
                           }
                        }
                     },
                     "type" : "array",
                     "links" : [
                        {
                           "href" : "{userid}",
                           "rel" : "child"
                        }
                     ]
                  },
                  "name" : "index",
                  "parameters" : {
                     "properties" : {
                        "enabled" : {
                           "description" : "Optional filter for enable property.",
                           "type" : "boolean",
                           "optional" : 1
                        }
                     },
                     "additionalProperties" : 0
                  }
               },
               "POST" : {
                  "parameters" : {
                     "properties" : {
                        "password" : {
                           "maxLength" : 64,
                           "description" : "Initial password.",
                           "type" : "string",
                           "minLength" : 5,
                           "optional" : 1
                        },
                        "comment" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "lastname" : {
                           "type" : "string",
                           "optional" : 1
                        },
                        "email" : {
                           "type" : "string",
                           "optional" : 1,
                           "format" : "email-opt"
                        },
                        "expire" : {
                           "description" : "Account expiration date (seconds since epoch). '0' means no expiration date.",
                           "type" : "integer",
                           "minimum" : 0,
                           "optional" : 1
                        },
                        "keys" : {
                           "optional" : 1,
                           "description" : "Keys for two factor auth (yubico).",
                           "type" : "string"
                        },
                        "userid" : {
                           "maxLength" : 64,
                           "description" : "User ID",
                           "type" : "string",
                           "format" : "pve-userid"
                        },
                        "enable" : {
                           "description" : "Enable the account (default). You can set this to '0' to disable the accout",
                           "type" : "boolean",
                           "optional" : 1,
                           "default" : 1
                        },
                        "firstname" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "groups" : {
                           "type" : "string",
                           "optional" : 1,
                           "format" : "pve-groupid-list"
                        }
                     },
                     "additionalProperties" : 0
                  },
                  "returns" : {
                     "type" : "null"
                  },
                  "name" : "create_user",
                  "permissions" : {
                     "check" : [
                        "and",
                        [
                           "userid-param",
                           "Realm.AllocateUser"
                        ],
                        [
                           "userid-group",
                           [
                              "User.Modify"
                           ],
                           "groups_param",
                           1
                        ]
                     ],
                     "description" : "You need 'Realm.AllocateUser' on '/access/realm/<realm>' on the realm of user <userid>, and 'User.Modify' permissions to '/access/groups/<group>' for any group specified (or 'User.Modify' on '/access/groups' if you pass no groups."
                  },
                  "protected" : 1,
                  "description" : "Create new user.",
                  "method" : "POST"
               }
            }
         },
         {
            "info" : {
               "GET" : {
                  "name" : "index",
                  "returns" : {
                     "links" : [
                        {
                           "href" : "{groupid}",
                           "rel" : "child"
                        }
                     ],
                     "items" : {
                        "type" : "object",
                        "properties" : {
                           "groupid" : {
                              "type" : "string"
                           }
                        }
                     },
                     "type" : "array"
                  },
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "user" : "all",
                     "description" : "The returned list is restricted to groups where you have 'User.Modify', 'Sys.Audit'  or 'Group.Allocate' permissions on /access/groups/<group>."
                  },
                  "method" : "GET",
                  "description" : "Group index."
               },
               "POST" : {
                  "protected" : 1,
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/access/groups",
                        [
                           "Group.Allocate"
                        ]
                     ]
                  },
                  "returns" : {
                     "type" : "null"
                  },
                  "name" : "create_group",
                  "parameters" : {
                     "properties" : {
                        "comment" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "groupid" : {
                           "type" : "string",
                           "format" : "pve-groupid"
                        }
                     },
                     "additionalProperties" : 0
                  },
                  "method" : "POST",
                  "description" : "Create new group."
               }
            },
            "path" : "/access/groups",
            "text" : "groups",
            "leaf" : 0,
            "children" : [
               {
                  "info" : {
                     "GET" : {
                        "method" : "GET",
                        "description" : "Get group configuration.",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/groups",
                              [
                                 "Sys.Audit",
                                 "Group.Allocate"
                              ],
                              "any",
                              1
                           ]
                        },
                        "returns" : {
                           "type" : "object",
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "members" : {
                                 "items" : {
                                    "type" : "string"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "name" : "read_group",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "groupid" : {
                                 "type" : "string",
                                 "format" : "pve-groupid"
                              }
                           }
                        }
                     },
                     "PUT" : {
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "groupid" : {
                                 "type" : "string",
                                 "format" : "pve-groupid"
                              },
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "returns" : {
                           "type" : "null"
                        },
                        "name" : "update_group",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/groups",
                              [
                                 "Group.Allocate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "description" : "Update group data.",
                        "method" : "PUT"
                     },
                     "DELETE" : {
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/groups",
                              [
                                 "Group.Allocate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        },
                        "name" : "delete_group",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "groupid" : {
                                 "format" : "pve-groupid",
                                 "type" : "string"
                              }
                           }
                        },
                        "method" : "DELETE",
                        "description" : "Delete group."
                     }
                  },
                  "path" : "/access/groups/{groupid}",
                  "text" : "{groupid}",
                  "leaf" : 1
               }
            ]
         },
         {
            "children" : [
               {
                  "path" : "/access/roles/{roleid}",
                  "leaf" : 1,
                  "text" : "{roleid}",
                  "info" : {
                     "GET" : {
                        "name" : "read_role",
                        "returns" : {},
                        "parameters" : {
                           "properties" : {
                              "roleid" : {
                                 "format" : "pve-roleid",
                                 "type" : "string"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "method" : "GET",
                        "description" : "Get role configuration."
                     },
                     "PUT" : {
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        },
                        "name" : "update_role",
                        "parameters" : {
                           "properties" : {
                              "append" : {
                                 "type" : "boolean",
                                 "requires" : "privs",
                                 "optional" : 1
                              },
                              "roleid" : {
                                 "type" : "string",
                                 "format" : "pve-roleid"
                              },
                              "privs" : {
                                 "type" : "string",
                                 "format" : "pve-priv-list"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "method" : "PUT",
                        "description" : "Create new role."
                     },
                     "DELETE" : {
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "roleid" : {
                                 "format" : "pve-roleid",
                                 "type" : "string"
                              }
                           }
                        },
                        "name" : "delete_role",
                        "returns" : {
                           "type" : "null"
                        },
                        "description" : "Delete role.",
                        "method" : "DELETE"
                     }
                  }
               }
            ],
            "path" : "/access/roles",
            "leaf" : 0,
            "text" : "roles",
            "info" : {
               "POST" : {
                  "parameters" : {
                     "properties" : {
                        "privs" : {
                           "format" : "pve-priv-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "roleid" : {
                           "format" : "pve-roleid",
                           "type" : "string"
                        }
                     },
                     "additionalProperties" : 0
                  },
                  "returns" : {
                     "type" : "null"
                  },
                  "name" : "create_role",
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/access",
                        [
                           "Sys.Modify"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "description" : "Create new role.",
                  "method" : "POST"
               },
               "GET" : {
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "links" : [
                        {
                           "rel" : "child",
                           "href" : "{roleid}"
                        }
                     ],
                     "items" : {
                        "properties" : {
                           "roleid" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "type" : "array"
                  },
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "method" : "GET",
                  "description" : "Role index."
               }
            }
         },
         {
            "info" : {
               "PUT" : {
                  "name" : "update_acl",
                  "returns" : {
                     "type" : "null"
                  },
                  "parameters" : {
                     "properties" : {
                        "roles" : {
                           "format" : "pve-roleid-list",
                           "description" : "List of roles.",
                           "type" : "string"
                        },
                        "path" : {
                           "description" : "Access control path",
                           "type" : "string"
                        },
                        "propagate" : {
                           "default" : 1,
                           "optional" : 1,
                           "type" : "boolean",
                           "description" : "Allow to propagate (inherit) permissions."
                        },
                        "delete" : {
                           "description" : "Remove permissions (instead of adding it).",
                           "type" : "boolean",
                           "optional" : 1
                        },
                        "users" : {
                           "description" : "List of users.",
                           "type" : "string",
                           "format" : "pve-userid-list",
                           "optional" : 1
                        },
                        "groups" : {
                           "format" : "pve-groupid-list",
                           "optional" : 1,
                           "type" : "string",
                           "description" : "List of groups."
                        }
                     },
                     "additionalProperties" : 0
                  },
                  "protected" : 1,
                  "permissions" : {
                     "check" : [
                        "perm-modify",
                        "{path}"
                     ]
                  },
                  "method" : "PUT",
                  "description" : "Update Access Control List (add or remove permissions)."
               },
               "GET" : {
                  "permissions" : {
                     "user" : "all",
                     "description" : "The returned list is restricted to objects where you have rights to modify permissions."
                  },
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "name" : "read_acl",
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "propagate" : {
                              "type" : "boolean"
                           },
                           "roleid" : {
                              "type" : "string"
                           },
                           "path" : {
                              "type" : "string"
                           },
                           "type" : {
                              "enum" : [
                                 "user",
                                 "group"
                              ],
                              "type" : "string"
                           },
                           "ugid" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object",
                        "additionalProperties" : 0
                     },
                     "type" : "array"
                  },
                  "description" : "Get Access Control List (ACLs).",
                  "method" : "GET"
               }
            },
            "text" : "acl",
            "leaf" : 1,
            "path" : "/access/acl"
         },
         {
            "text" : "domains",
            "leaf" : 0,
            "path" : "/access/domains",
            "info" : {
               "GET" : {
                  "method" : "GET",
                  "description" : "Authentication domain index.",
                  "name" : "index",
                  "returns" : {
                     "type" : "array",
                     "items" : {
                        "properties" : {
                           "tfa" : {
                              "description" : "Two-factor authentication provider.",
                              "type" : "string",
                              "enum" : [
                                 "yubico",
                                 "oath"
                              ],
                              "optional" : 1
                           },
                           "comment" : {
                              "type" : "string",
                              "optional" : 1
                           },
                           "realm" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{realm}",
                           "rel" : "child"
                        }
                     ]
                  },
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "description" : "Anyone can access that, because we need that list for the login box (before the user is authenticated).",
                     "user" : "world"
                  }
               },
               "POST" : {
                  "method" : "POST",
                  "description" : "Add an authentication server.",
                  "returns" : {
                     "type" : "null"
                  },
                  "name" : "create",
                  "parameters" : {
                     "properties" : {
                        "secure" : {
                           "description" : "Use secure LDAPS protocol.",
                           "type" : "boolean",
                           "optional" : 1
                        },
                        "base_dn" : {
                           "optional" : 1,
                           "pattern" : "\\w+=[^,]+(,\\s*\\w+=[^,]+)*",
                           "type" : "string",
                           "description" : "LDAP base domain name",
                           "maxLength" : 256
                        },
                        "tfa" : {
                           "maxLength" : 128,
                           "description" : "Use Two-factor authentication.",
                           "type" : "string",
                           "optional" : 1,
                           "format" : "pve-tfa-config"
                        },
                        "port" : {
                           "type" : "integer",
                           "description" : "Server port.",
                           "minimum" : 1,
                           "maximum" : 65535,
                           "optional" : 1
                        },
                        "comment" : {
                           "optional" : 1,
                           "type" : "string",
                           "description" : "Description.",
                           "maxLength" : 4096
                        },
                        "realm" : {
                           "type" : "string",
                           "maxLength" : 32,
                           "description" : "Authentication domain ID",
                           "format" : "pve-realm"
                        },
                        "default" : {
                           "description" : "Use this as default realm",
                           "type" : "boolean",
                           "optional" : 1
                        },
                        "user_attr" : {
                           "maxLength" : 256,
                           "description" : "LDAP user attribute name",
                           "type" : "string",
                           "pattern" : "\\S{2,}",
                           "optional" : 1
                        },
                        "type" : {
                           "description" : "Realm type.",
                           "type" : "string",
                           "enum" : [
                              "pam",
                              "ldap",
                              "pve",
                              "ad"
                           ]
                        },
                        "domain" : {
                           "optional" : 1,
                           "maxLength" : 256,
                           "description" : "AD domain name",
                           "type" : "string",
                           "pattern" : "\\S+"
                        }
                     },
                     "additionalProperties" : 0,
                     "type" : "object"
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/access/realm",
                        [
                           "Realm.Allocate"
                        ]
                     ]
                  },
                  "protected" : 1
               }
            },
            "children" : [
               {
                  "path" : "/access/domains/{realm}",
                  "leaf" : 1,
                  "text" : "{realm}",
                  "info" : {
                     "PUT" : {
                        "description" : "Update authentication server settings.",
                        "method" : "PUT",
                        "protected" : 1,
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/realm",
                              [
                                 "Realm.Allocate"
                              ]
                           ]
                        },
                        "parameters" : {
                           "properties" : {
                              "user_attr" : {
                                 "optional" : 1,
                                 "type" : "string",
                                 "pattern" : "\\S{2,}",
                                 "maxLength" : 256,
                                 "description" : "LDAP user attribute name"
                              },
                              "domain" : {
                                 "description" : "AD domain name",
                                 "maxLength" : 256,
                                 "pattern" : "\\S+",
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "port" : {
                                 "type" : "integer",
                                 "description" : "Server port.",
                                 "minimum" : 1,
                                 "maximum" : 65535,
                                 "optional" : 1
                              },
                              "realm" : {
                                 "description" : "Authentication domain ID",
                                 "maxLength" : 32,
                                 "type" : "string",
                                 "format" : "pve-realm"
                              },
                              "comment" : {
                                 "description" : "Description.",
                                 "maxLength" : 4096,
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "default" : {
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Use this as default realm"
                              },
                              "digest" : {
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "type" : "string",
                                 "optional" : 1
                              },
                              "tfa" : {
                                 "format" : "pve-tfa-config",
                                 "optional" : 1,
                                 "type" : "string",
                                 "description" : "Use Two-factor authentication.",
                                 "maxLength" : 128
                              },
                              "delete" : {
                                 "format" : "pve-configid-list",
                                 "optional" : 1,
                                 "maxLength" : 4096,
                                 "description" : "A list of settings you want to delete.",
                                 "type" : "string"
                              },
                              "base_dn" : {
                                 "pattern" : "\\w+=[^,]+(,\\s*\\w+=[^,]+)*",
                                 "type" : "string",
                                 "description" : "LDAP base domain name",
                                 "maxLength" : 256,
                                 "optional" : 1
                              },
                              "secure" : {
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "description" : "Use secure LDAPS protocol."
                              }
                           },
                           "type" : "object",
                           "additionalProperties" : 0
                        },
                        "name" : "update",
                        "returns" : {
                           "type" : "null"
                        }
                     },
                     "GET" : {
                        "method" : "GET",
                        "description" : "Get auth server configuration.",
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/realm",
                              [
                                 "Realm.Allocate",
                                 "Sys.Audit"
                              ],
                              "any",
                              1
                           ]
                        },
                        "name" : "read",
                        "returns" : {},
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "realm" : {
                                 "maxLength" : 32,
                                 "description" : "Authentication domain ID",
                                 "type" : "string",
                                 "format" : "pve-realm"
                              }
                           }
                        }
                     },
                     "DELETE" : {
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/realm",
                              [
                                 "Realm.Allocate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "name" : "delete",
                        "returns" : {
                           "type" : "null"
                        },
                        "parameters" : {
                           "properties" : {
                              "realm" : {
                                 "type" : "string",
                                 "maxLength" : 32,
                                 "description" : "Authentication domain ID",
                                 "format" : "pve-realm"
                              }
                           },
                           "additionalProperties" : 0
                        },
                        "method" : "DELETE",
                        "description" : "Delete an authentication server."
                     }
                  }
               }
            ]
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Dummy. Useful for formaters which want to priovde a login page.",
                  "method" : "GET",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "name" : "get_ticket",
                  "returns" : {
                     "type" : "null"
                  },
                  "permissions" : {
                     "user" : "world"
                  }
               },
               "POST" : {
                  "permissions" : {
                     "user" : "world",
                     "description" : "You need to pass valid credientials."
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "object",
                     "properties" : {
                        "username" : {
                           "type" : "string"
                        },
                        "ticket" : {
                           "type" : "string",
                           "optional" : 1
                        },
                        "CSRFPreventionToken" : {
                           "type" : "string",
                           "optional" : 1
                        }
                     }
                  },
                  "name" : "create_ticket",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "privs" : {
                           "maxLength" : 64,
                           "requires" : "path",
                           "description" : "Verify ticket, and check if user have access 'privs' on 'path'",
                           "type" : "string",
                           "format" : "pve-priv-list",
                           "optional" : 1
                        },
                        "username" : {
                           "type" : "string",
                           "description" : "User name",
                           "maxLength" : 64
                        },
                        "otp" : {
                           "optional" : 1,
                           "type" : "string",
                           "description" : "One-time password for Two-factor authentication."
                        },
                        "password" : {
                           "type" : "string",
                           "description" : "The secret password. This can also be a valid ticket."
                        },
                        "realm" : {
                           "maxLength" : 32,
                           "description" : "You can optionally pass the realm using this parameter. Normally the realm is simply added to the username <username>@<relam>.",
                           "type" : "string",
                           "format" : "pve-realm",
                           "optional" : 1
                        },
                        "path" : {
                           "type" : "string",
                           "maxLength" : 64,
                           "description" : "Verify ticket, and check if user have access 'privs' on 'path'",
                           "requires" : "privs",
                           "optional" : 1
                        }
                     }
                  },
                  "method" : "POST",
                  "description" : "Create or verify authentication ticket."
               }
            },
            "text" : "ticket",
            "leaf" : 1,
            "path" : "/access/ticket"
         },
         {
            "path" : "/access/password",
            "text" : "password",
            "leaf" : 1,
            "info" : {
               "PUT" : {
                  "description" : "Change user password.",
                  "method" : "PUT",
                  "permissions" : {
                     "check" : [
                        "or",
                        [
                           "userid-param",
                           "self"
                        ],
                        [
                           "and",
                           [
                              "userid-param",
                              "Realm.AllocateUser"
                           ],
                           [
                              "userid-group",
                              [
                                 "User.Modify"
                              ]
                           ]
                        ]
                     ],
                     "description" : "Each user is allowed to change his own password. A user can change the password of another user if he has 'Realm.AllocateUser' (on the realm of user <userid>) and 'User.Modify' permission on /access/groups/<group> on a group where user <userid> is member of."
                  },
                  "protected" : 1,
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "password" : {
                           "minLength" : 5,
                           "description" : "The new password.",
                           "maxLength" : 64,
                           "type" : "string"
                        },
                        "userid" : {
                           "type" : "string",
                           "maxLength" : 64,
                           "description" : "User ID",
                           "format" : "pve-userid"
                        }
                     }
                  },
                  "name" : "change_passsword",
                  "returns" : {
                     "type" : "null"
                  }
               }
            }
         }
      ]
   },
   {
      "info" : {
         "GET" : {
            "method" : "GET",
            "description" : "Pool index.",
            "permissions" : {
               "description" : "List all pools where you have Pool.Allocate or VM.Allocate permissions on /pool/<pool>.",
               "user" : "all"
            },
            "name" : "index",
            "returns" : {
               "links" : [
                  {
                     "rel" : "child",
                     "href" : "{poolid}"
                  }
               ],
               "type" : "array",
               "items" : {
                  "properties" : {
                     "poolid" : {
                        "type" : "string"
                     }
                  },
                  "type" : "object"
               }
            },
            "parameters" : {
               "additionalProperties" : 0
            }
         },
         "POST" : {
            "method" : "POST",
            "description" : "Create new pool.",
            "protected" : 1,
            "permissions" : {
               "check" : [
                  "perm",
                  "/pool/{poolid}",
                  [
                     "Pool.Allocate"
                  ]
               ]
            },
            "returns" : {
               "type" : "null"
            },
            "name" : "create_pool",
            "parameters" : {
               "additionalProperties" : 0,
               "properties" : {
                  "comment" : {
                     "optional" : 1,
                     "type" : "string"
                  },
                  "poolid" : {
                     "format" : "pve-poolid",
                     "type" : "string"
                  }
               }
            }
         }
      },
      "text" : "pools",
      "leaf" : 0,
      "path" : "/pools",
      "children" : [
         {
            "path" : "/pools/{poolid}",
            "text" : "{poolid}",
            "leaf" : 1,
            "info" : {
               "GET" : {
                  "description" : "Get pool configuration.",
                  "method" : "GET",
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/pool/{poolid}",
                        [
                           "Pool.Allocate"
                        ]
                     ]
                  },
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "poolid" : {
                           "type" : "string",
                           "format" : "pve-poolid"
                        }
                     }
                  },
                  "returns" : {
                     "properties" : {
                        "members" : {
                           "items" : {
                              "properties" : {
                                 "storage" : {
                                    "type" : "string",
                                    "optional" : 1
                                 },
                                 "node" : {
                                    "type" : "string"
                                 },
                                 "vmid" : {
                                    "type" : "integer",
                                    "optional" : 1
                                 },
                                 "type" : {
                                    "type" : "string",
                                    "enum" : [
                                       "qemu",
                                       "lxc",
                                       "openvz",
                                       "storage"
                                    ]
                                 },
                                 "id" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object",
                              "additionalProperties" : 1
                           },
                           "type" : "array"
                        },
                        "comment" : {
                           "type" : "string",
                           "optional" : 1
                        }
                     },
                     "type" : "object",
                     "additionalProperties" : 0
                  },
                  "name" : "read_pool"
               },
               "PUT" : {
                  "permissions" : {
                     "description" : "You also need the right to modify permissions on any object you add/delete.",
                     "check" : [
                        "perm",
                        "/pool/{poolid}",
                        [
                           "Pool.Allocate"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "name" : "update_pool",
                  "returns" : {
                     "type" : "null"
                  },
                  "parameters" : {
                     "properties" : {
                        "vms" : {
                           "description" : "List of virtual machines.",
                           "type" : "string",
                           "optional" : 1,
                           "format" : "pve-vmid-list"
                        },
                        "delete" : {
                           "optional" : 1,
                           "type" : "boolean",
                           "description" : "Remove vms/storage (instead of adding it)."
                        },
                        "poolid" : {
                           "format" : "pve-poolid",
                           "type" : "string"
                        },
                        "storage" : {
                           "type" : "string",
                           "description" : "List of storage IDs.",
                           "format" : "pve-storage-id-list",
                           "optional" : 1
                        },
                        "comment" : {
                           "type" : "string",
                           "optional" : 1
                        }
                     },
                     "additionalProperties" : 0
                  },
                  "method" : "PUT",
                  "description" : "Update pool data."
               },
               "DELETE" : {
                  "description" : "Delete pool.",
                  "method" : "DELETE",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "poolid" : {
                           "type" : "string",
                           "format" : "pve-poolid"
                        }
                     }
                  },
                  "returns" : {
                     "type" : "null"
                  },
                  "name" : "delete_pool",
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/pool/{poolid}",
                        [
                           "Pool.Allocate"
                        ]
                     ],
                     "description" : "You can only delete empty pools (no members)."
                  },
                  "protected" : 1
               }
            }
         }
      ]
   },
   {
      "info" : {
         "GET" : {
            "method" : "GET",
            "description" : "API version details. The result also includes the global datacenter confguration.",
            "name" : "version",
            "returns" : {
               "properties" : {
                  "repoid" : {
                     "type" : "string"
                  },
                  "release" : {
                     "type" : "string"
                  },
                  "version" : {
                     "type" : "string"
                  }
               },
               "type" : "object"
            },
            "parameters" : {
               "additionalProperties" : 0
            },
            "permissions" : {
               "user" : "all"
            }
         }
      },
      "text" : "version",
      "leaf" : 1,
      "path" : "/version"
   }
]
;

